package smail.filter;

public class DateCondition implements smail.filter.Condition {
    
    
    /** constant for type-declaration of the actual filter<br>
     * This constant is used for OlderDatefilter, which compares a given date
     * with the dates of the mails
     */
    public static final int OLDER  = 0;
    /** constant for type-declaration of the actual filter<br>
     * This constant is used for NewerDatefilter, which compares a given date
     * with the dates of the mails
     */
    public static final int NEWER  = 1;
    /** constant for type-declaration of the actual filter<br>
     * This constant is used for EqualsDatefilter, which compares a given date
     * with the dates of the mails
     */
    public static final int EQUALS = 2;
    
    /** the type of the DateCondition (see above) */
    private int type;

    /** the date is the date which is searched as the receiving-date*/
    private java.util.Date    date;
    
    /** constructs a new DateCondtion-object
     * @param date is the date which is searched as the receiving-date
     */
    public DateCondition (int type, java.util.Date date) throws NoSuchTypeException {
        if (type >= 0 && type <= 2)
            this.type = type;
        else throw new smail.filter.NoSuchTypeException();
        
        this.date   = date;
    }
           
    /** set the type of the DateCondition */
    public void setType (int type)  throws smail.filter.NoSuchTypeException{
        if (type >= 0 && type <= 2)
            this.type = type;
        else throw new smail.filter.NoSuchTypeException();
    }
    
    /** to get the type of the DateCondition */
    public int getType () { return this.type; }

    /** set the date of the condition */
    public void setDate (java.util.Date date) { this.date = date; }
    
    /** to get the date of the condition */
    public java.util.Date getDate() { return this.date ; }

    /** this Function tests, if the Condition is true or not */
    public boolean test(javax.mail.Message msg) {
        java.util.Date date;
        try { date = msg.getReceivedDate(); }
        catch (javax.mail.MessagingException e) {
            System.out.println("DateCondition :: MessagingException");
            return false;
        }
        
        switch (this.type) {
            case (smail.filter.DateCondition.OLDER) : return date.before(this.date);            
            case (smail.filter.DateCondition.NEWER) : return date.after(this.date);
            case (smail.filter.DateCondition.EQUALS): return date.equals(this.date);
        }
        return false; //Dead Code
    }
	
	public String getConditionType()
	{
		return "DATE";
	}
}

    
