package smail.filter;

public class SubjectCondition implements smail.filter.Condition {
    
    /** the keyword is the (Sub)String for which are searched in the subject*/
    private java.lang.String    keyword;
    
    /** constructs a new SubjectCondtion-object
     * @param keyword an String for which are searched in the subject
     */
    public SubjectCondition (java.lang.String keyword) {
        this.keyword    = keyword;
    }
           
    /** set the keyword of the condition */
    public void setKeyword (java.lang.String key) { this.keyword = key; }
    
    /** to get the keyword of the condition */
    public java.lang.String getKeyword() { return this.keyword ; }

    /** this Function tests, it the Condition are true or not */
    public boolean test(javax.mail.Message msg) {
        String subj;
        try { subj = msg.getSubject(); }
        catch (javax.mail.MessagingException e)
        {
            System.out.println("SubjectCondition :: MessagingException");
            return false;
        }
        if (subj.indexOf(this.keyword) != -1) return true;
        else return false;
    }    
	
	public String getConditionType()
	{
		return "SUBJECT" ;
	}
}
