package smail.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.color.*;
import javax.swing.border.*;
import java.util.*;

/**
 * used to add a new address to the addressbook
 *
 *
 */
public class AddAddress extends JPanel {
    private JFrame frame;
    private ResourceBundle resourceB = ResourceBundle.getBundle("smail/gui/lang");

    private String addButtonString = resourceB.getString("addButtonString_key");
    private String nameLabelString = resourceB.getString("nameLabelString_key");
    private String emailLabelString = resourceB.getString("emailLabelString_key");
    private String groupLabelString = resourceB.getString("groupLabelString_key");
    private String closeButtonString = resourceB.getString("closeButtonString_key");
    private String titleBorderString = resourceB.getString("titleBorderString_key");

    private JPanel mainPanel = new JPanel();
    private JPanel labelPanel = new JPanel();
    private JPanel textfieldPanel = new JPanel();
    
    private JPanel choosePanel = new JPanel();
    private JPanel buttonPanel = new JPanel();
    private JPanel downPanel = new JPanel();
    
    private JButton addButton = new JButton(addButtonString);
    private JButton closeButton = new JButton(closeButtonString);

    private JLabel nameLabel = new JLabel(nameLabelString);
    private JLabel emailLabel = new JLabel(emailLabelString);
    private JLabel groupLabel = new JLabel(groupLabelString);
    
    private JTextField nameTextField = new JTextField(20);
    private JTextField emailTextField = new JTextField(20);
    
    private JComboBox groupComboBox = new JComboBox();
    private Group currentGroup;
   
    private TitledBorder titleBorder;

    private AddAddress add;
    Image image = new ImageIcon(getClass().getResource("Images/icon16.png")).getImage();
   /**
   *
   * @param ab The Addressbook the address should be added to
   */ 
    AddAddress(final Addressbook ab) { 
	super();
       
	add = this;
	
        frame = new JFrame();
	frame.getContentPane().setLayout(new GridLayout(0,1));

	frame.getContentPane().add(mainPanel);
	
	mainPanel.setLayout(new BorderLayout());
	mainPanel.add(BorderLayout.CENTER, choosePanel);
	mainPanel.add(BorderLayout.SOUTH, downPanel);

	titleBorder = BorderFactory.createTitledBorder(titleBorderString);
	choosePanel.setBorder(titleBorder);
	choosePanel.setLayout(new BorderLayout());
	choosePanel.add(BorderLayout.WEST, labelPanel);
	choosePanel.add(BorderLayout.CENTER, textfieldPanel);
	
	downPanel.setLayout(new BorderLayout());
	downPanel.add(BorderLayout.EAST, buttonPanel);
	
	labelPanel.setLayout(new GridLayout(3,1));
	labelPanel.add(groupLabel);	
	labelPanel.add(nameLabel);
	labelPanel.add(emailLabel);
	
	textfieldPanel.setLayout(new GridLayout(3,1));
	textfieldPanel.add(groupComboBox);
	textfieldPanel.add(nameTextField);
	textfieldPanel.add(emailTextField);

	buttonPanel.setLayout(new GridLayout(1,2));
	buttonPanel.add(addButton);
	buttonPanel.add(closeButton);

	addButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		   
		    for (int i=0; i<ab.groupVector.size(); i++) {
			if (((ab.currentGroup).getName()).equals(((Group)ab.groupVector.elementAt(i)).getName())) {
			    ((Group)ab.groupVector.elementAt(i)).addAddress(new Address(nameTextField.getText(),
											emailTextField.getText()));
			    break;
			}
		    }
		    
		    ab.groupComboBox.setSelectedItem((ab.currentGroup).getName());
		    ab.frame.repaint();
		    frame.dispose();
		}});
	
	for (int i=0; i<ab.groupVector.size(); i++) {
	    groupComboBox.addItem(((Group)ab.groupVector.elementAt(i)).getName());
	}
	
	groupComboBox.setSelectedItem((String)(ab.currentGroup).getName());
	
	groupComboBox.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent ae) {
		    for (int i=0; i<ab.groupVector.size(); i++) {
			if (groupComboBox.getSelectedItem() == ((Group)ab.groupVector.elementAt(i)).getName()) {
			    ab.currentGroup = (Group)ab.groupVector.elementAt(i);
			    System.out.println("currentGroup: "+ab.currentGroup.getName());
			}
		    }	    
		}});
	
	closeButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    frame.dispose();
		}});
	
        frame.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    frame.dispose();
		}
	    });

        frame.pack();
        frame.show(); 
        frame.setIconImage(image);

    }
    /* end of construuctor */
}
/* end of class AddAddress */
