package smail.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.color.*;
import javax.swing.border.*;
import java.util.*;

/**
 * used to add a new group to the addressbook
 * 
 *
 */
public class AddGroup extends JPanel {
    private JFrame frame;
    private ResourceBundle resourceB = ResourceBundle.getBundle("smail/gui/lang");

    private String addGroupButtonString = resourceB.getString("addGroupButtonString_key");
    private String groupNameLabelString = resourceB.getString("groupNameLabelString_key");
    private String closeButtonString = resourceB.getString("closeButtonString_key");
    private String addNewGroupString = resourceB.getString("addNewGroupString_key");

    private JPanel mainPanel = new JPanel();

    private JPanel groupPanel = new JPanel();
    private JPanel buttonPanel = new JPanel();
    private JPanel downPanel = new JPanel();

    private JButton addGroupButton = new JButton(addGroupButtonString);
    private JButton closeButton = new JButton(closeButtonString);
    
    private JLabel groupNameLabel = new JLabel(groupNameLabelString);

    private JTextField groupTextField = new JTextField(20);
  
    private TitledBorder titleBorder;
    private AddGroup add;
    Image image = new ImageIcon(getClass().getResource("Images/icon16.png")).getImage();
   /**
   *
   * @param ab The Addressbook the group should be added to
   */ 
    AddGroup(final Addressbook ab) { 
	
	super();

        add = this;
	
        frame = new JFrame();
	frame.getContentPane().setLayout(new GridLayout(0,1));
	frame.getContentPane().add(mainPanel);
	
	mainPanel.setLayout(new BorderLayout());
	mainPanel.add(BorderLayout.CENTER, groupPanel);
	mainPanel.add(BorderLayout.SOUTH,downPanel);

	downPanel.setLayout(new BorderLayout());
	downPanel.add(BorderLayout.EAST,buttonPanel);

	titleBorder = BorderFactory.createTitledBorder(addNewGroupString);
	groupPanel.setBorder(titleBorder);
	groupPanel.setLayout(new BorderLayout());
	groupPanel.add(BorderLayout.WEST,groupNameLabel);
	groupPanel.add(BorderLayout.CENTER,groupTextField);

	buttonPanel.setLayout(new GridLayout(1,2));
	buttonPanel.add(addGroupButton);
	buttonPanel.add(closeButton);

	addGroupButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    Group group = new Group(groupTextField.getText());
		    ab.groupVector.addElement(group);
		    ab.groupComboBox.addItem(group.getName());
		    ab.currentGroup = group;
		    ab.groupComboBox.setSelectedItem(group.getName());
		    ab.listModel.update();
		    ab.frame.repaint();
		     
		    ab.addToMailButton.setEnabled(true);
		    ab.addToMailAsCcButton.setEnabled(true);
		    ab.addToMailAsBccButton.setEnabled(true);
		    ab.addNewButton.setEnabled(true);
		    ab.isEmpty = false;
		    frame.dispose();
		}});

	
	closeButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    frame.dispose();
		}});

        frame.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    frame.dispose();
		}
	    });

        frame.pack();
        frame.show();
        frame.setIconImage(image);

    } 
    /* end of construuctor */
}
/* end of class AddGroup */
