package smail.gui;



import java.util.*;

import javax.swing.*;

import java.awt.event.*;

import java.awt.*;

import javax.swing.event.*;

import javax.swing.border.*;

import java.io.*;



import smail.utils.*;

import smail.*;



/**

 * Addressbook

 * <BR>

 * In the address can the user mark an existing address, and add it to the to-,

 * cc-, or bcc-field in the existing editor.

 * If no editor is open, a new one is launched.

 * The addresses are ordered in groups, and consists of a name and an

 * emailadddress of the contact.

 * The user can add new groups and emailaddresses, and edit existing addresses.

 */

public class Addressbook extends JPanel {

    PropertiesManager propMan = PropertiesManager.getInstance() ;

      

    /* get the home directory of the user*/

    String home = PropertiesManager.get("smail.home") ;

    String osName = System.getProperty("os.name");



    boolean isEmpty = true;


    Image image = new ImageIcon(getClass().getResource("Images/icon16.png")).getImage();
    Vector groupVector = getAddressbook();

    

    /* used to hold all the groups of the Addressbook */

    /* needs to be saved when exit */

    //Vector groupVector = new Vector();



    /* the current Locale for the language independence of the addressbook */

    /* so far only English and German                                      */

    private ResourceBundle resourceB = ResourceBundle.getBundle("smail/gui/lang");



    /* get all the strings used in the GUI from the appropriate properties-file */

    private String title = resourceB.getString("title_key");

    private String addNewString =resourceB.getString("addNewString_key");

    private String addToMailString =resourceB.getString("addToMailString_key");

    private String addToMailAsCcString =resourceB.getString("addToMailAsCcString_key");

    private String addToMailAsBccString =resourceB.getString("addToMailAsBccString_key");

    private String addNewGroupString =resourceB.getString("addNewGroupString_key");

    private String closeString =resourceB.getString("closeString_key");

    private String groupString =resourceB.getString("groupString_key");

    private String contactInfoString =resourceB.getString("contactInfoString_key");

    private String nameSearchString =resourceB.getString("nameSearchString_key");

    private String addressNameLabelString =resourceB.getString("addressNameLabelString_key");

    private String addressEmailLabelString =resourceB.getString("addressEmailLabelString_key");

    private String updateButtonString =resourceB.getString("updateButtonString_key");

    private String removeButtonString = resourceB.getString("removeButtonString_key");



    private JPanel menyPanel = new JPanel();

    private JPanel mainPanel = new JPanel();

    private JPanel buttonPanel = new JPanel();

    private JPanel choosePanel = new JPanel();

    private JPanel controlPanel = new JPanel();

    private JPanel bodyPanel = new JPanel();

    private JPanel groupComboBoxPanel = new JPanel();

    private JPanel listPanel = new JPanel();

    private JPanel addressPanel = new JPanel();

    private JPanel addressPanel2 = new JPanel();

    private JPanel closePanel = new JPanel();

    private JPanel groupAddressPanel = new JPanel();

    private JPanel listNamePanel = new JPanel();

    private JPanel nameSearchPanel = new JPanel();

    private JPanel addressNamePanel = new JPanel();

    private JPanel addressEmailPanel = new JPanel();

    private JPanel addressButtonPanel = new JPanel();

    private JPanel addressButtonPanel2 = new JPanel();



    JButton addNewButton = new JButton(addNewString);

    JButton addToMailButton = new JButton(addToMailString);

    JButton addToMailAsCcButton = new JButton(addToMailAsCcString);   

    JButton addToMailAsBccButton = new JButton(addToMailAsBccString);

    private JButton closeButton = new JButton(closeString);

    private JButton updateAddressButton = new JButton(updateButtonString);

    private JButton addNewGroupButton = new JButton(addNewGroupString);

    private JButton removeAddressButton = new JButton(removeButtonString);



    private JLabel nameSearchLabel = new JLabel(nameSearchString);

    private JLabel addressNameLabel = new JLabel(addressNameLabelString);

    private JLabel addressEmailLabel = new JLabel(addressEmailLabelString);



    private JTextField nameSearchTextField = new JTextField();

    private JTextField addressNameTextField = new JTextField(40);

    private JTextField addressEmailTextField = new JTextField(40);



    JComboBox groupComboBox = new JComboBox();

    

    MyListModel listModel;

    private JList addressList;

    private JScrollPane scrollpane;

   

    private TitledBorder titleBorder = BorderFactory.createTitledBorder("Groups");



    /*

    private JMenuBar menuBar = new JMenuBar();

    private JMenu addressMenu = new JMenu("Address");

    private JMenuItem addressMenuItem1 = new JMenuItem("Address");

    private JMenu aboutMenu = new JMenu("About");

    */

    

    Group currentGroup;

    private Address currentAddress;



    JFrame frame = new JFrame(title);

    final Addressbook ab;

    private Fassade fassade = null;

    private EditorFrame editor = null;

    

   

    /** 

     * Constructor to use when the Addressbook is started from the main window

     *

     * @param fassade The Fassade, to get communicate with the rest of theprogram

     *

     */

    public Addressbook(final Fassade fassade) {

	

	/* just a test print out, will be removed later*/

	System.out.println("Addressbook started from main window");



	this.fassade = fassade;

	

	

	if (!isEmpty) {

	    for (int i=0; i<groupVector.size(); i++) {

		groupComboBox.addItem(((Group)groupVector.elementAt(i)).getName());

	    }

	    currentGroup = (Group)groupVector.elementAt(0);

	}

		

	listModel = new MyListModel();

	addressList = new JList(listModel);

	scrollpane = new JScrollPane(addressList);



	layoutComponents();



	/* place the components in the frame */

	ab = this;





	addNewButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    System.out.println("addNewButton was pressed");

		    AddAddress add = new AddAddress(ab);

		}});



	addNewGroupButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    System.out.println("addNewGroupButton was pressed");

		    AddGroup add = new AddGroup(ab);

		}});



	addressList.addListSelectionListener(new ListSelectionListener() {

		public void valueChanged(ListSelectionEvent e) {

		    if (e.getValueIsAdjusting())

			return;

		    JList theList = (JList)e.getSource();

		    if (theList.isSelectionEmpty()) {

			//do nothing

		    } else {

			int i = theList.getSelectedIndex();

			currentAddress = currentGroup.getAddressAt(i);

			addressNameTextField.setText(currentAddress.getName());

			addressEmailTextField.setText(currentAddress.getEmail());

		    }}});

	

	groupComboBox.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    Group group;

		    for (int i=0; i<groupVector.size(); i++) {

			group = (Group)groupVector.elementAt(i);

			if (groupComboBox.getSelectedItem().equals(group.getName())) {

			    currentGroup = group;

			    System.out.println("currentGroup: "+currentGroup.getName());

			    listModel.groupChanged();

			    titleBorder = BorderFactory.createTitledBorder(groupString+""+currentGroup.getName());

			    addressList.setBorder(titleBorder);

			    addressNameTextField.setText("");

			    addressEmailTextField.setText("");

			    addressList.clearSelection();

			}

		    }	    

		}

	    });



	nameSearchTextField.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    String name = nameSearchTextField.getText();

		    Vector vector = currentGroup.getNames();

		    

		    for (int i=0; i<currentGroup.getSize(); i++) {

			if (((String)vector.elementAt(i)).startsWith(name)) {

			    addressList.setSelectedIndex(i);

			    break;

			}

		    }



		}});



	closeButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    saveAddressbook();

		    frame.dispose();

		}});



	updateAddressButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    String name = addressNameTextField.getText();

		    String email = addressEmailTextField.getText();

		    int index = addressList.getSelectedIndex();

		    currentGroup.updateAddressAt(name,email,index);

		    listModel.update();

		}});



	

	removeAddressButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    addressNameTextField.setText("");

		    addressEmailTextField.setText("");

		    int index = addressList.getSelectedIndex();

		    currentGroup.removeAddressAt(index);

		    listModel.update();

		}});





	/* different depending on where the addressbook is started */

	

	addToMailButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    System.out.println("addToMailButton was pressed");

		    if (currentAddress != null) {

			if (editor != null) 

		      	  editor.addAddressTo(currentAddress);

		     	else {

		        	System.out.println("Editor Fenster ffnen");

         	    		editor = new EditorFrame(fassade,"","","bla.de"); /* <-- change the bla.de!! */

        	        	enableEvents(AWTEvent.WINDOW_EVENT_MASK);

        			editor.setVisible(true);

        			editor.addAddressTo(currentAddress);

        		}

        	  }

		}});

	

	addToMailAsCcButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    System.out.println("addToMailAsCcButton was pressed");

		    if (currentAddress != null) {

			if (editor != null) 

		      	  editor.addAddressCc(currentAddress);

		     	else {

		        	System.out.println("Editor Fenster ffnen");

         	    		editor = new EditorFrame(fassade,"","","bla.de"); /* <-- change the bla.de!! */

        	        	enableEvents(AWTEvent.WINDOW_EVENT_MASK);

        			editor.setVisible(true);

        			editor.addAddressCc(currentAddress);

        		}}

		}});

	

	addToMailAsBccButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    System.out.println("addToMailAsBccButton was pressed");

		    if (currentAddress != null) {

			if (editor != null) 

		      	  editor.addAddressBcc(currentAddress);

		     	else {

		        	System.out.println("Editor Fenster ffnen");

         	    		editor = new EditorFrame(fassade,"","","bla.de"); /* <-- change the bla.de!! */

        	        	enableEvents(AWTEvent.WINDOW_EVENT_MASK);

        			editor.setVisible(true);

        			editor.addAddressBcc(currentAddress);

        		}}

		}});



	if (isEmpty) {

	    addToMailButton.setEnabled(false);

	    addToMailAsCcButton.setEnabled(false);

	    addToMailAsBccButton.setEnabled(false);

	    addNewButton.setEnabled(false);

	}



	frame.pack();

	

	frame.addWindowListener(new WindowAdapter() {

		public void windowClosing(WindowEvent e) {

		    saveAddressbook();

		    frame.dispose();

		}

	    });

        frame.setVisible(true);

	frame.setIconImage(image);
    }

    /* end of constructor for the main window*/

    

    /** 

     * Constructor to use when the Addressbook is started from the Editor

     *

     * @param editor The EditorFrame the Addressbook is started from

     * @param fassade The Fassade, to get communicate with the rest of the program

     *

     */

    public Addressbook(final EditorFrame editor, Fassade fassade) {



	/* just a test print out, will be removed later*/

	System.out.println("Addressbook started from main window");



	this.fassade = fassade;

	this.editor = editor;

	



	if (!isEmpty) {

	    for (int i=0; i<groupVector.size(); i++) {

		groupComboBox.addItem(((Group)groupVector.elementAt(i)).getName());

	    }

	    currentGroup = (Group)groupVector.elementAt(0);

	}





	listModel = new MyListModel();

	addressList = new JList(listModel);

	scrollpane = new JScrollPane(addressList);



	layoutComponents();



	/* place the components in the frame */

	ab = this;





	addNewButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    System.out.println("addNewButton was pressed");

		    AddAddress add = new AddAddress(ab);

		}});



	addNewGroupButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    System.out.println("addNewGroupButton was pressed");

		    AddGroup add = new AddGroup(ab);

		}});



	addressList.addListSelectionListener(new ListSelectionListener() {

		public void valueChanged(ListSelectionEvent e) {

		    if (e.getValueIsAdjusting())

			return;

		    JList theList = (JList)e.getSource();

		    if (theList.isSelectionEmpty()) {

			//do nothing

		    } else {

			int i = theList.getSelectedIndex();

			currentAddress = currentGroup.getAddressAt(i);

			addressNameTextField.setText(currentAddress.getName());

			addressEmailTextField.setText(currentAddress.getEmail());

		    }}});

	

	groupComboBox.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    Group group;

		    for (int i=0; i<groupVector.size(); i++) {

			group = (Group)groupVector.elementAt(i);

			if (groupComboBox.getSelectedItem().equals(group.getName())) {

			    currentGroup = group;

			    System.out.println("currentGroup: "+currentGroup.getName());

			    listModel.groupChanged();

			    titleBorder = BorderFactory.createTitledBorder(groupString+""+currentGroup.getName());

			    addressList.setBorder(titleBorder);

			    addressNameTextField.setText("");

			    addressEmailTextField.setText("");

			    addressList.clearSelection();

			}

		    }	    

		}

	    });



	nameSearchTextField.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    String name = nameSearchTextField.getText();

		    Vector vector = currentGroup.getNames();

		    

		    for (int i=0; i<currentGroup.getSize(); i++) {

			if (((String)vector.elementAt(i)).startsWith(name)) {

			    addressList.setSelectedIndex(i);

			    break;

			}

		    }



		}});



	closeButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    saveAddressbook();

		    frame.dispose();

		}});



	updateAddressButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    String name = addressNameTextField.getText();

		    String email = addressEmailTextField.getText();

		    int index = addressList.getSelectedIndex();

		    currentGroup.updateAddressAt(name,email,index);

		    listModel.update();

		}});



	

	removeAddressButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    addressNameTextField.setText("");

		    addressEmailTextField.setText("");

		    int index = addressList.getSelectedIndex();

		    currentGroup.removeAddressAt(index);

		    listModel.update();

		}});

	

	/* different depending on where the addressbook is started */

	addToMailButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    System.out.println("addToMailButton was pressed");

		    if (currentAddress != null)

			editor.addAddressTo(currentAddress);

		}});

	

	addToMailAsCcButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    System.out.println("addToMailAsCcButton was pressed");

		    if (currentAddress != null)

			editor.addAddressCc(currentAddress);

		}});

	

	addToMailAsBccButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent e) {

		    System.out.println("addToMailAsBccButton was pressed");

		    if (currentAddress != null) 

			editor.addAddressBcc(currentAddress);

		}});





	frame.pack();

	

	frame.addWindowListener(new WindowAdapter() {

		public void windowClosing(WindowEvent e) {

		    saveAddressbook();

		    frame.dispose();

		}

	    });

	

	if (isEmpty) {

	    addToMailButton.setEnabled(false);

	    addToMailAsCcButton.setEnabled(false);

	    addToMailAsBccButton.setEnabled(false);

	    addNewButton.setEnabled(false);

	}

	

	

	frame.setVisible(true);
        frame.setIconImage(image);
    }

    /* end of constructor for the Editor */

    

    /* ListModel class to handle the events from the addressList */

    class MyListModel extends AbstractListModel {

	public Vector vector = new Vector();//currentGroup.getNames();



	public void update() {

	    fireContentsChanged(this, 0, getSize());

	}



	public void groupChanged() {

	    vector.removeAllElements();

	    currentGroup.sort();

	    for (int i=0; i<currentGroup.getSize(); i++) {

		vector.addElement(currentGroup.getAddressNameAt(i));

	    }

	    update();

	    

	}

	

	public int getSize() {

	   if (!isEmpty)

	       return currentGroup.getSize();

	   else return 0;

	}



	public Object getElementAt(int index) {

	    if (!isEmpty)

		return (String) currentGroup.getAddressNameAt(index);

	    else return "";

	}

	

    } 

    /* end of class MyListModel */



    /* method to put all the compnents in the frame, defined separately because

it's used in several constructors */

    /* all the actionPerformed and other methods that are independent from where

the addressbook is started is here */



    void layoutComponents() {

	

	

	addressList.setPreferredSize(new Dimension(180, 180));

	addressList.setVisibleRowCount(6);

	

	addressList.setModel(listModel);

	addressList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);	



	

	frame.getContentPane().add(mainPanel);

	mainPanel.setLayout(new BorderLayout());	

	mainPanel.add(BorderLayout.NORTH, buttonPanel);

	mainPanel.add(BorderLayout.CENTER,bodyPanel);



	bodyPanel.setLayout(new BorderLayout());

	bodyPanel.add(BorderLayout.CENTER, choosePanel);

	bodyPanel.add(BorderLayout.SOUTH, closePanel);

	

	buttonPanel.setLayout(new GridLayout(1,5));

	buttonPanel.add(addToMailButton);

	buttonPanel.add(addToMailAsCcButton);

	buttonPanel.add(addToMailAsBccButton);

	buttonPanel.add(addNewButton);

	buttonPanel.add(addNewGroupButton);



	groupComboBoxPanel.setLayout(new BorderLayout());

	//groupComboBox.setBorder(titleBorder);

	groupComboBoxPanel.add(BorderLayout.CENTER, groupComboBox);

	groupComboBoxPanel.add(BorderLayout.NORTH, new JLabel(groupString));



	choosePanel.setLayout(new BorderLayout());

	choosePanel.add(BorderLayout.WEST, listNamePanel);

	choosePanel.add(BorderLayout.CENTER, groupAddressPanel);



	groupAddressPanel.setLayout(new BorderLayout());

	groupAddressPanel.add(BorderLayout.NORTH, groupComboBoxPanel);

	groupAddressPanel.add(BorderLayout.CENTER, addressPanel);

	

	listNamePanel.setLayout(new BorderLayout());

	listNamePanel.add(BorderLayout.NORTH, nameSearchPanel);

	listNamePanel.add(BorderLayout.CENTER, listPanel);



	nameSearchPanel.setLayout(new BorderLayout());

	nameSearchPanel.add(BorderLayout.WEST, nameSearchLabel);

	nameSearchPanel.add(BorderLayout.CENTER, nameSearchTextField);

	

	closePanel.setLayout(new BorderLayout());

	closePanel.add(BorderLayout.EAST,closeButton);



	if (currentGroup != null)

	    titleBorder = BorderFactory.createTitledBorder(groupString+" "+currentGroup.getName());

	else

	    titleBorder = BorderFactory.createTitledBorder(groupString+"");

	addressList.setBorder(titleBorder);

      	listPanel.add(addressList);	



	titleBorder = BorderFactory.createTitledBorder(contactInfoString);

	addressPanel.setBorder(titleBorder);

      	addressPanel.add(addressPanel2);

	

	addressPanel2.setLayout(new GridLayout(3,1));

	addressPanel2.add(addressNamePanel);

	addressPanel2.add(addressEmailPanel);

	addressPanel2.add(addressButtonPanel);



	addressNamePanel.setLayout(new BorderLayout());

	addressNamePanel.add(BorderLayout.CENTER, addressNameLabel);

	addressNamePanel.add(BorderLayout.EAST, addressNameTextField);



	addressEmailPanel.setLayout(new BorderLayout());

	addressEmailPanel.add(BorderLayout.CENTER, addressEmailLabel);

	addressEmailPanel.add(BorderLayout.EAST, addressEmailTextField);



	addressButtonPanel.setLayout(new BorderLayout());

	addressButtonPanel.add(BorderLayout.EAST, addressButtonPanel2);

	addressButtonPanel2.setLayout(new GridLayout(1,2));

	addressButtonPanel2.add(updateAddressButton);

	addressButtonPanel2.add(removeAddressButton);

    }

    

    /**

     * gets all the addresses and groups in the addressbook from a properties file

     *

     *

     *

     */

    private Vector getAddressbook() {

	

	Vector addressesV = new Vector();

	Vector groupVector = new Vector();

	String path = "";

	//String path = home+"\\addresses";

	String line = null;

	BufferedReader bufReader;

	FileReader in = null;

	String tmpGroup = null;

	String tmpName = null;

	String tmpEmail = null;

	boolean isOk = true;

	Group gr;

	File addrFile;

	int index;

	Address addr;

	int nrOfAddresses = 0;

	int count = 0;



	if (osName.startsWith("win"))

	    path = home+"\\addresses";

	else

	    path = home+"/addresses";

	//System.out.println("path:"+path);

	try {

	    in = new FileReader(path);

	}

	catch (FileNotFoundException e) {

	    addrFile = new File(path);

	    try {

	        in = new FileReader(path);//addrFile);

	    }

	    catch (FileNotFoundException e2) {

		System.out.println("addresses properties file was not found");	

		isEmpty = true;

		return addressesV;

	    }		

	    

	}

	bufReader = new BufferedReader(in);

	/*	

	  in the file are the addresses with the pattern:

	  group=GroupName1

	  name=Name blabla

	  email=bla@bla

	  group=GroupName2

	  name=Name blabla

	  email=bla@bla

	  group=GroupName1

	  name=Name blablabla

	  email=bla@bla.bla

	*/

	try {

	    line = bufReader.readLine();

	    //System.out.println("line:"+line);

	}

	catch (IOException e) {

	    System.out.println("error");

	    isOk = false;

	    return addressesV;

	}

	if (line == null)

	    isOk = false;

	

	while (isOk) {

	    if (line.startsWith("group=")) {

		tmpGroup = line.substring(6);

		if (!groupVector.contains(tmpGroup)) {

		    groupVector.add(tmpGroup);

		    addressesV.add(new Group(tmpGroup));

		}

	    }

	    if (line.startsWith("name=")) {

		tmpName = line.substring(5);

	    }

	    if (line.startsWith("email=")) {

		tmpEmail = line.substring(6);

		

		index = groupVector.indexOf(tmpGroup);

		

		((Group)addressesV.elementAt(index)).addAddress(new Address(tmpName,tmpEmail));

		isEmpty = false;

		//System.out.println("group="+tmpGroup);

		//System.out.println("name="+tmpName);

		//System.out.println("email="+tmpEmail);

	    }

	    try {

		line = bufReader.readLine();

	    }

	    catch (IOException e) {

		System.out.println("error");

		//isOk = false;

	    }   

	    if (line == null)

		isOk = false;

	    count++;

	} //end of while loop?

	

	

	System.out.println("addresses loaded from: "+path);

	return addressesV;

	

    }

    

    

    /**

     * Saves all the addresses and groups in the addressbook to a properties

file

     *

     *

     *

     */

    private void saveAddressbook() {

	String path = "";

	FileWriter out = null;

	String tmpGroup = null;

	String tmpName = null;

	String tmpEmail = null;

	

	String writeString = "";

	

	Group gr;

	Address addr;

	

	int numberOfAddr = 0;

		

	if (osName.startsWith("win"))

	    path = home+"\\addresses";

	else

	    path = home+"/addresses";

	System.out.println("path:"+path);

    	try {

	    out = new FileWriter(path);

	}

	catch (IOException e) {

		System.out.println("could'n write file");

	}

	

    

    	for (int i=0; i<groupVector.size(); i++) {

 		gr =  (Group)(groupVector.elementAt(i));		

    		numberOfAddr = gr.getSize();

    		tmpGroup = gr.getName(); 

    		for (int j=0; j<numberOfAddr; j++) {

    			addr = (Address)gr.getAddressAt(j);

    			tmpName = addr.getName();

    			tmpEmail = addr.getEmail();

    			writeString = writeString+"group="+tmpGroup+"\n"+"name="+tmpName+"\n"+"email="+tmpEmail+"\n";	

    		}

		if (numberOfAddr == 0) {

		  writeString = writeString+"group="+tmpGroup+"\n"+"name="+"\n"+"email="+"\n";

		}

    	}

    	try {

	    //System.out.println("writeString:  "+writeString+" ---end of writeString");

	    out.write(writeString);

	    out.close();

    	}

    	catch (IOException ioe3) {

	    System.out.println("error");

    	}

    	System.out.println("addresses saved to: "+path);

    }/* end of saveAddressbook() */

    

    

}

/* end of class Addressbook */



