// ErrorFrame.java

package smail.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


/** The ErrorFrame class displays a dialog window where the user can get an information
 * about things he has to do. It will close after he pressed the OK-button.
 * <br><br>
 * Since it is a modal dialog, when the application calls its show method to display the dialog, it
 * blocks the rest of the application until the user has cliqued on a button or closed this window. 
 */


public class ErrorFrame extends JDialog
{

    JPanel contentPane;
    JButton jButtonOk = new JButton();
    JLabel jLabelInfo = new JLabel();


    /**Creates a dialog window, that gives an information to the user*/
    public ErrorFrame()
    {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }
    
    /**Component initialization*/
    private void jbInit() throws Exception
    {
        setModal(true);

        this.setSize(new Dimension(220, 150));
        this.setResizable(false);

        jLabelInfo.setFont(new java.awt.Font("SansSerif", 0, 13));
        jLabelInfo.setBounds(new Rectangle(8, 13, 203, 28));

        jButtonOk.setText("OK");
        jButtonOk.setBounds(new Rectangle(37, 82, 131, 31));
        jButtonOk.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jButtonOk_actionPerformed(e);}});

        contentPane = (JPanel) this.getContentPane();
        contentPane.setLayout(null);
        contentPane.add(jLabelInfo, null);
        contentPane.add(jButtonOk, null);

        //Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = getSize();
        if (frameSize.height > screenSize.height)
        {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width)
        {
            frameSize.width = screenSize.width;
        }
        setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

    }


    /**Overridden so we can exit when window is closed*/
    protected void processWindowEvent(WindowEvent e)
    {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING)
        {
            dispose();
        }
    }

	// Button OK
	// closes the window
    void jButtonOk_actionPerformed(ActionEvent e)
    {
        dispose();
    }

}

