package smail.gui;

import java.util.*;
/**
 * used to hold the addresses in a particular group
 *
 */
class Group {
    private String name;
    private Vector addressVector = new Vector();
    private Vector nameVector = new Vector();
    private int groupsize;

    private Address[] tmpArray;  
    
    public Group(String name) {
	this.name = name;
	addressVector = new Vector();
	this.groupsize = 0;
    }
    
    public void addAddress(Address a) {
	(this.addressVector).addElement(a);
	(this.nameVector).addElement(a.getName());
	groupsize++;
    }
    
    public Address getAddressAt(int i) {
	return (Address)addressVector.elementAt(i);
    }
    
    public String getAddressNameAt(int i) {
	if (groupsize == 0)
	    return "";
	return (String)nameVector.elementAt(i);
    }

    public void updateAddressAt(String name, String email, int i) {
	Address address = (Address)addressVector.elementAt(i);
	address.setName(name);
	address.setEmail(email);
	nameVector.setElementAt(name,i);
	addressVector.setElementAt(address,i);
    }

    public void removeAddressAt(int i) {
	groupsize = groupsize - 1;
	nameVector.removeElementAt(i);
	addressVector.removeElementAt(i);
    }


    public int getSize() {
	return groupsize;
    }

    public Vector getNames() {
	return nameVector;
    }
   
    
    public String getName() {
	return name;   
    }

    public void sort() {
	tmpArray = new Address[groupsize];
	
	//move all the addresses to a tmpArray to manage the sorting easier
	for (int i=0; i<groupsize; i++) {
	    tmpArray[i] = (Address)addressVector.elementAt(i);
	}
	Arrays.sort(tmpArray,new MyComparator());

	
	//copy all elements back to the right position
	addressVector.removeAllElements();
	for (int i=0; i<groupsize; i++) {
	    addressVector.addElement(tmpArray[i]);
	}
	
	nameVector.removeAllElements();
	for (int i=0; i<groupsize; i++) {
	    nameVector.addElement((String)(((Address)(addressVector.elementAt(i)))).getName());
	}
    }
   
  
    /* inner class MyComparator to use in the sorting */
    class MyComparator implements Comparator {
	private char[] alphabet = {'a','b','c','d','e','f','g','h','i','j','k','l','m',
			   'n','o','p','q','r','s','t','u','','v','w','x','y','z','','',''};

	private int findPos(char c) {
	    int pos = -1;
	    for (int i=0; i<alphabet.length; i++) {
		if (alphabet[i] == c) {
		    pos = i;
		    break;
		}
	    }
	    return pos;
	}
	
	public int compare(Object o1, Object o2) {
	    return ((Address)o1).getName().compareTo(((Address)o2).getName());
	}
	
	public boolean equals(Object obj) {
	    //don't want to use this but have to implement it
	    return true;
	    
	}	
	
    } 
    /* end of class MyComparator */   
} 
/* end of class Group */    

