// InputFrame.java

package smail.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

/** The InputFrame class displays a dialog window where the user can set a new folder...
 */

public class InputFrame extends JDialog
{
  /** the information if the user has pressed the OK-button (true) or canceled (false)  */
  public boolean bInputStatus = false;


  /** the expression you want to find in the text */
  public String sInput = "";


  // property-File for chosing language (editor_lang_en for english, editor_lang_de for german)
  private ResourceBundle resource = ResourceBundle.getBundle("smail/gui/editor_lang");

  // getting the language specific textes for buttons, menus, etc from the property-file
  //private String title = resource.getString("titleFind_key");

  private String sButtonOK = resource.getString("buttonOk_key");
  private String sButtonCancel = resource.getString("buttonCancel_key");
  //private String sLabelFind = resource.getString("labelFind_key");


  JPanel contentPane;
  JLabel jLabel = new JLabel();
  JTextField jTextField = new JTextField();
  JButton jButtonOk = new JButton(sButtonOK);
  JButton jButtonCancel = new JButton(sButtonCancel);


  /**Creates a dialog window for finding a certain expression in the editor's textpane
  	* @param sFind the expression you want to find in the text
    */
  public InputFrame()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
    //jTextField.setText(sInput);
  }



  /**Component initialization*/
  private void jbInit() throws Exception
  {
    setModal(true);

    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(null);

    this.setTitle("new folder");
    this.setSize(new Dimension(300, 130));
    this.setResizable(false);


    jLabel.setText("Description");
    jLabel.setBounds(new Rectangle(15, 18, 100, 22));

    jTextField.setBackground(Color.white);
    jTextField.setEditable(true);
    jTextField.setBounds(new Rectangle(100, 18, 180, 22));
    jTextField.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jTextField_actionPerformed(e);}});

    //jButtonOk.setText("OK");
    jButtonOk.setBounds(new Rectangle(15, 64, 115, 27));
    jButtonOk.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jButtonOk_actionPerformed(e);}});

    //jButtonCancel.setText("Cancel");
    jButtonCancel.setBounds(new Rectangle(165, 64, 115, 27));
    jButtonCancel.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jButtonCancel_actionPerformed(e);}});

    contentPane.add(jLabel, null);
    contentPane.add(jTextField, null);
    contentPane.add(jButtonOk, null);
    contentPane.add(jButtonCancel, null);

    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = getSize();
    if (frameSize.height > screenSize.height)
    {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width)
    {
      frameSize.width = screenSize.width;
    }
    setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

  }


  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      // System.exit(0);
    }
  }


  // Button OK
  // gets the text to search from the textfield and sets it to the global variable sFind
  void jButtonOk_actionPerformed(ActionEvent e)
  {
  	bInputStatus = true;
    sInput = jTextField.getText();
    dispose();
  }


  // Button Cancel
  // closes the window without doing anything
  void jButtonCancel_actionPerformed(ActionEvent e)
  {
    dispose();
  }


  // by typing enter in the Textfiel find go to the OK Button
  void jTextField_actionPerformed(ActionEvent e)
  {
    jButtonOk.requestFocus();
  }
}



