package smail.gui;

import javax.swing.UIManager;
import java.awt.*;

public class Smail {
  smail.Fassade fassade;
  boolean packFrame = false;

  /**Construct the application*/
  public Smail(smail.Fassade fassade) {
    this.fassade = fassade;
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    SmailFrame frame = new SmailFrame(fassade);
    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2 -50);
    frame.setVisible(true);
  }
  /**Main method*/
  // public static void main(String[] args) {
  // new Smail();
  //}
}
