package smail.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.io.*;
import javax.swing.tree.*;
import java.lang.*;

import com.l2fprod.gui.plaf.skin.Skin;
import com.l2fprod.gui.plaf.skin.CompoundSkin;
import com.l2fprod.gui.plaf.skin.SkinLookAndFeel;

/** The SmailFrame class displays the main window of the Sm@il-Program.
 * <br><br>
 */

public class SmailFrame extends JFrame {
  JPanel contentPane, upperPane, lowerPane;
   smail.Fassade face;
  ProgressUploadFrame uploadFrame;
  ProgressDownloadFrame downloadFrame;

    // property-File for chosing language (editor_lang_en for english, editor_lang_de for german)
    private ResourceBundle resource = ResourceBundle.getBundle("smail/gui/smail_lang");

    // getting the language specific textes for buttons, menus, etc from the property-file
    private String title = resource.getString("titleSmail_key");

    private String sMenuSmail = resource.getString("menuSmail_key");
    private String sMenuSmailProperties = resource.getString("menuSmailProperties_key");
    private String sMenuSmailExit = resource.getString("menuSmailExit_key");

    private String sMenuAccount = resource.getString("menuAccount_key");
    private String sMenuAccountFetch = resource.getString("menuAccountFetch_key");
    private String sMenuAccountSend = resource.getString("menuAccountSend_key");
    private String sMenuAccountFetchSend = resource.getString("menuAccountFetchSend_key");
    //private String sMenuAccountFetchAll = resource.getString("menuAccountFetchAll_key");
    private String sMenuAccountCreate = resource.getString("menuAccountCreate_key");
    private String sMenuAccountDelete = resource.getString("menuAccountDelete_key");
    //private String sMenuAccountShowAccount = resource.getString("menuAccountShowAccount_key");
    //private String sMenuAccountShowAllAccounts = resource.getString("menuAccountShowAllAccounts_key");
    private String sMenuAccountFilters = resource.getString("menuAccountFilters_key");
    private String sMenuAccountProperties = resource.getString("menuAccountProperties_key");

    private String sMenuFolder = resource.getString("menuFolder_key");
    //private String sMenuFolderNewRoot = resource.getString("menuFolderNewRoot_key");
    private String sMenuFolderNewChild = resource.getString("menuFolderNewChild_key");
    private String sMenuFolderDelete = resource.getString("menuFolderDelete_key");
    private String sMenuFolderRename = resource.getString("menuFolderRename_key");
    private String sMenuFolderProperties = resource.getString("menuFolderProperties_key");

    private String sMenuMessage = resource.getString("menuMessage_key");
    private String sMenuMessageNew = resource.getString("menuMessageNew_key");
    private String sMenuMessageReply = resource.getString("menuMessageReply_key");
    private String sMenuMessageReplyToAll = resource.getString("menuMessageReplyToAll_key");
    private String sMenuMessageInQuoting = resource.getString("menuMessageIncludingQuoting_key");
    private String sMenuMessageExQuoting = resource.getString("menuMessageExcludingQuoting_key");
    private String sMenuMessageForward = resource.getString("menuMessageForward_key");
    private String sMenuMessageRead = resource.getString("menuMessageRead_key");
    private String sMenuMessageSave = resource.getString("menuMessageSave_key");
    private String sMenuMessageAppend = resource.getString("menuMessageAppend_key");
    private String sMenuMessageMarkAsRead = resource.getString("menuMessageMarkAsRead_key");
    private String sMenuMessageMarkAsUnread = resource.getString("menuMessageMarkAsRead_key");
    private String sMenuMessageMove = resource.getString("menuMessageMove_key");
    private String sMenuMessageCopy = resource.getString("menuMessageCopy_key");
    //private String sMenuMessageSelectAll = resource.getString("menuMessageSelectAll_key");
    private String sMenuMessageDelete = resource.getString("menuMessageDelete_key");

    private String sMenuAddressbook = resource.getString("menuAddressbook_key");
    private String sMenuAddressbookAdd = resource.getString("menuAddressbookAdd_key");
    private String sMenuAddressbookOpen = resource.getString("menuAddressbookOpen_key");

    private String sMenuSkins = resource.getString("menuSkins_key");
    private String sMenuSkinsSelect = resource.getString("menuSkinsSelect_key");
    private String sMenuSkinsDefault = resource.getString("menuSkinsDefault_key");

    private String sMenuLanguage = resource.getString("menuLanguage_key");

    private String sMenuHelp = resource.getString("menuHelp_key");
    private String sMenuHelpAbout = resource.getString("menuHelpAbout_key");

    // Tooltips
    private String sTooltipFetch = resource.getString("tooltipFetch_key");
    private String sTooltipSend = resource.getString("tooltipSend_key");
    private String sTooltipFetchSend = resource.getString("tooltipFetchSend_key");
    private String sTooltipNew = resource.getString("tooltipNew_key");
    private String sTooltipReply = resource.getString("tooltipReply_key");
    private String sTooltipForward = resource.getString("tooltipForward_key");
    private String sTooltipMove = resource.getString("tooltipMove_key");
    private String sTooltipCopy = resource.getString("tooltipCopy_key");
    private String sTooltipDelete = resource.getString("tooltipDelete_key");
    private String sTooltipAddressbook = resource.getString("tooltipAddressbook_key");
    private String sTooltipHelp = resource.getString("tooltipHelp_key");

    private String sTableDate = resource.getString("labelDate_key");
    private String sTableFrom = resource.getString("labelFrom_key");
    private String sTableSubject = resource.getString("labelSubject_key");


    // Menu
    JMenuBar jMenuBar1 = new JMenuBar();

    // Smail
    JMenu jMenuSmail = new JMenu(sMenuSmail);
    JMenuItem jMenuSmailProperties = new JMenuItem(sMenuSmailProperties);
    JMenuItem jMenuSmailExit = new JMenuItem(sMenuSmailExit);

    // Account
    JMenu jMenuAccount = new JMenu(sMenuAccount);
    JMenuItem jMenuAccountFetch = new JMenuItem(sMenuAccountFetch);
    JMenuItem jMenuAccountSend = new JMenuItem(sMenuAccountSend);
    JMenuItem jMenuAccountFetchSend = new JMenuItem(sMenuAccountFetchSend);
    //JMenuItem jMenuAccountFetchAll = new JMenuItem(sMenuAccountFetchAll);
    JMenuItem jMenuAccountCreate = new JMenuItem(sMenuAccountCreate);
    JMenuItem jMenuAccountDelete = new JMenuItem(sMenuAccountDelete);
    //JMenuItem jMenuAccountShowAccount = new JMenuItem(sMenuAccountShowAccount);
    //JMenuItem jMenuAccountShowAllAccounts = new JMenuItem(sMenuAccountShowAllAccounts);
    JMenuItem jMenuAccountFilters = new JMenuItem(sMenuAccountFilters);
    JMenuItem jMenuAccountProperties = new JMenuItem(sMenuAccountProperties);

    // Folder
    JMenu jMenuFolder = new JMenu(sMenuFolder);
    //JMenuItem jMenuFolderNewRoot = new JMenuItem(sMenuFolderNewRoot);
    JMenuItem jMenuFolderNewChild = new JMenuItem(sMenuFolderNewChild);
    JMenuItem jMenuFolderDelete = new JMenuItem(sMenuFolderDelete);
    JMenuItem jMenuFolderRename = new JMenuItem(sMenuFolderRename);
    JMenuItem jMenuFolderProperties = new JMenuItem(sMenuFolderProperties);

    // Message
    JMenu jMenuMessage = new JMenu(sMenuMessage);
    JMenuItem jMenuMessageNew = new JMenuItem(sMenuMessageNew);

    JMenu jMenuMessageReply = new JMenu(sMenuMessageReply);
      JMenuItem jMenuMessageReplyQuoting = new JMenuItem(sMenuMessageInQuoting);
      JMenuItem jMenuMessageReplyNoQuoting = new JMenuItem(sMenuMessageExQuoting);
    JMenu jMenuMessageReplyToAll = new JMenu(sMenuMessageReplyToAll);
      JMenuItem jMenuMessageReplyToAllQuoting = new JMenuItem(sMenuMessageInQuoting);
      JMenuItem jMenuMessageReplyToAllNoQuoting = new JMenuItem(sMenuMessageExQuoting);
    JMenuItem jMenuMessageForward = new JMenuItem(sMenuMessageForward);
    JMenuItem jMenuMessageRead = new JMenuItem(sMenuMessageRead);
    JMenuItem jMenuMessageSave = new JMenuItem(sMenuMessageSave);
    JMenuItem jMenuMessageAppend = new JMenuItem(sMenuMessageAppend);
    JMenuItem jMenuMessageMarkAsRead = new JMenuItem(sMenuMessageMarkAsRead);
    JMenuItem jMenuMessageMarkAsUnread = new JMenuItem(sMenuMessageMarkAsUnread);
    JMenuItem jMenuMessageMove = new JMenuItem(sMenuMessageMove);
    JMenuItem jMenuMessageCopy = new JMenuItem(sMenuMessageCopy);
    //JMenuItem jMenuMessageSelectAll = new JMenuItem(sMenuMessageSelectAll);
    JMenuItem jMenuMessageDelete = new JMenuItem(sMenuMessageDelete);

    // Addressbook
    JMenu jMenuAddressbook = new JMenu(sMenuAddressbook);
    JMenuItem jMenuAddressbookOpen = new JMenuItem(sMenuAddressbookOpen);
    JMenuItem jMenuAddressbookAddSenderToAddressbook = new JMenuItem(sMenuAddressbookAdd);

    // Skins
    JMenu jMenuSkins = new JMenu(sMenuSkins);
    JMenuItem jMenuSkinsSelect = new JMenuItem(sMenuSkinsSelect);
    JMenuItem jMenuSkinsDefault = new JMenuItem(sMenuSkinsDefault);

    // Language
    JMenu jMenuLanguage = new JMenu(sMenuLanguage);
    JMenuItem jMenuLanguageEnglish  = new JMenuItem("English");
    JMenuItem jMenuLanguageGerman  = new JMenuItem("Deutsch");
    JMenuItem jMenuLanguageSwedish  = new JMenuItem("Svenska");
    JMenuItem jMenuLanguageFrench  = new JMenuItem("Francais");
	JMenuItem jMenuLanguageSpanish  = new JMenuItem("Espanol");

    // Help
    JMenu jMenuHelp = new JMenu(sMenuHelp);
    JMenuItem jMenuHelpHelp  = new JMenuItem(sMenuHelp);
    JMenuItem jMenuHelpAbout  = new JMenuItem(sMenuHelpAbout);


    // Buttons
    JToolBar jToolBar1 = new JToolBar();
    JToolBar jToolBar2 = new JToolBar();
    JToolBar jToolBar3 = new JToolBar();
    JToolBar jToolBar4 = new JToolBar();

    JButton jButton1Fetch = new JButton();
    JButton jButton2Send = new JButton();
    JButton jButton3FetchSend = new JButton();

    JButton jButton4New = new JButton();
    JButton jButton5Reply = new JButton();
    JButton jButton6Forward = new JButton();

    JButton jButton7Move = new JButton();
    JButton jButton8Copy = new JButton();
    JButton jButton9Delete = new JButton();

    JButton jButton10Addressbook = new JButton();
    JButton jButton11Help = new JButton();


    // SplitPanes, Tabellen etc.
    JSplitPane jSplitPaneTreeTable = new JSplitPane();
    JSplitPane jSplitPane2 = new JSplitPane();
    JSplitPane jSplitPaneTableText = new JSplitPane();

    JScrollPane jScrollPaneTree = new JScrollPane();
    JScrollPane jScrollPaneBla = new JScrollPane();
    JScrollPane jScrollPaneTable = new JScrollPane();
    JScrollPane jScrollPaneText = new JScrollPane();

    //JTabbedPane jTabbedPane1 = new JTabbedPane();
    //JTabbedPane jTabbedPane2 = new JTabbedPane();


    JTable table1 = new JTable();
    JTextPane jTextPane1 = new JTextPane();
    JPanel jPanel1 = new JPanel();
    JTree jTree1 = new JTree();

    //IntroFrame introFrame;
    //Thread introThread;


    /**Construct the frame*/
    public SmailFrame(smail.Fassade fassade)
    {
      //introFrame = new IntroFrame();
      //introThread = new Thread(introFrame);
      //introThread.start();
      this.face = fassade;

      enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      try
      {
        jbInit();
      }
      catch(Exception e)
      {
        e.printStackTrace();
      }
    }



  protected DefaultMutableTreeNode convertVectorTree2TreeNodeTree(TreeVector vTree)
  {
    // Recursion
    String sName = vTree.sFolderName; //Accountname
    DefaultMutableTreeNode item = new DefaultMutableTreeNode(sName); // Knoten anlegen

    if (vTree.size() == 0)
    {
      // Recursionsanker
      return item;
    }
    else
    {
      for (int iCounter = 0; iCounter < vTree.size(); iCounter++)
      {
        DefaultMutableTreeNode addItem = convertVectorTree2TreeNodeTree(vTree.elementAt(iCounter));
        item.add(addItem);
      }
    }
    return item;
  }

 // get TreeVectorFromFassade
  // converts an account to tree
  protected TreeVector getTreeVectorFromFassade(String sAccount, String sPath)
  {
    // Account Name
    String sAccountName = sAccount;
    //smail.DummyFassade df = new smail.DummyFassade();
    //smail.DummyFolderContent fc = (smail.DummyFolderContent)df.getFolderContent(sPath);
    smail.FolderContent fc = face.getFolderContent(sPath);

    String[] sFolder = fc.getSubFolder();
    if (sPath.equalsIgnoreCase("/") == true)
      sPath = "";
    TreeVector tvFolder = new TreeVector(sAccountName);
    if (sFolder != null)
    {
      TreeVector tvTemp = null;
      for (int iCounter = 0; iCounter < sFolder.length; iCounter ++)
      {
        String sTempFolder = sFolder[iCounter];
        // manchmal wird / geliefert, manchmal nicht...
        if(sTempFolder.charAt(sTempFolder.length()-1) == '/')
        {
           sTempFolder = sTempFolder.substring(0, sTempFolder.length()-1);
        }

        String sFolderName = sTempFolder;
        int iFolderLength = sTempFolder.length();

        // an der Stelle 1 steht /
        if(iFolderLength < 1)
        {
          sTempFolder = "";
        }
        else
        {
          int iBegin = sTempFolder.lastIndexOf('/',iFolderLength-2) + 1; // liefert Stelle an der / steht +1
          int iEnd = iFolderLength;

          sFolderName = sTempFolder.substring(iBegin, iEnd);
        }

        tvTemp = getTreeVectorFromFassade(sFolderName, sTempFolder);
        tvFolder.add(tvTemp);
      }
    }

    return tvFolder;
  }



    /**Component initialization*/
    private void jbInit() throws Exception
    {
      contentPane = (JPanel) this.getContentPane();

      contentPane.add(upperPane = new JPanel (new FlowLayout(FlowLayout.LEFT)));//GridLayout(1,1 ,1,1)), BorderLayout.BEFORE_FIRST_LINE);
      contentPane.add(lowerPane = new JPanel (new GridLayout(1,1 ,1,1)), BorderLayout.CENTER);

      //Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();

      this.setSize(new Dimension(800,600));
      this.setTitle("Sm@il");

      Image image = new ImageIcon(getClass().getResource("Images/icon16.png")).getImage();
      this.setIconImage(image);


      this.setJMenuBar(jMenuBar1);



      // Menu
      // Smail

      //jMenuSmailProperties.setAccelerator(javax.swing.KeyStroke.getKeyStroke(83, java.awt.event.KeyEvent.CTRL_MASK, false));
      //jMenuSmailProperties.addActionListener(new java.awt.event.ActionListener() {public void actionPerformed(ActionEvent e) {jMenuSmailProperties_actionPerformed(e);}});
      jMenuSmailExit.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuSmailExit_actionPerformed(e);}});

      // Account
      jMenuAccountSend.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAccountSend_actionPerformed(e);}});
      jMenuAccountFetch.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAccountFetch_actionPerformed(e);}});
      jMenuAccountFetchSend.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAccountFetchSend_actionPerformed(e);}});
      jMenuAccountCreate.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAccountCreate_actionPerformed(e);}});
      jMenuAccountDelete.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAccountDelete_actionPerformed(e);}});
      jMenuAccountFilters.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAccountFilters_actionPerformed(e);}});
      jMenuAccountProperties.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAccountProperties_actionPerformed(e);}});

      // Folder
      //jMenuFolderNewRoot.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuFolderNewRoot_actionPerformed(e);}});
      jMenuFolderNewChild.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuFolderNewChild_actionPerformed(e);}});
      jMenuFolderDelete.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuFolderDelete_actionPerformed(e);}});
      jMenuFolderRename.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuFolderRename_actionPerformed(e);}});

      // Message
      jMenuMessageNew.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageNew_actionPerformed(e);}});
      jMenuMessageReplyQuoting.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageReplyQuoting_actionPerformed(e);}});
      jMenuMessageReplyNoQuoting.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageReplyNoQuoting_actionPerformed(e);}});
      jMenuMessageReplyToAllQuoting.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageReplyToAllQuoting_actionPerformed(e);}});
      jMenuMessageReplyToAllNoQuoting.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageReplyToAllNoQuoting_actionPerformed(e);}});
      jMenuMessageForward.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageForward_actionPerformed(e);}});
      jMenuMessageRead.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageRead_actionPerformed(e);}});
      jMenuMessageSave.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageSave_actionPerformed(e);}});
      jMenuMessageAppend.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageAppend_actionPerformed(e);}});
      jMenuMessageMarkAsRead.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageMarkAsRead_actionPerformed(e);}});
      jMenuMessageMarkAsUnread.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageMarkAsUnread_actionPerformed(e);}});
      jMenuMessageMove.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageMove_actionPerformed(e);}});
      jMenuMessageCopy.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageCopy_actionPerformed(e);}});
      jMenuMessageDelete.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageDelete_actionPerformed(e);}});

      // Addressbook
      jMenuAddressbookOpen.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAddressbookOpen_actionPerformed(e);}});
      jMenuAddressbookAddSenderToAddressbook.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAddressbookAddSenderToAddressbook_actionPerformed(e);}});

      // Skins
      jMenuSkinsSelect.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuSkinsSelect_actionPerformed(e);}});
      jMenuSkinsDefault.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuSkinsDefault_actionPerformed(e);}});

      // Language
      jMenuLanguageEnglish.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuLanguageEnglish_actionPerformed(e);}});
      jMenuLanguageGerman.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuLanguageGerman_actionPerformed(e);}});
      jMenuLanguageSwedish.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuLanguageSwedish_actionPerformed(e);}});
      jMenuLanguageFrench.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuLanguageFrench_actionPerformed(e);}});
	  jMenuLanguageSpanish.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuLanguageSpanish_actionPerformed(e);}});


      // Help
      jMenuHelpHelp.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuHelpHelp_actionPerformed(e);}});
      jMenuHelpAbout.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuHelpAbout_actionPerformed(e);}});


      // Add Menus to Menubar
      jMenuBar1.add(jMenuSmail);
      jMenuBar1.add(jMenuAccount);
      jMenuBar1.add(jMenuFolder);
      jMenuBar1.add(jMenuMessage);
      jMenuBar1.add(jMenuAddressbook);
      jMenuBar1.add(jMenuSkins);
      jMenuBar1.add(jMenuLanguage);
      jMenuBar1.add(jMenuHelp);

      // Add MenuItems to Menus
      jMenuSmail.add(jMenuSmailProperties);
      jMenuSmail.add(jMenuSmailExit);

      jMenuAccount.add(jMenuAccountFetch);
      jMenuAccount.add(jMenuAccountSend);
      jMenuAccount.add(jMenuAccountFetchSend);
      //jMenuAccount.add(jMenuAccountFetchAll);
      jMenuAccount.add(jMenuAccountCreate);
      jMenuAccount.add(jMenuAccountDelete);
      //jMenuAccount.add(jMenuAccountShowAccount);
      //jMenuAccount.add(jMenuAccountShowAllAccounts);
      jMenuAccount.add(jMenuAccountFilters);
      jMenuAccount.add(jMenuAccountProperties);

      //jMenuFolder.add(jMenuFolderNewRoot);
      jMenuFolder.add(jMenuFolderNewChild);
      jMenuFolder.add(jMenuFolderDelete);
      jMenuFolder.add(jMenuFolderRename);
      jMenuFolder.add(jMenuFolderProperties);

      jMenuMessage.add(jMenuMessageNew);
      jMenuMessage.add(jMenuMessageReply);
        jMenuMessageReply.add(jMenuMessageReplyQuoting);
        jMenuMessageReply.add(jMenuMessageReplyNoQuoting);
      jMenuMessage.add(jMenuMessageReplyToAll);
        jMenuMessageReplyToAll.add(jMenuMessageReplyToAllQuoting);
        jMenuMessageReplyToAll.add(jMenuMessageReplyToAllNoQuoting);
      jMenuMessage.add(jMenuMessageForward);
      jMenuMessage.add(jMenuMessageRead);
      jMenuMessage.add(jMenuMessageSave);
      jMenuMessage.add(jMenuMessageAppend);
      jMenuMessage.add(jMenuMessageMarkAsRead);
      jMenuMessage.add(jMenuMessageMarkAsUnread);
      jMenuMessage.add(jMenuMessageMove);
      jMenuMessage.add(jMenuMessageCopy);
      //jMenuMessage.add(jMenuMessageSelectAll);
      jMenuMessage.add(jMenuMessageDelete);

      jMenuAddressbook.add(jMenuAddressbookOpen);
      jMenuAddressbook.add(jMenuAddressbookAddSenderToAddressbook);

      jMenuSkins.add(jMenuSkinsSelect);
      jMenuSkins.add(jMenuSkinsDefault);

      jMenuLanguage.add(jMenuLanguageEnglish);
      jMenuLanguage.add(jMenuLanguageGerman);
      jMenuLanguage.add(jMenuLanguageSwedish);
      jMenuLanguage.add(jMenuLanguageFrench);
      jMenuLanguage.add(jMenuLanguageSpanish);

      jMenuHelp.add(jMenuHelpHelp);
      jMenuHelp.add(jMenuHelpAbout);





      // Buttons
      jToolBar1.setBorderPainted(false);
      jToolBar2.setBorderPainted(false);
      jToolBar3.setBorderPainted(false);
      jToolBar4.setBorderPainted(false);


      // Setting Images, Tooltips,Sizes, ActionListeners to the Buttons
      jButton1Fetch.setIcon(new ImageIcon(EditorFrame.class.getResource("Images/fetch2.png")));
      jButton1Fetch.setToolTipText(sTooltipFetch);
      jButton1Fetch.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAccountFetch_actionPerformed(e);}});

      jButton2Send.setIcon(new ImageIcon(EditorFrame.class.getResource("Images/send.png")));
      jButton2Send.setToolTipText(sTooltipSend);
      jButton2Send.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAccountSend_actionPerformed(e);}});

      jButton3FetchSend.setIcon(new ImageIcon(EditorFrame.class.getResource("Images/fetchsend.png")));
      jButton3FetchSend.setToolTipText(sTooltipFetchSend);
      jButton3FetchSend.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAccountFetchSend_actionPerformed(e);}});

      jButton4New.setIcon(new ImageIcon(EditorFrame.class.getResource("Images/new.png")));
      jButton4New.setToolTipText(sTooltipNew);
      jButton4New.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageNew_actionPerformed(e);}});

      jButton5Reply.setIcon(new ImageIcon(EditorFrame.class.getResource("Images/reply.png")));
      jButton5Reply.setToolTipText(sTooltipReply);
      jButton5Reply.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageReplyQuoting_actionPerformed(e);}});

      jButton6Forward.setIcon(new ImageIcon(EditorFrame.class.getResource("Images/forward.png")));
      jButton6Forward.setToolTipText(sTooltipForward);
      jButton6Forward.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageForward_actionPerformed(e);}});

      jButton7Move.setIcon(new ImageIcon(EditorFrame.class.getResource("Images/move.png")));
      jButton7Move.setToolTipText(sTooltipMove);
      //jButton7Move.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageMove_actionPerformed(e);}});

      jButton8Copy.setIcon(new ImageIcon(EditorFrame.class.getResource("Images/copym.png")));
      jButton8Copy.setToolTipText(sTooltipCopy);
      //jButton8Copy.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageCopy_actionPerformed(e);}});

      jButton9Delete.setIcon(new ImageIcon(EditorFrame.class.getResource("Images/delete.png")));
      jButton9Delete.setToolTipText(sTooltipDelete);
      //jButton9Delete.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageDelete_actionPerformed(e);}});

      jButton10Addressbook.setIcon(new ImageIcon(EditorFrame.class.getResource("Images/addressbok.png")));
      jButton10Addressbook.setToolTipText(sTooltipAddressbook);
      jButton10Addressbook.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAddressbookOpen_actionPerformed(e);}});

      jButton11Help.setIcon(new ImageIcon(EditorFrame.class.getResource("Images/help.png")));
      jButton11Help.setToolTipText(sTooltipHelp);
      jButton11Help.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){jMenuHelpHelp_actionPerformed(e);}});

      // Adding Buttons to the Toolbars
      jToolBar1.add(jButton1Fetch, null);
      jToolBar1.add(jButton2Send, null);
      jToolBar1.add(jButton3FetchSend, null);

      jToolBar2.add(jButton4New, null);
      jToolBar2.add(jButton5Reply, null);
      jToolBar2.add(jButton6Forward, null);

      jToolBar3.add(jButton7Move, null);
      jToolBar3.add(jButton8Copy, null);
      jToolBar3.add(jButton9Delete, null);

      jToolBar4.add(jButton10Addressbook, null);
      jToolBar4.add(jButton11Help, null);

      jToolBar1.setBounds(new Rectangle(10, 0, 90, 30));
      jToolBar2.setBounds(new Rectangle(110, 0, 90, 30));
      jToolBar3.setBounds(new Rectangle(210, 0, 90, 30));
      jToolBar4.setBounds(new Rectangle(310, 0, 60, 30));


      jButton1Fetch.setPreferredSize(new Dimension(27, 27));
      jButton2Send.setPreferredSize(new Dimension(27, 27));
      jButton3FetchSend.setPreferredSize(new Dimension(27, 27));
      jButton4New.setPreferredSize(new Dimension(27, 27));
      jButton5Reply.setPreferredSize(new Dimension(27, 27));
      jButton6Forward.setPreferredSize(new Dimension(27, 27));
      jButton7Move.setPreferredSize(new Dimension(27, 27));
      jButton8Copy.setPreferredSize(new Dimension(27, 27));
      jButton9Delete.setPreferredSize(new Dimension(27, 27));
      jButton10Addressbook.setPreferredSize(new Dimension(27, 27));
      jButton11Help.setPreferredSize(new Dimension(27, 27));

      // Splitpanes
      jSplitPaneTreeTable.setBounds(new Rectangle(5, 40, 790, 510));
      //jSplitPane2.setOrientation(JSplitPane.VERTICAL_SPLIT);
      jSplitPaneTableText.setOrientation(JSplitPane.VERTICAL_SPLIT);

      jSplitPaneTreeTable.add(jScrollPaneTree, JSplitPane.LEFT);
      jSplitPaneTreeTable.add(jSplitPaneTableText, JSplitPane.RIGHT);

      //jSplitPane2.add(jScrollPaneTree, JSplitPane.TOP);
      //jSplitPane2.add(jScrollPaneBla, JSplitPane.BOTTOM);

      jSplitPaneTableText.add(jScrollPaneText, JSplitPane.BOTTOM);
      jSplitPaneTableText.add(jScrollPaneTable, JSplitPane.TOP);

      jSplitPaneTreeTable.setDividerLocation(130);
      jSplitPane2.setDividerLocation(500);
      jSplitPaneTableText.setDividerLocation(180);

      //jTabbedPane1.add(jSplitPaneTableText, "Account1");
      //jTabbedPane1.add(jTabbedPane2, "Account2");
      jScrollPaneTable.setBorder(BorderFactory.createEtchedBorder());
      //jPanel1.setLayout(new BorderLayout())

      //jTable1.addFocusListener(new java.awt.event.FocusAdapter(){public void focusGained(FocusEvent e){jTable1_focusGained(e);}});
      //jTable1.addMouseListener(new java.awt.event.MouseAdapter(){public void mouseEntered(MouseEvent e){jTable1_mouseEntered(e);}});


      TreeVector vTree = getTreeVectorFromFassade("","/");
      DefaultMutableTreeNode top = convertVectorTree2TreeNodeTree(vTree);
      jTree1 = new JTree(top);
      jTree1.addMouseListener(new java.awt.event.MouseAdapter(){public void mouseReleased(MouseEvent e){jTree1_mouseReleased(e);}});

      jScrollPaneTable.getViewport().setBackground(Color.white);

      jScrollPaneTree.getViewport().add(jTree1, null);
      jScrollPaneTable.getViewport().add(table1, null);
      jScrollPaneText.getViewport().add(jTextPane1, null);

      // Add components to the contentPane
      contentPane.add(upperPane, BorderLayout.BEFORE_FIRST_LINE);
      contentPane.add(lowerPane, null);
      /*      contentPane.add(jToolBar1, null);
      contentPane.add(jToolBar2, null);
      contentPane.add(jToolBar3, null);
      contentPane.add(jToolBar4, null); */

      // contentPane.add(jSplitPaneTreeTable, null);
      upperPane.add(jToolBar1, null);
      upperPane.add(jToolBar2, null);
      upperPane.add(jToolBar3, null);
      upperPane.add(jToolBar4, null);
      lowerPane.add(jSplitPaneTreeTable, null);
  }

    // holt den Pfad des Folders der im Baum markiert ist
    public String getTreePath()
    {
      String sPath = "";
      TreePath tp  = jTree1.getSelectionPath();
      for (int iCounter = 1; iCounter < tp.getPathCount(); iCounter ++)
      {
        sPath = sPath+ "/"+tp.getPathComponent(iCounter);
      }
      return sPath;
    }



    // creates a new node at the tree
    protected void addNewChildToTree(String sNewFolder)
    {
        DefaultMutableTreeNode childNode = new DefaultMutableTreeNode(sNewFolder);
        DefaultTreeModel tm = (DefaultTreeModel) jTree1.getModel();
        DefaultMutableTreeNode parentNode = null;
        TreePath parentPath = jTree1.getSelectionPath();
        if (parentPath == null)
        {
                  //There's no selection. Default to the root node.
                  parentNode = null;
        }
        else
        {
          parentNode = (DefaultMutableTreeNode)(parentPath.getLastPathComponent());
        }

        tm.insertNodeInto(childNode, parentNode, parentNode.getChildCount());
        // make it visible
        jTree1.scrollPathToVisible(new TreePath(childNode.getPath()));
    }

    // shows the table in this way that a certain row is visible
    protected void showCell(int row)
    {
      Rectangle rect = table1.getCellRect(row, 0, true);
      table1.scrollRectToVisible(rect);
      smail.gui.SmailTable tb =  (smail.gui.SmailTable) table1.getModel();
      tb.fireTableDataChanged(); // notify the model
     }

    // gets the MessageNumber from a selected row of the table
    protected String getMsgNrFromTable()
    {
      int iRowCount = table1.getSelectedRow();
      if (iRowCount < 0)
        return null;

      // get the model
      smail.gui.SmailTable smailtable = (smail.gui.SmailTable) table1.getModel();
      if (smailtable == null)
        return null;

      String sMsgNr = (String) smailtable.getValueAt(iRowCount, 5);
      return sMsgNr;

    }



  // Tabelle anzeigen je nachdem wo im Baum geklickt wird
  void jTree1_mouseReleased(MouseEvent e)
  {

    TreePath tp  = jTree1.getSelectionPath();
    if(tp.getPathCount()==1)
      return;
    String sPath = getTreePath();

    try
    {
      //this.setTitle(sPath);


      smail.FolderContent fc = (smail.FolderContent) face.getFolderContent(sPath);
      smail.MessageHeader[] mh = null;

      mh = fc.getMessageHeader();

      Vector vRowData = new Vector();
      Vector vColumNames = new Vector();

      vColumNames.addElement(" ");
      vColumNames.addElement("Attachment");
      vColumNames.addElement(sTableDate);
      vColumNames.addElement(sTableSubject);
      vColumNames.addElement(sTableFrom);
      vColumNames.addElement("Nr");


      // rowdaten fuellen
      System.out.println("Laenge: "+mh.length);

      for (int iCounter = 0; iCounter < mh.length; iCounter ++)
      {
        Vector v = new Vector();
        if (mh[iCounter].read == false)
        {
          v.add(new ImageIcon(EditorFrame.class.getResource("Images/new.png")));
           //v.add("not read");
        }
        else
        {
          if (mh[iCounter].answered == true)
          {
            v.add(new ImageIcon(EditorFrame.class.getResource("Images/reply.png")));
            //v.add("answered");
          }
          else
          {
            v.add(" ");
          }
        }

        if (mh[iCounter].attachment == true)
        {
          v.add(new ImageIcon(EditorFrame.class.getResource("Images/attachment.png")));
        }
        else
        {
          v.add(" ");
        }

        v.add(mh[iCounter].sDate);
        v.add(mh[iCounter].subject);
        v.add(mh[iCounter].from);
        String sPosition = ""+mh[iCounter].folderPosition;
        v.add(sPosition);

        vRowData.add(v);
      }


      //JTable
      SmailTable st = new SmailTable(vRowData, vColumNames);
      table1 = new JTable(st);

      table1.getColumnModel().getColumn(0).setWidth(20);
      table1.getTableHeader().getColumnModel().getColumn(0).setWidth(10);

      table1.setSelectionMode(0);
      table1.setShowHorizontalLines(true);
      table1.setShowVerticalLines(false);
      table1.setEnabled(true);

      table1.addKeyListener(new java.awt.event.KeyAdapter(){public void keyReleased(KeyEvent e){table1_keyReleased(e);}});
      table1.addFocusListener(new java.awt.event.FocusAdapter(){public void focusGained(FocusEvent e){jTable1_focusGained(e);}});
      table1.addMouseListener(new java.awt.event.MouseAdapter(){public void mouseClicked(MouseEvent e){jTable1_mouseClicked(e);}});
      table1.addKeyListener(new java.awt.event.KeyAdapter(){public void keyTyped(KeyEvent e){table1_keyTyped(e);}});

      jScrollPaneTable.getViewport().add(table1, null);

    }
    catch (Exception e1)
    {
      System.out.println(e1 +"SmailFrame: jTree1_mouseReleased");
      e1.printStackTrace();
    }
  }

  void jTable1_focusGained(FocusEvent e)
  {
    System.out.println("Blaa focus");
  }

  // mit der maus in der Tabelle klicken
  void jTable1_mouseClicked(MouseEvent e)
  {
    int iClickCount = e.getClickCount();
    System.out.println("Clickanzahl: "+ iClickCount);

    SmailTable st = (smail.gui.SmailTable) table1.getModel();
    int iRow = table1.getSelectedRow();
    if (iRow == -1)
      return;

    String sTemp = (String) st.getValueAt(iRow,5);
    int iMsgNr = Integer.parseInt(sTemp);

    String sPath = getTreePath();
    smail.gui.MessageContent mc = face.openMail(iMsgNr,sPath);
    //smail.DummyFassade dm = new smail.DummyFassade(); // anstatt Originalfassade
    //smail.gui.MessageContent mc = dm.openMail(iMsgNr,sFolder);

    if (iClickCount == 2)
    {
      TreePath tp  = jTree1.getSelectionPath();




      if((sPath.indexOf("/OUTBOX")>-1)||(sPath.indexOf("/DRAFTS")>-1))
      {
          EditorFrame editor = new EditorFrame(face,"pfad/zur/PropertieDatei.txt", "id", "sAddress",mc,0);
          editor.show();
      }
      else
      {
          ViewMessageFrame view = new ViewMessageFrame(face,sPath,"PropertieFile",iMsgNr+"",mc);
          view.show();
      }
    }
    if (iClickCount == 1)
    {
      ViewMessagePane view = new ViewMessagePane(face,"PropertieFile","Id",mc.getText());
      jScrollPaneText.getViewport().add(view, null);
      System.out.println("Blaa enter");
    }
  }


  // Taste druecken
  void table1_keyTyped(KeyEvent e)
  {
    SmailTable st = (smail.gui.SmailTable) table1.getModel();
    int iRow = table1.getSelectedRow();
    if (iRow == -1)
      return;

    String sTemp = (String) st.getValueAt(iRow,5);
    int iMsgNr = Integer.parseInt(sTemp);

      String sPath = getTreePath();

      smail.gui.MessageContent mc = face.openMail(iMsgNr,sPath);
    if(e.getKeyChar() == e.VK_ENTER)
    {
      ViewMessageFrame view = new ViewMessageFrame(face,sPath,"PropertieFile",iMsgNr+"",mc);
      view.show();
    }
  }


  void table1_keyReleased(KeyEvent e)
  {

    SmailTable st = (smail.gui.SmailTable) table1.getModel();
    int iRow = table1.getSelectedRow();
    if (iRow == -1)
      return;

    String sTemp = (String) st.getValueAt(iRow,5);
    int iMsgNr = Integer.parseInt(sTemp);

    String sPath = getTreePath();
    smail.gui.MessageContent mc = face.openMail(iMsgNr,sPath);

    if(e.getKeyChar() != e.VK_ENTER)
    {
      ViewMessagePane view = new ViewMessagePane(face,"PropertieFile","Id",mc.getText());
      jScrollPaneText.getViewport().add(view, null);
      System.out.println("Blaa enter");
    }
  }

  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
    {
        face.exit() ;
        //      System.exit(0);
    }
  }



  // Smail -> Exit
  void jMenuSmailExit_actionPerformed(ActionEvent e)
  {
    face.exit();
  }


  // Account -> Send
  void jMenuAccountSend_actionPerformed(ActionEvent e)
  {
    uploadFrame = new ProgressUploadFrame();
    int uploadSize = 3000;
    uploadFrame.setAmount(uploadSize);
    uploadFrame.setLocation(300, 250);
    uploadFrame.setVisible(true);
    uploadFrame.progressBar.setValue(100);
    uploadFrame.progressBar.repaint();
    face.send(/*uploadFrame*/);
    updateUpload();
    uploadFrame.dispose();
  }

  void updateUpload(){
    int uSize = 3000;
      for (int i=1; i< uSize; i++) {
      try {
	uploadFrame.progressBar.setValue(i);
	uploadFrame.progressBar.repaint();
      }
      catch (Exception eup) {
	eup.printStackTrace();
      }
  }}

  void updateDownload(){
    int uSize = 3000;
      for (int i=1; i< uSize; i++) {
      try {
	downloadFrame.progressBar.setValue(i);
	downloadFrame.progressBar.repaint();
      }
      catch (Exception eup) {
	eup.printStackTrace();
      }
  }}

  // Account -> Fetch
  void jMenuAccountFetch_actionPerformed(ActionEvent e)
  {
    downloadFrame = new ProgressDownloadFrame();
    int uploadSize = 3000;
    downloadFrame.setAmount(uploadSize);
    downloadFrame.setLocation(300, 250);
    downloadFrame.setVisible(true);
    downloadFrame.progressBar.setValue(100);
    downloadFrame.progressBar.repaint();
      face.receive();
      System.out.println("fetch");
      int iSelect = jTree1.getSelectionCount();
      if(iSelect>0)
      {
        jTree1_mouseReleased(null);
      }
    updateDownload();
    downloadFrame.dispose();
  }


  // Account -> FetchSend
  void jMenuAccountFetchSend_actionPerformed(ActionEvent e)
  {
    jMenuAccountFetch_actionPerformed(e);
    jMenuAccountSend_actionPerformed(e);
      System.out.println("fetch&send");
  }


  // Account -> Create
  void jMenuAccountCreate_actionPerformed(ActionEvent e)
  {

  }


  // Account -> Delete
  void jMenuAccountDelete_actionPerformed(ActionEvent e)
  {

  }


  // Account -> Filters
  void jMenuAccountFilters_actionPerformed(ActionEvent e)
  {
	smail.gui.filterGui.FilterGuy filterG = new smail.gui.filterGui.FilterGuy(face) ;
	filterG.show() ;
//	smail.Popup p = new smail.Popup("This is not yet implemented !", true);
  }


  // Account -> Properties
  void jMenuAccountProperties_actionPerformed(ActionEvent e)
  {
    AccountFrame account = new AccountFrame(face);
    account.show();
  }



  // Folder -> Create
  void jMenuFolderNewChild_actionPerformed(ActionEvent e)
  {
      int iSelect = jTree1.getSelectionCount();
      TreePath tp  = jTree1.getSelectionPath();

      if((iSelect<=0)||(tp.getPathCount()==1))
      {
            ErrorFrame error = new ErrorFrame();
            error.jLabelInfo.setText("Please select a parentfolder");
            error.setTitle("No Selected Folder");
            error.jButtonOk.requestFocus();
            error.show();
            return;
      }

      String sPath = getTreePath();
      System.out.println("Pfad: "+sPath);
      //(Pfad,Name)
      InputFrame input = new InputFrame();
      input.show();

      if(input.bInputStatus == true)
      {
          String sFolder = input.sInput;

          try
          {
            face.addNewFolder(sPath,sFolder);
            addNewChildToTree(sFolder);
          }
          catch (Exception ex){System.out.println("SmailFrame: New Folder");}
      }
  }


  // Folder -> Delete

  void jMenuFolderDelete_actionPerformed(ActionEvent e)
  {
      TreePath tp  = jTree1.getSelectionPath();
      if(tp.getPathCount()==1)
      {
            ErrorFrame error = new ErrorFrame();
            error.jLabelInfo.setText("You are trying to delete root");
            error.setTitle("Rootfolder!");
            error.jButtonOk.requestFocus();
            error.show();
            return;
      }

      String sPath = getTreePath();

      if (sPath.equals("/INBOX")== true)
      {
            ErrorFrame error = new ErrorFrame();
            error.jLabelInfo.setText("You are trying to delete the Inbox");
            error.setTitle("Inbox");
            error.jButtonOk.requestFocus();
            error.show();
            return;
      }


      if (sPath.equals("/OUTBOX")== true)
      {
            ErrorFrame error = new ErrorFrame();
            error.jLabelInfo.setText("You are trying to delete the Outbox");
            error.setTitle("Outbox");
            error.jButtonOk.requestFocus();
            error.show();
            return;
      }

      System.out.println("Pfad wird jetzt gelscht...: "+sPath);
      try
      {
          face.removeFolder(sPath);
          System.out.println("Geloescht");

          TreePath currentSelection = jTree1.getSelectionPath();
          if (currentSelection != null)
          {
            DefaultTreeModel treeModel = (DefaultTreeModel) jTree1.getModel();
            DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)
                         (currentSelection.getLastPathComponent());
            MutableTreeNode parent = (MutableTreeNode)(currentNode.getParent());
            if (parent != null)
            {
                treeModel.removeNodeFromParent(currentNode);
                return;
            }
          }
      }
      catch(Exception ex){System.out.println("SmailFrame: MenuFolderDelete");}
  }

  // Folder -> Rename
  void jMenuFolderRename_actionPerformed(ActionEvent e)
  {
        TreePath currentSelection = jTree1.getSelectionPath();
        if (currentSelection != null)
        {

          if(currentSelection.getPathCount()==1)
          {
              ErrorFrame error = new ErrorFrame();
              error.jLabelInfo.setText("Rename impossible");
              error.setTitle("Rename folder");
              error.jButtonOk.requestFocus();
              error.show();
              return;
          }

          String sPath = getTreePath();
          if ((sPath.equals("/INBOX")== true)||(sPath.equals("/OUTBOX")== true)||(sPath.equals("/DRAFTS")== true))
          {
            ErrorFrame error = new ErrorFrame();
            error.jLabelInfo.setText("Rename impossible");
            error.setTitle("Rename folder");
            error.jButtonOk.requestFocus();
            error.show();
            return;
          }


          InputFrame input = new InputFrame();
          input.show();

          if(input.bInputStatus == true)
          {
            String sFolder = input.sInput;

            DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode) (currentSelection.getLastPathComponent());
            sPath = this.getTreePath();


            int i = sPath.lastIndexOf('/');

            sPath = sPath.substring(0, i+1)+sFolder;

            try
            {
              face.copyFolder((String)getTreePath(), sPath);
               currentNode.setUserObject(sFolder);
            }
            catch(Exception e1)
            {
            }
        }
      }
  }




  // Message -> New
  // Hier muessen noch sinnvolle Daten uebergeben werden!
  void jMenuMessageNew_actionPerformed(ActionEvent e)
  {
      System.out.println("Edit");
      //  get the first address
      smail.server.Account ac = face.getAllAccounts()[0];
      String sAddress = "";
      if ((ac == null) || (ac.username == null))
        sAddress = "Dummy@bla.de";
      else
      {
          sAddress  = ac.username;
          if (ac.pop3Host != null)
            sAddress = sAddress+"@"+ac.pop3Host;
      }
    // call editor with activ adress
     EditorFrame ed = new EditorFrame(face,"pfad/zur/PropertieDatei.txt", "id", sAddress);
  }



  // Message -> Reply -> Include Quoting
  void jMenuMessageReplyQuoting_actionPerformed(ActionEvent e)
  {
      SmailTable st = (smail.gui.SmailTable) table1.getModel();
      int iRow = table1.getSelectedRow();
      if (iRow == -1)
      return;

      String sTemp = (String) st.getValueAt(iRow,5);
      int iMsgNr = Integer.parseInt(sTemp);

      String sFolder = "";
      TreePath tp = jTree1.getSelectionPath();
      for(int iCounter =0; iCounter < tp.getPathCount();iCounter++)
      {
          sFolder = sFolder + tp.getPathComponent(iCounter);
      }
            smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
//      smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
      //smail.DummyFassade dm = new smail.DummyFassade(); // anstatt Originalfassade
      //smail.gui.MessageContent mc = dm.openMail(iMsgNr,sFolder);

      Vector vToAddress = new Vector();
      vToAddress.add(mc.getFrom());

      //  get the first address
      smail.server.Account ac = face.getAllAccounts()[0];
      String sAddress = "";
      if ((ac == null) || (ac.username == null))
        sAddress = "Dummy@bla.de";
      else
      {
          sAddress  = ac.username;
          if (ac.pop3Host != null)
            sAddress = sAddress+"@"+ac.pop3Host;
      }

      MessageContent content = new MessageContent(sAddress,mc.getDate(),vToAddress, new Vector(),mc.getSubject(),mc.getText());

      EditorFrame editor = new EditorFrame(face,"pfad/zur/PropertieDatei.txt", "id", sAddress,content);
      //editor.jTextPane1.requestFocus();
      editor.show();
  }

  // Message -> Reply -> Exclude Quoting
  void jMenuMessageReplyNoQuoting_actionPerformed(ActionEvent e)
  {
      SmailTable st = (smail.gui.SmailTable) table1.getModel();
      int iRow = table1.getSelectedRow();
      if (iRow == -1)
      return;

      String sTemp = (String) st.getValueAt(iRow,5);
      int iMsgNr = Integer.parseInt(sTemp);

      String sFolder = "";
      TreePath tp = jTree1.getSelectionPath();
      for(int iCounter =0; iCounter < tp.getPathCount();iCounter++)
      {
          sFolder = sFolder + tp.getPathComponent(iCounter);
      }
            smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
//      smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
      //smail.DummyFassade dm = new smail.DummyFassade(); // anstatt Originalfassade
      //smail.gui.MessageContent mc = dm.openMail(iMsgNr,sFolder);

      Vector vToAddress = new Vector();
      vToAddress.add(mc.getFrom());

      //  get the first address
      smail.server.Account ac = face.getAllAccounts()[0];
      String sAddress = "";
      if ((ac == null) || (ac.username == null))
        sAddress = "Dummy@bla.de";
      else
      {
          sAddress  = ac.username;
          if (ac.pop3Host != null)
            sAddress = sAddress+"@"+ac.pop3Host;
      }


      MessageContent content = new MessageContent(sAddress,mc.getDate(),vToAddress, new Vector(),mc.getSubject(),"");

      EditorFrame editor = new EditorFrame(face,"pfad/zur/PropertieDatei.txt", "id", sAddress,content);
      //editor.jTextPane1.requestFocus();
      editor.show();
  }

  // Message -> Reply To All-> Include Quoting
  void jMenuMessageReplyToAllQuoting_actionPerformed(ActionEvent e)
  {
      SmailTable st = (smail.gui.SmailTable) table1.getModel();
      int iRow = table1.getSelectedRow();
      if (iRow == -1)
      return;

      String sTemp = (String) st.getValueAt(iRow,5);
      int iMsgNr = Integer.parseInt(sTemp);

      String sFolder = "";
      TreePath tp = jTree1.getSelectionPath();
      for(int iCounter =0; iCounter < tp.getPathCount();iCounter++)
      {
          sFolder = sFolder + tp.getPathComponent(iCounter);
      }
            smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
//      smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
      //smail.DummyFassade dm = new smail.DummyFassade(); // anstatt Originalfassade
      //smail.gui.MessageContent mc = dm.openMail(iMsgNr,sFolder);


      Vector vToAddress = new Vector();
      vToAddress.add(mc.getFrom());


        for(int iCounter = 0;iCounter < mc.getToAddresses().size();iCounter++)
        {
            vToAddress.add(mc.getToAddresses().elementAt(iCounter));
        }

        for(int iCounter = 0;iCounter < mc.getCcAddresses().size();iCounter++)
        {
            vToAddress.add(mc.getCcAddresses().elementAt(iCounter));
        }


      //  get the first address
      smail.server.Account ac = face.getAllAccounts()[0];
      String sAddress = "";
      if ((ac == null) || (ac.username == null))
        sAddress = "Dummy@bla.de";
      else
      {
          sAddress  = ac.username;
          if (ac.pop3Host != null)
            sAddress = sAddress+"@"+ac.pop3Host;
      }


      MessageContent content = new MessageContent(sAddress,mc.getDate(),vToAddress, new Vector(),mc.getSubject(),mc.getText());

      EditorFrame editor = new EditorFrame(face,"pfad/zur/PropertieDatei.txt", "id", sAddress,content);
      //editor.jTextPane1.requestFocus();
      editor.show();

  }


  // Message -> Reply To All-> Exclude Quoting
  void jMenuMessageReplyToAllNoQuoting_actionPerformed(ActionEvent e)
  {
      SmailTable st = (smail.gui.SmailTable) table1.getModel();
      int iRow = table1.getSelectedRow();
      if (iRow == -1)
      return;

      String sTemp = (String) st.getValueAt(iRow,5);
      int iMsgNr = Integer.parseInt(sTemp);

      String sFolder = "";
      TreePath tp = jTree1.getSelectionPath();
      for(int iCounter =0; iCounter < tp.getPathCount();iCounter++)
      {
          sFolder = sFolder + tp.getPathComponent(iCounter);
      }
            smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
//      smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
      //smail.DummyFassade dm = new smail.DummyFassade(); // anstatt Originalfassade
      //smail.gui.MessageContent mc = dm.openMail(iMsgNr,sFolder);


      Vector vToAddress = new Vector();
      vToAddress.add(mc.getFrom());


        for(int iCounter = 0;iCounter < mc.getToAddresses().size();iCounter++)
        {
            vToAddress.add(mc.getToAddresses().elementAt(iCounter));
        }

        for(int iCounter = 0;iCounter < mc.getCcAddresses().size();iCounter++)
        {
            vToAddress.add(mc.getCcAddresses().elementAt(iCounter));
        }


      //  get the first address
      smail.server.Account ac = face.getAllAccounts()[0];
      String sAddress = "";
      if ((ac == null) || (ac.username == null))
        sAddress = "Dummy@bla.de";
      else
      {
          sAddress  = ac.username;
          if (ac.pop3Host != null)
            sAddress = sAddress+"@"+ac.pop3Host;
      }


      MessageContent content = new MessageContent(sAddress,mc.getDate(),vToAddress, new Vector(),mc.getSubject(),"");

      EditorFrame editor = new EditorFrame(face,"pfad/zur/PropertieDatei.txt", "id", sAddress,content);
      //editor.jTextPane1.requestFocus();
      editor.show();
  }


  // Message -> Forward
  void jMenuMessageForward_actionPerformed(ActionEvent e)
  {
      SmailTable st = (smail.gui.SmailTable) table1.getModel();
      int iRow = table1.getSelectedRow();
      if (iRow == -1)
      return;

      String sTemp = (String) st.getValueAt(iRow,5);
      int iMsgNr = Integer.parseInt(sTemp);

      String sFolder = "";
      TreePath tp = jTree1.getSelectionPath();
      for(int iCounter =0; iCounter < tp.getPathCount();iCounter++)
      {
          sFolder = sFolder + tp.getPathComponent(iCounter);
      }
            smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
//      smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
      //smail.DummyFassade dm = new smail.DummyFassade(); // anstatt Originalfassade
      //smail.gui.MessageContent mc = dm.openMail(iMsgNr,sFolder);
      //  get the first address
      smail.server.Account ac = face.getAllAccounts()[0];
      String sAddress = "";
      if ((ac == null) || (ac.username == null))
        sAddress = "Dummy@bla.de";
      else
      {
          sAddress  = ac.username;
      }



      MessageContent forwardContent = new MessageContent(mc.getSubject(),mc.getHeader(),mc.getText(), mc.getAttachments());
      EditorFrame editor = new EditorFrame(face,"pfad/zur/PropertieDatei.txt", "id", sAddress,forwardContent,"forward");

      editor.show();
  }



  // Message -> Read

  // muss noch geaendert werden
  // hier wird das Anzeigen einer Mail getestet (beim Klicken im Menu Message -> Read)
  void jMenuMessageRead_actionPerformed(ActionEvent e)
  {
    SmailTable st = (smail.gui.SmailTable) table1.getModel();
    int iRow = table1.getSelectedRow();
    if (iRow == -1)
      return;
    //System.out.println("MessageNummer: "+iMsgNr);

    String sTemp = (String) st.getValueAt(iRow,5);
    int iMsgNr = Integer.parseInt(sTemp);

    String sFolder = "";
    TreePath tp = jTree1.getSelectionPath();
    for(int iCounter = 1; iCounter < tp.getPathCount();iCounter++)
    {
        sFolder = sFolder + "/" + tp.getPathComponent(iCounter);
    }
     System.out.println("Folder: "+sFolder);
    smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
    //smail.DummyFassade dm = new smail.DummyFassade(); // anstatt Originalfassade
    //smail.gui.MessageContent mc = dm.openMail(iMsgNr,sFolder);
      ViewMessageFrame view = new ViewMessageFrame(face,sFolder,"PropertieFile",iMsgNr+"",mc);
      view.show();
  }

  // Message -> Save
  void jMenuMessageSave_actionPerformed(ActionEvent e)
  {

  }


  // Message -> Append
  void jMenuMessageAppend_actionPerformed(ActionEvent e)
  {

  }


  // Message -> MarkAsRead
  void jMenuMessageMarkAsRead_actionPerformed(ActionEvent e)
  {

  }


  // Message -> MarkAsUnread
  void jMenuMessageMarkAsUnread_actionPerformed(ActionEvent e)
  {

  }


  // Message -> Move
  void jMenuMessageMove_actionPerformed(ActionEvent e)
  {
    //face.copyMessage(String srcFolderName, int msgNumber, String destFolderName)
    //face.deleteMessage(String folderName, int msgNumber)
  }


  // Message -> Copy
  void jMenuMessageCopy_actionPerformed(ActionEvent e)
  {
    //face.copyMessage(String srcFolderName, int msgNumber, String destFolderName)
    /*try
    {
        face.copyMessage("/INBOX",1,"/SENT");
    }
    catch(smail.NonExistentFolderException ex)
    {}//System.out.println("SmailFrame copy Message");}
    */
  }


  // Message -> Delete
  void jMenuMessageDelete_actionPerformed(ActionEvent e)
  {
    //SmailTable st = (smail.gui.SmailTable) table1.getModel();
    int iRow = table1.getSelectedRow();
    if (iRow == -1)
      return;

    String sTemp = getMsgNrFromTable();
    int iMsgNr = Integer.parseInt(sTemp);

    String sPath = getTreePath();

      //face.deleteMessage(String folderName, int msgNumber)

    try
    {
     // face.deleteMessage(sPath,iMsgNr);
      jTree1_mouseReleased(null);   // null ist ok weil mouseevent hier nicht benutzt
      showCell(iRow);
    }
    catch(Exception ex){System.out.println("SmailFrame: MenuMessageDelete");}

  }


  // Addressbook -> Open Addressbook
  void jMenuAddressbookOpen_actionPerformed(ActionEvent e)
  {
      Addressbook book = new Addressbook(face);
      book.show();
  }


  // Addressbook -> AddSenderToAddressbook
  void jMenuAddressbookAddSenderToAddressbook_actionPerformed(ActionEvent e)
  {
      //Addressbook book = new Addressbook(face);
      //book.show();
  }


  // Skins -> Select Skin
  // Skins Auswahl
  void jMenuSkinsSelect_actionPerformed(ActionEvent e)
  {
  	//Hier geht ein FileDialog auf wo man die Skin auswhlt
	JFileChooser chooser = new JFileChooser();
	chooser.setFileFilter(new myFileFilter());
	int returnVal = chooser.showOpenDialog(this);
	if(returnVal == JFileChooser.APPROVE_OPTION)
	{

		Skin skin=null;
		try {
			skin = SkinLookAndFeel.loadThemePack(chooser.getSelectedFile().toURL());
		}
		catch(Exception me)
		{
			System.out.println(me);
		}
		// set the skin
		SkinLookAndFeel.setSkin(skin);
		try {
			UIManager.setLookAndFeel("com.l2fprod.gui.plaf.skin.SkinLookAndFeel");
		}
		catch(Exception me2)
		{
			System.out.println(me2);
		}
		SwingUtilities.updateComponentTreeUI(this);
	}
  }

  // Skins -> Default Skin
  void jMenuSkinsDefault_actionPerformed(ActionEvent e)
  {
	try {
		UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
	}
	catch(Exception me2)
	{
		System.out.println(me2);
	}
	SwingUtilities.updateComponentTreeUI(this);
  }

  // Language -> English
  public void jMenuLanguageEnglish_actionPerformed(ActionEvent e)
  {
    smail.utils.PropertiesManager.set("smail.language", "ENG");

    ErrorFrame error = new ErrorFrame();
    error.jLabelInfo.setText("Please restart Sm@il");
    error.setTitle("Language");
    error.jButtonOk.requestFocus();
    error.show();
    return;

  }

  // Language -> German
  public void jMenuLanguageGerman_actionPerformed(ActionEvent e)
  {
    smail.utils.PropertiesManager.set("smail.language", "GE");
    ErrorFrame error = new ErrorFrame();
    error.jLabelInfo.setText("Bitte Sm@il neustarten");
    error.setTitle("Sprache");
    error.jButtonOk.requestFocus();
    error.show();
    return;

  }

  // Language -> Swedish
  public void jMenuLanguageSwedish_actionPerformed(ActionEvent e)
  {
    	smail.utils.PropertiesManager.set("smail.language", "SW");
        ErrorFrame error = new ErrorFrame();
        error.jLabelInfo.setText("Vad god restart Sm@il :-)))");
        error.setTitle("Sprak");
        error.jButtonOk.requestFocus();
        error.show();
        return;

  }

  // Language -> French
  public void jMenuLanguageFrench_actionPerformed(ActionEvent e)
  {
    	smail.utils.PropertiesManager.set("smail.language", "FR");
        ErrorFrame error = new ErrorFrame();
        error.jLabelInfo.setText("SVP recommencez Sm@il");
        error.setTitle("Langue");
        error.jButtonOk.requestFocus();
        error.show();
        return;

  }

  // Language -> Spanish
  public void jMenuLanguageSpanish_actionPerformed(ActionEvent e)
  {
    	smail.utils.PropertiesManager.set("smail.language", "ES");
        ErrorFrame error = new ErrorFrame();
        error.jLabelInfo.setText("Por favor recomencar Sm@il");
        error.setTitle("Lengua");
        error.jButtonOk.requestFocus();
        error.show();
        return;

  }



    // Help -> Help
    public void jMenuHelpHelp_actionPerformed(ActionEvent e)
    {
        String sTempResource = smail.gui.EditorFrame.class.getResource("help.html").toString();//.substring(5);
        Internet browser = new Internet(sTempResource);
        browser.show(sTempResource);
    }

    // Help -> About
    public void jMenuHelpAbout_actionPerformed(ActionEvent e)
    {
	final JFrame f = new AboutFrame();
    }


}



class myFileFilter extends javax.swing.filechooser.FileFilter
{
    // Accept all directories and all zip files
    public boolean accept(File f)
    {
        if (f.isDirectory())
            return true;

        String extension = getExtension(f);
		if (extension != null)
		{
            if (extension.equals("zip"))
            	return true;
            else
                return false;
    	}

        return false;
    }

    public String getDescription()
    {
        return "Skins";
    }

    public static String getExtension(File f)
    {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }

}




