package smail.gui;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
//import net.jmge.gif.*;
import com.sun.image.codec.jpeg.*;
  

/* This is an implementation for Smily recognition, that identifies Smilies from Strings and
draws them in an graphical form. After this, the image gets saved as an File for later use */
public class Smilie
{

	private char[] onHead = { '0','|','','<','>' };
	private char[] eyes = { ':',';','8','',',','%','B','o','|','X','+','X' };
	private char[] tears = { '','\'',',','.','0' };
	private char[] noses = { '-','%','*' };
	private char[] mouth = { 'o','O',')','(','!','|','P','p','S', '8','X', '/', '[', 'L' };
	private char[] beards = { ')','>' };
	private int Width = 20;
	private int Height = 20;
	private int count=0;
	private BufferedImage bi;
	
	/* This sets the Resolution of the Image that should be created. After calling this, all
	following smilies are created with this Size. The default Size is 20x20 */
	public void setSize(int w, int h)
	{
		Width=w;
		Height=h;
	}

	/* This returns the last created Smily in its image representation. */ 
	public Image getImage()
	{
		return bi;
	}
	
	
	/* This Method recognizes Smilies
	 * The Smilies have to have the following Form
	 * [<onHead>]<eyes>[<tears>][<noses>]<mouth>[<beards>]
	 * z.B.: 08-o> Heiligenschein, Brille, Trne und o mouth mit Bart
	*/	
	public String getSmilie(String smile)
	{
		int pos = 0;
		char []Smilie = {' ',' ',' ',' ',' ',' ' };
		boolean isfinished=false;
		int i=0;
		
		if(smile.length()>pos)
		for( i=0;i<onHead.length;i++)
			if(onHead[i]==smile.charAt(pos))
			{
				pos++;
				Smilie[0] = onHead[i];
				break;
			}
		if(smile.length()>pos)
		for( i=0;i<eyes.length;i++)
			if(eyes[i]==smile.charAt(pos))
			{
				pos++;
				Smilie[1] = eyes[i];
				break;
			}
		if(pos==0)return null;

		if(smile.length()>pos)
		for( i=0;i<tears.length;i++)
			if(tears[i]==smile.charAt(pos))
			{
				pos++;
				Smilie[2] = tears[i];
				break;
			}

		if(smile.length()>pos)
		for( i=0;i<noses.length;i++)
			if(noses[i]==smile.charAt(pos))
			{
				pos++;
				Smilie[3] = noses[i];
				break;
			}

		if(smile.length()>pos)
		for( i=0;i<mouth.length;i++)
			if(mouth[i]==smile.charAt(pos))
			{
				pos++;
				Smilie[4] = mouth[i];
				break;
			}
		if(i==mouth.length)return null;
		
		if(smile.length()>pos)
		for( i=0;i<beards.length;i++)
			if(beards[i]==smile.charAt(pos))
			{
				pos++;
				Smilie[5] = beards[i];
				break;
			}
			
		bi = new BufferedImage(Width+1,Height+1,BufferedImage.TYPE_INT_RGB);
		Graphics2D g2d = bi.createGraphics();
		g2d.fillRect(0,0,Width+1,Height+1);
		g2d.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
		g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING , RenderingHints.VALUE_ANTIALIAS_ON );
		drawBase(g2d);
		drawOnHead(g2d,Smilie[0]);
		drawEyes(g2d,Smilie[1]);
		drawTears(g2d,Smilie[2]);
		drawNoses(g2d,Smilie[3]);
		drawMouth(g2d,Smilie[4]);
		drawBeards(g2d,Smilie[5]);

		OutputStream out;
		java.io.File f = null;
		try { 
				f = java.io.File.createTempFile("smail",".jpg");
				f.deleteOnExit();
				out = new FileOutputStream(f);
				com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(out).encode(bi); 
			} 
		catch(Exception e){System.out.println(e);}
		
		count++;

		try {
				return f.toURL().toString(); 	
			} catch(Exception e){System.out.println(e); return null; 
		}
	}

	/* Draws the Base Smilie, just a black Circle with a Yellow interior */	
	private void drawBase(Graphics g)
	{
		g.setColor(Color.yellow);
		g.fillOval(0,0,Width,Height);				
		g.setColor(Color.black);
		g.drawOval(0,0,Width,Height);				
	}
	
	/* Draws the Stuff thats on the Head */
	private void drawOnHead(Graphics g,char c)
	{
		switch(c)
		{
			case '0' : 
				g.setColor(Color.red);
				g.drawOval(0,0,Width,Height/5);
				break;
			case '<':
				g.setColor(Color.red);
				g.drawLine(Width/2,0,Width, Height/5);
				g.drawLine(0,Height/5, Width/2,0);
				break;
			
			default : break;			
		}
	}


	/* Draws the Stuff that could be Eyes */
	private void drawEyes(Graphics g,char c)
	{
		switch(c)
		{
			case ':' : 
				g.setColor(Color.black);
				g.fillOval((int)(Width*0.2),Height/4,Width/5,Height/5);
				g.fillOval((int)(Width*0.8)-Width/5,Height/4,Width/5,Height/5);
				break;
			case ';' :
				g.setColor(Color.black);
				g.drawLine(Width/3,Height/3,Width/5,Height/3); 
		     		g.fillOval((int)(Width*0.8)-Width/5,Height/4,Width/5,Height/5); 	 	
				break; 			
			case ',':
				g.setColor(Color.black);
				g.drawLine((int)(Width*0.2),Height/3,(int)(Width*0.4),Height/3);
				break;
			case '8' :
				g.setColor(Color.black);
				g.drawOval((int)(Width*0.6),(int)(Height*0.2),Width/5,Height/5);
				g.drawOval((int)(Width*0.2),(int)(Height*0.2),Width/5,Height/5);
				g.drawLine((int)(Width*0.3),Height/5,(int)(Width*0.7),Height/5);
				break;				
			case '%' :
				g.setColor(Color.black);
				g.drawOval(Width/2,(int)(Height*0.1),Width/5,Height/3);
				g.drawOval(Width/4,(int)(Height*0.1),Width/5,Height/3);
				break;
			case 'B' :
				g.setColor(Color.black);
				g.fillOval((int)(Width*0.2),Height/4,Width/5,Height/5);
				g.fillOval((int)(Width*0.8)-Width/5,Height/4,Width/5,Height/5);
				g.drawLine((int)(Width*0.1),Height/4,(int)(Width*0.85),Height/4);
				break;
			case 'o' :
				g.setColor(Color.black);
				g.fillOval((int)(Width*0.4),(int)(Height*0.2),Width/5,Height/5);
				break;
			case '|' :
				g.setColor(Color.black);
				g.drawOval(Width/2,(int)(Height*0.4),Width/5,Height/60);
				g.drawOval(Width/4,(int)(Height*0.2),Width/5,Height/60);
				break;
			case 'X' :	
				g.setColor(Color.black);
				g.drawOval(Width/2,(int)(Height*0.4),Width/5,Height/60);
				g.drawOval(Width/4,(int)(Height*0.2),Width/5,Height/60);	
				break;	
			case '+':
				g.setColor(Color.black);
				g.drawLine((int)(Width*0.2),Height/3,(int)(Width*0.4),Height/3);
				g.drawLine((int)(Width*0.6),Height/3,(int)(Width*0.8),Height/3);
				g.drawLine((int)(Width*0.7),Height/4,(int)(Width*0.7),(int)(Height*0.4));
				g.drawLine((int)(Width*0.3),Height/4,(int)(Width*0.3),(int)(Height*0.4));
				break;
				
			default : break;	
	 	} 	
	}
	/* Draws the Stuff that comes out of the Eyes */  
	private void drawTears(Graphics g,char c) 	
	{
		switch(c)  	 
		{
			case '0' : 
				g.setColor(Color.black);	
				g.drawOval(Width/2,(int)(Height*0.5),Width/5,Height/8);
				g.drawOval(Width/4,(int)(Height*0.5),Width/5,Height/8);
	  			break;
			case ',' :
				g.setColor(Color.black);
				g.drawOval(Width/4,(int)(Height*0.5),Width/5,Height/8);	
				break;
				 
			default :break;  		
		}
	}
 
	/* Draws the Stuff that most of you have in the middle of your Face; Removed because Smilies have no Nose */
	private void drawNoses(Graphics g,char c)
	{
		/**switch(c)
		{
			case '-' : 
				g.setColor(Color.black);
				g.drawLine(Width/2,Height/2-Height/8,Width/2,Height/2+Height/8);
				g.drawLine(Width/2-1,Height/2-Height/8,Width/2-1,Height/2+Height/8);
				break;
			case '*':				
				g.setColor(Color.black);
				g.drawArc((int)(Width*0.3),(int)(Height*0.6),(int)(Width*0.3),Height/2,40,120);					
				g.drawArc((int)(Width*0.5),(Height/4),(int)(Width*0.3),Height/2,-20,-120);
				break;
			
				
			default : break;			
		}**/
	}

	/* Draws the Stuff that you should keep closed most of the Time :-) */
	private void drawMouth(Graphics g,char c)
	{
		switch(c)
		{
			case ')' : 
				g.setColor(Color.black);
				g.drawArc((int)(Width*0.2),(Height/4),(int)(Width*0.6),Height/2,-20,-140);
				break;
			case '(' : 
				g.setColor(Color.black);
				g.drawArc((int)(Width*0.2),3*(Height/4),(int)(Width*0.6),Height/3,20,140);
				break;
			case '|' :
				g.setColor(Color.black);
				g.drawLine((int)(Width*0.2),3*(Height/4),(int)(Width*0.8),3*(Height/4)); 	
				break;
			case '8' ://angry smilie :-8
				g.setColor(Color.black);
				g.drawOval(Width/2,(int)(Height*0.1),Width/5,Height/4);
				g.drawOval(Width/4,(int)(Height*0.1),Width/5,Height/4);
				break;
			case 'o' :
				g.setColor(Color.black);
				g.drawOval(Width/3,(int)(Height*0.6),Width/3,Height/5);
				break;
			case 'O' :
				g.setColor(Color.black);
				g.drawOval(Width/4,(int)(Height*0.6),Width/2,Height/4);
				break;
			case 'P' :
				g.setColor(Color.black);
				g.drawArc((int)(Width*0.2),(Height/4),(int)(Width*0.6),Height/2,-20,-140);
				g.drawOval((int)(Width*0.6),(int)(Height*0.6),Width/4,Height/6);
				break;
			case 'p' :
				g.setColor(Color.black);
				g.drawArc((int)(Width*0.2),(Height/4),(int)(Width*0.6),Height/2,-20,-140);
				g.drawOval((int)(Width*0.6),(int)(Height*0.6),Width/4,Height/6);
				break;
			case 'S' :
				g.setColor(Color.black);
				g.drawArc((int)(Width*0.3),(int)(Height*0.6),(int)(Width*0.3),Height/2,40,120);					
				g.drawArc((int)(Width*0.5),(Height/4),(int)(Width*0.3),Height/2,-20,-120);
				break; 
			case '/' :
				g.setColor(Color.black);	
				g.drawLine((int)(Width*0.3),4*(Height/5),(int)(Width*0.7),3*(Height/5)); 	
				break;
			case 'X' :				
				g.setColor(Color.black);	
				g.drawLine((int)(Width*0.3),(int)(Height*0.8),(int)(Width*0.7),3*(Height/6));
				g.drawLine((int)(Width*0.3),Height/2,(int)(Width*0.7),4*(Height/5));	
				break;
			case '[' :
				g.setColor(Color.black);
				g.drawLine((int)(Width*0.2),(int)(Height*0.7),(int)(Width*0.2),(int)(Height*0.8));
				g.drawLine((int)(Width*0.2),3*(Height/4),(int)(Width*0.8),3*(Height/4));
				g.drawLine((int)(Width*0.8),(int)(Height*0.7),(int)(Width*0.8),(int)(Height*0.8));
				g.drawLine((int)(Width*0.4),(int)(Height*0.7),(int)(Width*0.2),(int)(Height*0.8));
				g.drawLine((int)(Width*0.6),(int)(Height*0.7),(int)(Width*0.8),(int)(Height*0.8));
				//g.drawLine(Width/4,Height/2-Height/8,Width/4,Height/2+Height/8);
				break;
			case 'L' :
				g.setColor(Color.black);
				g.drawLine((int)(Width*0.2),(int)(Height*0.7),(int)(Width*0.2),(int)(Height*0.8));
				g.drawLine((int)(Width*0.2),3*(Height/4),(int)(Width*0.8),3*(Height/4));
				g.drawLine((int)(Width*0.4),(int)(Height*0.7),(int)(Width*0.2),(int)(Height*0.8));
				break;		

			default : break;			
		}
	}

	/* Draws the Stuff that some have at their chin */
	private void drawBeards(Graphics g,char c)
	{
	/*	switch(c)
		{
			case '0' : 
				g.setColor(Color.black);
				g.drawOval(0,0,Width,Height/5);
				break;
			
			default : break;			
		}*/
	}

	/* This one is just for testing, it takes a smilie from the commandline
	 and writes it to a gif file. It also displays it in a frame */
	public static void main(String[] args)
	{
		if(args.length<1)
		{
			System.out.println("Geben Sie einen Smilie an");
			return;
		}
		final Smilie s = new Smilie();
		
		s.setSize(80,80);
		s.getSmilie(args[0]);

		JFrame jf = new JFrame();
		jf.getContentPane().setLayout(new BorderLayout());
		jf.getContentPane().add(new JLabel(args[0]),BorderLayout.NORTH);
		final Image gross = s.getImage();
		s.setSize(15,15);
		s.getSmilie(args[0]);
		final Image klein = s.getImage();
		JPanel jp = new JPanel()
		{
			public void paint(Graphics g)
			{
				g.drawImage(gross,30,30,this);
				g.drawImage(klein,120,30,this);
			}
				
		};
		jf.getContentPane().add(jp,BorderLayout.CENTER);
		jf.addWindowListener(
			new WindowAdapter()
			{
				public void windowClosing(WindowEvent we)
				{
					System.exit(0);
				}
			}
		);
		
		jf.setSize(300,300);
		jf.show();


	}
	
	
}
