// ViewMessageFrame.java

package smail.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import javax.swing.event.*;
import javax.swing.text.*;

/** The ViewMessageFrame class displays a window where is shown message.
 * There are given some possibilities work with, like reply on this message, forward it,
 * save, or delete it.
 * <br><br>
 */


public class ViewMessageFrame extends JFrame implements HyperlinkListener
{
    smail.Fassade fassade = null;

    MouseEvent mouseEvent = null;

    String sReplaceOld = "";

    String sPropertieFile = "";
    String sId = "";
    String sPath = "";
    String sAufruf = "";


    boolean bHeaderStatus = true;

    int iIndexOld = 0;
    String sFindOld = "";
    MessageContent content = null;

//    Vector vToAddresses = new Vector();
//    Vector vCcAddresses = new Vector();

    JPanel contentPane;



    // property-File for chosing language (view_lang_en for english, view_lang_de for german)
    private ResourceBundle resource = ResourceBundle.getBundle("smail/gui/view_lang_en");

    // getting the language specific textes for buttons, menus, etc from the property-file
    private String title = resource.getString("titleView_key");

    private String sMenuMessage = resource.getString("menuMessage_key");
    private String sMenuMessageReply = resource.getString("menuMessageReply_key");
    private String sMenuMessageReplyToAll = resource.getString("menuMessageReplyToAll_key");
    private String sMenuMessageInQuoting = resource.getString("menuMessageIncludingQuoting_key");
    private String sMenuMessageExQuoting = resource.getString("menuMessageExcludingQuoting_key");
    private String sMenuMessageForward = resource.getString("menuMessageForward_key");
    private String sMenuMessageNew = resource.getString("menuMessageNew_key");
    private String sMenuMessageUp = resource.getString("menuMessageUp_key");
    private String sMenuMessageDown = resource.getString("menuMessageDown_key");
    private String sMenuMessageDelete = resource.getString("menuMessageDelete_key");
    private String sMenuMessageMove = resource.getString("menuMessageMove_key");
    private String sMenuMessageClose = resource.getString("menuMessageClose_key");

    private String sMenuEdit = resource.getString("menuEdit_key");
    private String sMenuEditCopy = resource.getString("menuEditCopy_key");
    private String sMenuEditSelectAll = resource.getString("menuEditSelectAll_key");
    private String sMenuEditFind = resource.getString("menuEditFind_key");

    private String sMenuAttachment = resource.getString("menuAttachment_key");
    private String sMenuAttachmentSave = resource.getString("menuAttachmentSave_key");
    private String sMenuAttachmentOpen = resource.getString("menuAttachmentOpen_key");

    private String sMenuAddressbook = resource.getString("menuAddressbook_key");
    private String sMenuAddressbookAdd = resource.getString("menuAddressbookAdd_key");
    private String sMenuAddressbookOpen = resource.getString("menuAddressbookOpen_key");

    private String sWindow = resource.getString("menuWindow_key");
    private String sWindowFullHeader = resource.getString("menuWindowFullHeader_key");
    private String sWindowNoHeader = resource.getString("menuWindowNoHeader_key");

    private String sMenuHelp = resource.getString("menuHelp_key");
    private String sMenuHelpAbout = resource.getString("menuHelpAbout_key");

    // Popup Menus
    private String sPopupAttachmentSave = resource.getString("popupAttachmentSave_key");
    private String sPopupAttachmentOpen = resource.getString("popupAttachmentOpen_key");

    // Tooltips for Buttons
    private String sTooltipReply = resource.getString("tooltipReply_key");
    private String sTooltipForward = resource.getString("tooltipForward_key");
    private String sTooltipNew = resource.getString("tooltipNew_key");
    private String sTooltipCopy = resource.getString("tooltipCopy_key");
    //private String sTooltipSelectAll = resource.getString("tooltipSelectAll_key");
    private String sTooltipMove = resource.getString("tooltipMove_key");
    private String sTooltipCopyM = resource.getString("tooltipCopy_key");
    private String sTooltipDelete = resource.getString("tooltipDelete_key");
    private String sTooltipUp = resource.getString("tooltipUp_key");
    private String sTooltipDown = resource.getString("tooltipDown_key");
    private String sTooltipAttachment = resource.getString("tooltipAttachment_key");
    private String sTooltipAddressbook = resource.getString("tooltipAddressbook_key");
    private String sTooltipHeader = resource.getString("tooltipHeader_key");
    private String sTooltipHelp = resource.getString("tooltipHelp_key");

    private String sLabelTo = resource.getString("labelTo_key");
    private String sLabelFrom = resource.getString("labelFrom_key");
    private String sLabelDate = resource.getString("labelDate_key");
    private String sLabelCc = resource.getString("labelCc_key");
    private String sLabelSubject = resource.getString("labelSubject_key");


    // Menu
    JMenuBar jMenuBar1 = new JMenuBar();

    JMenu jMenuMessage = new JMenu(sMenuMessage);
    JMenu jMenuMessageReply = new JMenu(sMenuMessageReply);
      JMenuItem jMenuMessageReplyQuoting = new JMenuItem(sMenuMessageInQuoting);
      JMenuItem jMenuMessageReplyNoQuoting = new JMenuItem(sMenuMessageExQuoting);
    JMenu jMenuMessageReplyToAll = new JMenu(sMenuMessageReplyToAll);
      JMenuItem jMenuMessageReplyToAllQuoting = new JMenuItem(sMenuMessageInQuoting);
      JMenuItem jMenuMessageReplyToAllNoQuoting = new JMenuItem(sMenuMessageExQuoting);
    JMenuItem jMenuMessageForward = new JMenuItem(sMenuMessageForward);
    JMenuItem jMenuMessageNew = new JMenuItem(sMenuMessageNew);
    JMenuItem jMenuMessageDelete = new JMenuItem(sMenuMessageDelete);
    JMenuItem jMenuMessageMove = new JMenuItem(sMenuMessageMove);
    JMenuItem jMenuMessageUp = new JMenuItem(sMenuMessageUp);
    JMenuItem jMenuMessageDown = new JMenuItem(sMenuMessageDown);
    JMenuItem jMenuMessageClose = new JMenuItem(sMenuMessageClose);

    JMenu jMenuEdit = new JMenu(sMenuEdit);
    JMenuItem jMenuEditCopy = new JMenuItem(sMenuEditCopy);
    JMenuItem jMenuEditSelectAll = new JMenuItem(sMenuEditSelectAll);
    JMenuItem jMenuEditFind = new JMenuItem(sMenuEditFind);

    JMenu jMenuAttachment = new JMenu(sMenuAttachment);
    JMenuItem jMenuAttachmentSave = new JMenuItem(sMenuAttachmentSave);
    JMenuItem jMenuAttachmentOpen = new JMenuItem(sMenuAttachmentOpen);

    JMenu jMenuAddressbook = new JMenu(sMenuAddressbook);
    JMenuItem jMenuAddressbookAddSender = new JMenuItem(sMenuAddressbookAdd);
    JMenuItem jMenuAddressbookOpen = new JMenuItem(sMenuAddressbookOpen);

    JMenu jMenuWindow = new JMenu(sWindow);
    JMenuItem jMenuWindowFullHeader = new JMenuItem(sWindowFullHeader);
    JMenuItem jMenuWindowNoHeader = new JMenuItem(sWindowNoHeader);

    JMenu jMenuHelp = new JMenu(sMenuHelp);
    JMenuItem jMenuHelpHelp = new JMenuItem(sMenuHelp);
    JMenuItem jMenuHelpAbout = new JMenuItem(sMenuHelpAbout);


    // Popup Menus
    JPopupMenu jPopupMenuAttachments = new JPopupMenu();
    JMenuItem jPopupMenuAttachmentsSave = new JMenuItem(sPopupAttachmentSave);
    JMenuItem jPopupMenuAttachmentsOpen = new JMenuItem(sPopupAttachmentOpen);

    JPopupMenu jPopupMenuAddress = new JPopupMenu();
    JMenuItem jPopupMenuAddressEditor = new JMenuItem(sMenuMessageNew);
    JMenuItem jPopupMenuAddressAddressbook = new JMenuItem(sMenuAddressbookOpen);


    // Buttons
    JToolBar jToolBar = new JToolBar();
    JToolBar jToolBar1 = new JToolBar();

    JButton jButton1Reply = new JButton();
    JButton jButton2Forward = new JButton();
    JButton jButton3New = new JButton();
    JButton jButton4Copy = new JButton();
    JButton jButton5Move = new JButton();
    JButton jButton6CopyM = new JButton();
    JButton jButton7Delete = new JButton();
    JButton jButton8Up = new JButton();
    JButton jButton9Down = new JButton();
    JButton jButton10Attachment = new JButton();
    JButton jButton11Addressbook = new JButton();
    JButton jButton12FullHeader = new JButton();
    JButton jButton13Help = new JButton();

    ImageIcon image1;
    ImageIcon image2;
    ImageIcon image3;

    // oberer Bereich
    JLabel jLabelFrom = new JLabel(sLabelFrom);
    JLabel jLabelTo = new JLabel(sLabelTo);
    JLabel jLabelDate = new JLabel(sLabelDate);
    JLabel jLabelCc = new JLabel(sLabelCc);
    JLabel jLabelSubject = new JLabel(sLabelSubject);

    JTextField jTextFieldFrom = new JTextField();
    JTextField jTextFieldDate = new JTextField();
    JTextField jTextFieldSubject = new JTextField();

    JList jListTo = new JList();
    JList jListCc = new JList();


    // unterer Bereich
    JSplitPane jSplitPane1 = new JSplitPane();
    JScrollPane jScrollPane1 = new JScrollPane();
    JScrollPane jScrollPane2 = new JScrollPane();
    //JEditorPane jEditorPane1 = new JEditorPane();
    JTextPane jTextPane1 = new JTextPane();
    JList jListAttachments = new JList();

    JLabel statusBar = new JLabel();


  // Smiley-Hilfsfunktion
    private String changeHTMLSmilie(String sContent, java.net.URL SmilieFile) // sContent in html-format
    {
            // Smilies einbauen
            Smilie smilie = new Smilie();
            String sBefore = null;
            String sAfter = null;
            String sSmiley = null;

            //ReadFileByLines rfbl = new ReadFileByLines(SmilieFile);
            try {
	            java.io.BufferedReader rfbl = new java.io.BufferedReader(new java.io.InputStreamReader(SmilieFile.openStream()));
	            String sActualSmilie = rfbl.readLine(); // erste zeile holen der smilieliste holen
	            while (sActualSmilie != null)
	            {
	              int iIndex =  sContent.indexOf(sActualSmilie); // stelle des ersten smilies suchen
	              while (iIndex > -1)
	              {
	                  smilie.setSize(15,15);
	                  String sName = smilie.getSmilie(sActualSmilie); // pfad+dateiname holen
	                  if(sName!=null)
	                  {
		                  sSmiley = "<img src=\""+sName+"\">"; // erzeugen eines html-smileys
		                  sBefore = sContent.substring(0, iIndex);
		                  sAfter = sContent.substring(iIndex + sActualSmilie.length(), sContent.length());
		                  sContent = sBefore + sSmiley + sAfter;
		                  iIndex =  sContent.indexOf(sActualSmilie);
		              }
		              else break;    
	              }
	              sActualSmilie = rfbl.readLine(); // naechste zeile holen, dh. naechsten smiley holen
	            }
	            rfbl.close();
	        }
	        catch(java.io.IOException ioe)
	        {
	        	System.out.println("ViewMessageFrame: Problem reading Smilie.txt");
	        }	
            return sContent;
    }


    private String replaceHyperlink(String sText)
    {
        String sTempBig = sText.toUpperCase();
        String sTemp = sText;

        String sBefore = null;
        String sAfter = null;
        String sLink = null;
        String sHyperlink = null;
        String sNewText = sText;
        int iEnd = -1;

        int iIndex =  sTempBig.indexOf("HTTP://"); // stelle des ersten links suchen

        while (iIndex > -1)
        {
            iEnd = sTempBig.indexOf(" ",iIndex);

            if(sTempBig.indexOf("\n",iIndex)<iEnd)
            {
              iEnd = sTempBig.indexOf("\n",iIndex);
            }

            if(sTempBig.indexOf("<",iIndex)<iEnd)
            {
              iEnd = sTempBig.indexOf("<",iIndex);
            }

            if(iEnd==-1)
            {
              iEnd = sTempBig.length();
            }
            sLink = sTemp.substring(iIndex,iEnd);

            // noch kein echter Link!!!
            sHyperlink = "<a href=\""+sLink+"\">"+sLink+"</a>"; // erzeugen eines hyperlinks

            sBefore = sTemp.substring(0, iIndex);
            sAfter = sTemp.substring(iIndex+sLink.length(), sTemp.length()); //+7 damit http weg ist
            sNewText = sBefore + sHyperlink + sAfter;
            sTempBig = sNewText.toUpperCase();
            sTemp = sNewText;
            iIndex =  sTempBig.indexOf("HTTP://",iIndex+sHyperlink.length()); // weitersuchen
        }

      return sNewText;
    }



    private String replaceAddress(String sText)
    {
        String sTemp = sText;

        String sBefore = null;
        String sAfter = null;
        String sLink = null;
        String sHyperlink = null;
        String sNewText = sText;
        int iEnd = -1;
        int iBegin = -1;
        int iTemp = -1;

        int iIndex =  sTemp.indexOf("@"); // stelle des ersten links suchen

        while (iIndex > -1)
        {
            // Ende des Links finden
            iEnd = sTemp.indexOf(" ",iIndex);

            if(iEnd == -1)
            {
              iEnd = sTemp.length();
            }

            iTemp = sTemp.indexOf("\n",iIndex);

            if((iTemp>-1)&&(iTemp<iEnd))//sTemp.indexOf("\n",iIndex)<iEnd)
            {
              iEnd = sTemp.indexOf("\n",iIndex);
            }

            iTemp = sTemp.indexOf("<",iIndex);

            if((iTemp>-1)&&(iTemp<iEnd))//sTemp.indexOf("\n",iIndex)<iEnd)
            {
              iEnd = sTemp.indexOf("<",iIndex);
            }

            // Anfang des Links finden
            iBegin = sTemp.lastIndexOf(" ",iIndex);

            if(sTemp.lastIndexOf("\n",iIndex)>iBegin)
            {
              iBegin = sTemp.lastIndexOf("\n",iIndex);
            }

            if(sTemp.lastIndexOf(">",iIndex)>iBegin)
            {
              iBegin = sTemp.lastIndexOf(">",iIndex);
            }

            if(iBegin==-1)
            {
              iBegin = 0;
            }

            // adresse rausschneiden
            sLink = sTemp.substring(iBegin+1,iEnd);

            // LinkAdresse erzeugen
            sHyperlink = "<a href=\""+sLink+"\">"+sLink+"</a>";

            // Text zusammenfuegen mit Linkadresse
            sBefore = sTemp.substring(0, iBegin+1);
            sAfter = sTemp.substring(iEnd, sTemp.length());
            sNewText = sBefore + sHyperlink + sAfter;
            sTemp = sNewText;
            iIndex =  sTemp.indexOf("@",iIndex+sHyperlink.length());
        }

      return sNewText;
    }


    // Construct the frame
    public ViewMessageFrame(smail.Fassade fassade, String sPath, String sPropertieFile, String sId, MessageContent content)
    {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try
        {
            jbInit();
            this.fassade = fassade;
            this.content = content;
            this.sPath = sPath;
            this.sId = sId;

            String sTemp = content.getText().trim().toUpperCase();
            java.net.URL sTempResource = smail.gui.ViewMessageFrame.class.getResource("smilie.txt");//.toString().substring(5);

            javax.swing.text.html.HTMLEditorKit eKit = new javax.swing.text.html.HTMLEditorKit();
            jTextPane1.setEditorKit(eKit);

            if ((sTemp.indexOf("<HTML>")==0)||(sTemp.indexOf("<!DOCTYPE HTML")==0))
            {
              String sContent = changeHTMLSmilie(content.getText(), sTempResource); // linux: /user/home/...
              //sContent = replaceHyperlink(sContent);
              sContent = replaceAddress(sContent);
              jTextPane1.setText(sContent);
            }
            else
            {
	      jTextPane1.setText("<HTML><PRE>"+content.getText()+"</PRE></HTML>");
              String sContent = changeHTMLSmilie(jTextPane1.getText(),sTempResource);
              sContent = replaceHyperlink(sContent);
              sContent = replaceAddress(sContent);
              jTextPane1.setText(sContent);
            }

            jTextFieldFrom.setText(" "+content.getFrom());
            jTextFieldDate.setText(" "+content.getDate());
            jTextFieldSubject.setText(" "+content.getSubject());

            jListTo.setListData(content.getToAddresses());
            jListCc.setListData(content.getCcAddresses());
	      Vector listData = new Vector();	
	      try { 	
		      for(int i=0;i<content.getAttachments().size();i++)
      				listData.addElement(((javax.mail.BodyPart)content.getAttachments().elementAt(i)).getFileName());
		}	
		catch(javax.mail.MessagingException me)
		{
			System.out.println("Messaging Exception in ViewMessageFrame, initializing the FilenameStrings "+me);
		}		

            jListAttachments.setListData(listData);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }


    // By changing the size of the editor, some components, like Textfields, Lists, etc.
    // will change their size too. This is realized here.
    void contentPane_ancestorResized(HierarchyEvent e)
    {
        int hoehe = getSize().height;
        int breite = getSize().width;
        int divLoc = jSplitPane1.getDividerLocation();
        int divSize = jSplitPane1.getDividerSize();

        jSplitPane1.setBounds(new Rectangle(10, 185, breite-20, hoehe-185-60));
        jSplitPane1.setDividerLocation(hoehe-580 +(220));
        //jTextFieldTo.setText(""+divLoc);

        int untererBereich = jTextPane1.getSize().height;

        jTextFieldFrom.setBounds(new Rectangle(50, 40, (breite/2)-60, 20));
        jTextFieldDate.setBounds(new Rectangle((breite/2)+50, 40, (breite/2)-65, 20));
        jTextFieldSubject.setBounds(new Rectangle(75, 140, breite-90, 20));

        jLabelDate.setBounds(new Rectangle((breite/2)+10, 20, (breite/2)-20, 55));
        jLabelCc.setBounds(new Rectangle((breite/2)+10, 40, (breite/2)-20, 55));

        jListTo.setBounds(new Rectangle(50, 65, (breite/2)-60, 55));
        jListCc.setBounds(new Rectangle((breite/2)+50, 65, (breite/2)-65, 55));
    }

    // (Hilfsprozedur) Edit -> Replace
    void replace(String sFind, String sReplace)
    {
        int iIndex = -2;
        String sNewText = "";
        String sText = "";

        javax.swing.text.DefaultStyledDocument doc = (javax.swing.text.DefaultStyledDocument) jTextPane1.getStyledDocument();

        try
        {
            sText = doc.getText(0,doc.getLength());
        }
        catch(Exception e){System.out.println("ViewMessageFrame - Document holen  "+e);}

        iIndex = sText.indexOf(sFind,iIndexOld);

        if (iIndex > -1)
        {
            sNewText = sText.substring(0,iIndex) + sReplace + sText.substring(iIndex+sFind.length());

            jTextPane1.setText(sNewText);
            sFindOld = sFind;
            sReplaceOld = sReplace;
        }
    }



    // Component initialization
    private void jbInit() throws Exception
    {
        image1 = new ImageIcon(smail.gui.ViewMessageFrame.class.getResource("Images/openFile.png"));
        image2 = new ImageIcon(smail.gui.ViewMessageFrame.class.getResource("Images/closeFile.png"));
        image3 = new ImageIcon(smail.gui.ViewMessageFrame.class.getResource("Images/help.png"));

        Image image = new ImageIcon(getClass().getResource("Images/icon16.png")).getImage();
        this.setIconImage(image);

        contentPane = (JPanel) this.getContentPane();
        contentPane.setLayout(null);

        this.setSize(new Dimension(600, 550));
        this.setTitle(title);


        //
        //jTextPane1 = new JTextPane(doc);
        //javax.swing.text.html.HTMLEditorKit eKit = new javax.swing.text.html.HTMLEditorKit();

        //jTextPane1.setEditorKit(eKit);
        //jTextPane1.setText("<HTML><BODY>Blaaaaa</BODY></HTML>");
        //jTextPane1.setText("Blaaaaa &auml; \n text <br>jaaja <hr>");
        //

        statusBar.setText(" ");
        statusBar.setBounds(new Rectangle(51, 512, 400, 17));

        // Menu
        this.setJMenuBar(jMenuBar1);

        // Message

        //Reply to
        //Including Quoting
        jMenuMessageReplyQuoting.setAccelerator(javax.swing.KeyStroke.getKeyStroke(82, java.awt.event.KeyEvent.CTRL_MASK, false));
        jMenuMessageReplyQuoting.addActionListener(new ViewMessageFrame_jMenuMessageReplyQuoting_actionAdapter(this));
        //Excluding Quoting
        jMenuMessageReplyNoQuoting.setAccelerator(javax.swing.KeyStroke.getKeyStroke(82, java.awt.event.KeyEvent.ALT_MASK, false));
        jMenuMessageReplyNoQuoting.addActionListener(new ViewMessageFrame_jMenuMessageReplyNoQuoting_actionAdapter(this));

        //Reply to All
        // Including Quoting
        jMenuMessageReplyToAllQuoting.setAccelerator(javax.swing.KeyStroke.getKeyStroke(84, java.awt.event.KeyEvent.CTRL_MASK, false));
        jMenuMessageReplyToAllQuoting.addActionListener(new ViewMessageFrame_jMenuMessageReplyToAllQuoting_actionAdapter(this));
        // Excluding Quoting
        jMenuMessageReplyToAllNoQuoting.setAccelerator(javax.swing.KeyStroke.getKeyStroke(84, java.awt.event.KeyEvent.ALT_MASK, false));
        jMenuMessageReplyToAllNoQuoting.addActionListener(new ViewMessageFrame_jMenuMessageReplyToAllNoQuoting_actionAdapter(this));


        // Forward
        jMenuMessageForward.setAccelerator(javax.swing.KeyStroke.getKeyStroke(70, java.awt.event.KeyEvent.ALT_MASK, false));
        jMenuMessageForward.addActionListener(new ViewMessageFrame_jMenuMessageForward_actionAdapter(this));

        // New Message
        jMenuMessageNew.setAccelerator(javax.swing.KeyStroke.getKeyStroke(78, java.awt.event.KeyEvent.CTRL_MASK, false));
        jMenuMessageNew.addActionListener(new ViewMessageFrame_jMenuMessageNew_actionAdapter(this));

        // Delete
        jMenuMessageDelete.setAccelerator(javax.swing.KeyStroke.getKeyStroke(68, java.awt.event.KeyEvent.CTRL_MASK, false));

        // Move
        jMenuMessageMove.setAccelerator(javax.swing.KeyStroke.getKeyStroke(77, java.awt.event.KeyEvent.CTRL_MASK, false));

        // Up
        jMenuMessageUp.setAccelerator(javax.swing.KeyStroke.getKeyStroke(85, java.awt.event.KeyEvent.ALT_MASK, false));
        jMenuMessageUp.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageUp_actionPerformed(e);}});

        // Down
        jMenuMessageDown.setAccelerator(javax.swing.KeyStroke.getKeyStroke(68, java.awt.event.KeyEvent.ALT_MASK, false));
        jMenuMessageDown.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageDown_actionPerformed(e);}});

        // Close
        jMenuMessageClose.setAccelerator(javax.swing.KeyStroke.getKeyStroke(81, java.awt.event.KeyEvent.CTRL_MASK, false));
        jMenuMessageClose.addActionListener(new ViewMessageFrame_jMenuMessageClose_ActionAdapter(this));

        // Edit
        // Copy
        jMenuEditCopy.setAccelerator(javax.swing.KeyStroke.getKeyStroke(67, java.awt.event.KeyEvent.CTRL_MASK, false));
        jMenuEditCopy.addActionListener(new ViewMessageFrame_jMenuEditCopy_actionAdapter(this));

        // Select All
        jMenuEditSelectAll.setAccelerator(javax.swing.KeyStroke.getKeyStroke(65, java.awt.event.KeyEvent.CTRL_MASK, false));
        jMenuEditSelectAll.addActionListener(new ViewMessageFrame_jMenuEditSelectAll_actionAdapter(this));

        // Find
        jMenuEditFind.setAccelerator(javax.swing.KeyStroke.getKeyStroke(70, java.awt.event.KeyEvent.CTRL_MASK, false));
        jMenuEditFind.addActionListener(new ViewMessageFrame_jMenuEditFind_actionAdapter(this));

        // Attachment

        // Save Selected Attachement
        jMenuAttachmentSave.setAccelerator(javax.swing.KeyStroke.getKeyStroke(65, java.awt.event.KeyEvent.ALT_MASK, false));
        jMenuAttachmentSave.addActionListener(new ViewMessageFrame_jMenuAttachmentSave_actionAdapter(this));

        //Open Selected Attachment

        // Addressbook

        //Add Sender to Addressbook

        //Open Addressbook
        jMenuAddressbookOpen.setAccelerator(javax.swing.KeyStroke.getKeyStroke(66, java.awt.event.KeyEvent.CTRL_MASK, false));
        jMenuAddressbookOpen.addActionListener(new ViewMessageFrame_jMenuAddressbookOpen_actionAdapter(this));

        // Window
        //View full Header
        jMenuWindowFullHeader.setAccelerator(javax.swing.KeyStroke.getKeyStroke(72, java.awt.event.KeyEvent.CTRL_MASK, false));
        jMenuWindowFullHeader.addActionListener(new ViewMessageFrame_jMenuWindowFullHeader_actionAdapter(this));
        jMenuWindowNoHeader.setEnabled(false);

        //View no Header
        jMenuWindowNoHeader.setAccelerator(javax.swing.KeyStroke.getKeyStroke(72, java.awt.event.KeyEvent.ALT_MASK, false));
        jMenuWindowNoHeader.addActionListener(new ViewMessageFrame_jMenuWindowNoHeader_actionAdapter(this));

        // Help
        //jMenuHelp.setText("Help");
        // Help
        jMenuHelpHelp.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F1,0, false));
        jMenuHelpHelp.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){jMenuHelpHelp_actionPerformed(e);}});
        //jMenuHelpAbout.setText("About");
        jMenuHelpAbout.addActionListener(new ViewMessageFrame_jMenuHelpAbout_ActionAdapter(this));

        // Popup menus
        jPopupMenuAttachmentsSave.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAttachmentSave_actionPerformed(e);}});
        jPopupMenuAddressEditor.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jPopupMenuAddressEditor_actionPerformed(e);}});
        jPopupMenuAddressAddressbook.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAddressbookOpen_actionPerformed(e);}});

        jTextPane1.addMouseListener(new java.awt.event.MouseAdapter(){public void mousePressed(MouseEvent e){jTextPane1_mousePressed(e);}});
        jListAttachments.addMouseListener(new java.awt.event.MouseAdapter(){public void mousePressed(MouseEvent e){jListAttachments_mousePressed(e);}});

        contentPane.addHierarchyBoundsListener(new ViewMessageFrame_contentPane_hierarchyBoundsAdapter(this));

        // Add Menus to Menubar
    jMenuBar1.add(jMenuMessage);
        jMenuBar1.add(jMenuEdit);
        jMenuBar1.add(jMenuAttachment);
        jMenuBar1.add(jMenuAddressbook);
        jMenuBar1.add(jMenuWindow);
        jMenuBar1.add(jMenuHelp);

        // Add MenuItems to Menus
        jMenuMessage.add(jMenuMessageReply);
            jMenuMessageReply.add(jMenuMessageReplyQuoting);
            jMenuMessageReply.add(jMenuMessageReplyNoQuoting);
        jMenuMessage.add(jMenuMessageReplyToAll);
            jMenuMessageReplyToAll.add(jMenuMessageReplyToAllQuoting);
            jMenuMessageReplyToAll.add(jMenuMessageReplyToAllNoQuoting);
        jMenuMessage.add(jMenuMessageForward);
        jMenuMessage.add(jMenuMessageNew);
        jMenuMessage.addSeparator();
        jMenuMessage.add(jMenuMessageUp);
        jMenuMessage.add(jMenuMessageDown);
        jMenuMessage.addSeparator();
        jMenuMessage.add(jMenuMessageDelete);
        jMenuMessage.add(jMenuMessageMove);
        jMenuMessage.addSeparator();
        jMenuMessage.add(jMenuMessageClose);

        jMenuEdit.add(jMenuEditCopy);
        jMenuEdit.add(jMenuEditSelectAll);
        jMenuEdit.add(jMenuEditFind);

        jMenuAttachment.add(jMenuAttachmentSave);
        jMenuAttachment.add(jMenuAttachmentOpen);

        jMenuAddressbook.add(jMenuAddressbookAddSender);
        jMenuAddressbook.add(jMenuAddressbookOpen);

        jMenuWindow.add(jMenuWindowFullHeader);
        jMenuWindow.add(jMenuWindowNoHeader);

        jMenuHelp.add(jMenuHelpHelp);
        jMenuHelp.add(jMenuHelpAbout);

        // Popup Menu
        //jPopupMenuAttachmentsSave.setText("Save Attachment");
        //jPopupMenuAttachmentsSave.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAttachmentSave_actionPerformed(e);}});
        //jPopupMenuAttachmentsOpen.setText("Open Attachment");
        //jPopupMenuAttachmentsOpen.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAttachmentOpen_actionPerformed(e);}});

        jPopupMenuAttachments.add(jPopupMenuAttachmentsSave);
        jPopupMenuAttachments.add(jPopupMenuAttachmentsOpen);

        jPopupMenuAddress.add(jPopupMenuAddressEditor);
        jPopupMenuAddress.add(jPopupMenuAddressAddressbook);


        // Buttons
        jToolBar1.setBorderPainted(false);
        jToolBar1.setBounds(new Rectangle(460, 5, 50, 30));

        jToolBar.setBorderPainted(false);
        jToolBar.setBounds(new Rectangle(10, 5, 440, 30));

        // Setting Images, Tooltips,Sizes, ActionListeners to the Buttons
        jButton1Reply.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/reply.png")));
        jButton1Reply.setToolTipText(sTooltipReply);
        jButton1Reply.setPreferredSize(new Dimension(27, 27));
        jButton1Reply.addActionListener(new ViewMessageFrame_jButton1Reply_actionAdapter(this));

        jButton2Forward.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/forward.png")));
        jButton2Forward.setToolTipText(sTooltipForward);
        jButton2Forward.setPreferredSize(new Dimension(27, 27));
        jButton2Forward.addActionListener(new ViewMessageFrame_jButton2Forward_actionAdapter(this));

        jButton3New.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/new.png")));
        jButton3New.setToolTipText(sTooltipNew);
        jButton3New.setPreferredSize(new Dimension(27, 27));
        jButton3New.addActionListener(new ViewMessageFrame_jButton3New_actionAdapter(this));

        jButton4Copy.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/copy.png")));
        jButton4Copy.setToolTipText(sTooltipCopy);
        jButton4Copy.setPreferredSize(new Dimension(27, 27));
        jButton4Copy.addActionListener(new ViewMessageFrame_jButton4Copy_actionAdapter(this));

        jButton5Move.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/move.png")));
        jButton5Move.setToolTipText(sTooltipMove);
        jButton5Move.setPreferredSize(new Dimension(27, 27));

        jButton6CopyM.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/copym.png")));
        jButton6CopyM.setToolTipText(sTooltipCopy);
        jButton6CopyM.setPreferredSize(new Dimension(27, 27));

        jButton7Delete.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/delete.png")));
        jButton7Delete.setToolTipText(sTooltipDelete);
        jButton7Delete.setPreferredSize(new Dimension(27, 27));

        jButton8Up.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/up.png")));
        jButton8Up.setToolTipText(sTooltipUp);
        jButton8Up.setPreferredSize(new Dimension(27, 27));
        jButton8Up.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageUp_actionPerformed(e);}});

        jButton9Down.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/down.png")));
        jButton9Down.setToolTipText(sTooltipDown);
        jButton9Down.setPreferredSize(new Dimension(27, 27));
        jButton9Down.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuMessageDown_actionPerformed(e);}});

        jButton10Attachment.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/attachment.png")));
        jButton10Attachment.setToolTipText(sTooltipAttachment);
        jButton10Attachment.setPreferredSize(new Dimension(27, 27));
        jButton10Attachment.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jMenuAttachmentSave_actionPerformed(e);}});

        jButton11Addressbook.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/addressbok.png")));
        jButton11Addressbook.setToolTipText(sTooltipAddressbook);
        jButton11Addressbook.setPreferredSize(new Dimension(27, 27));
        jButton11Addressbook.addActionListener(new ViewMessageFrame_jButton11Addressbook_actionAdapter(this));

        jButton12FullHeader.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/header.png")));
        jButton12FullHeader.setToolTipText(sTooltipHeader);
        jButton12FullHeader.setPreferredSize(new Dimension(27, 27));
        jButton12FullHeader.addActionListener(new ViewMessageFrame_jButton12FullHeader_actionAdapter(this));

        //jButton13Help.setIcon(image3);
        jButton13Help.setIcon(new ImageIcon(ViewMessageFrame.class.getResource("Images/help.png")));
        jButton13Help.setToolTipText(sTooltipHelp);
        jButton13Help.setPreferredSize(new Dimension(27, 27));
        jButton13Help.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){jMenuHelpHelp_actionPerformed(e);}});

        // Adding Buttons to the Toolbars
        jToolBar.add(jButton1Reply);
        jToolBar.add(jButton2Forward);
        jToolBar.add(jButton3New, null);
        jToolBar.add(jButton4Copy, null);
        jToolBar.add(jButton5Move, null);
        jToolBar.add(jButton6CopyM, null);
        jToolBar.add(jButton7Delete, null);
        jToolBar.add(jButton8Up, null);
        jToolBar.add(jButton9Down, null);
        jToolBar.add(jButton10Attachment, null);
        jToolBar.add(jButton11Addressbook, null);
        jToolBar.add(jButton12FullHeader, null);
        jToolBar1.add(jButton13Help, null);



        // oberer Bereich

        // Labels sizes
        jLabelFrom.setBounds(new Rectangle(10, 40, 50, 20));
        jLabelTo.setBounds(new Rectangle(10, 65, 60, 20));
        jLabelDate.setBounds(new Rectangle(310, 40, 50, 20));
        jLabelCc.setBounds(new Rectangle(310, 65, 60, 20));
        jLabelSubject.setBounds(new Rectangle(10, 140, 65, 20));

        // TextFields
        // Color, Editability, Size
        jTextFieldFrom.setBackground(Color.lightGray);
        jTextFieldFrom.setEditable(false);
        jTextFieldFrom.setBounds(new Rectangle(50, 40, 240, 20));

        jTextFieldDate.setBackground(Color.lightGray);
        jTextFieldDate.setEditable(false);
        jTextFieldDate.setBounds(new Rectangle(350, 40, 240, 20));

        jTextFieldSubject.setBackground(Color.lightGray);
        jTextFieldSubject.setEditable(false);
        jTextFieldSubject.setBounds(new Rectangle(70, 140, 520, 20));

        // Lists
        jListTo.setBackground(Color.white);
        jListTo.setBorder(BorderFactory.createEtchedBorder());
        jListTo.setBounds(new Rectangle(50, 70, 240, 55));

        jListCc.setBackground(Color.white);
        jListCc.setBorder(BorderFactory.createEtchedBorder());
        jListCc.setBounds(new Rectangle(350, 70, 240, 55));



        // unterer Bereich
        jSplitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setBounds(new Rectangle(10, 185, 580, 300));
        jSplitPane1.setDividerLocation(220);

        jTextPane1.setBackground(Color.white);
        jTextPane1.setSelectionColor(SystemColor.black);
        jTextPane1.setEditable(false);
        jTextPane1.setBorder(BorderFactory.createEtchedBorder());
        jTextPane1.setFont(new java.awt.Font("Serif", 0, 13));

        jListAttachments.setBackground(Color.white);
        jListAttachments.setBorder(BorderFactory.createEtchedBorder());
        //jListAttachments.setBounds(new Rectangle(385, 32, 270, 48));

        jSplitPane1.add(jScrollPane1, JSplitPane.LEFT);
        jScrollPane1.getViewport().add(jTextPane1, null);
        jSplitPane1.add(jScrollPane2, JSplitPane.RIGHT);
        jScrollPane2.getViewport().add(jListAttachments, null);


        // Add components to the contentPane

        // ToolBars
        contentPane.add(jToolBar, null);
        contentPane.add(jToolBar1, null);
        // Labels
        contentPane.add(jLabelFrom, null);
        contentPane.add(jLabelDate, null);
        contentPane.add(jLabelTo, null);
        contentPane.add(jLabelCc, null);
        contentPane.add(jLabelSubject, null);
        // TextFields
        contentPane.add(jTextFieldFrom, null);
        contentPane.add(jTextFieldSubject, null);
        contentPane.add(jTextFieldDate, null);
        //Lists
        contentPane.add(jListTo, null);
        contentPane.add(jListCc, null);
        // SplitPane
        contentPane.add(jSplitPane1, null);

        contentPane.add(statusBar, null);

        jTextPane1.addHyperlinkListener(this);
        jTextPane1.setEditable(false);
    }

    public void hyperlinkUpdate(HyperlinkEvent event)
    {
      if (event.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
      {
          System.out.println("URL: "+event.getDescription());

          sAufruf = event.getDescription(); // global machen
          String sAufrufLowerCase = sAufruf.toLowerCase();
          if ((sAufrufLowerCase.indexOf("http")!= -1)||(sAufrufLowerCase.indexOf("file")!= -1))
          {
            Internet browser = new Internet(sAufruf);
            browser.show(sAufruf);
          }
          else
          {
            if ((mouseEvent.getModifiers() != InputEvent.BUTTON1_MASK))
            {
              // rechte Maustaste
              jPopupMenuAddress.show(mouseEvent.getComponent(), mouseEvent.getX(), mouseEvent.getY());
            }
            else
            {
              // linke Maustaste
              EditorFrame editor = new EditorFrame(fassade,"pfad/zur/PropertieDatei.txt", "id", "bla@bla.de",sAufruf);
              editor.show();
            }
          }
      }
    }


    // Performances of the Actions
    // Prozeduren zu den einzelnen Menupunkten


    // Menu Message

    // Message -> Reply -> Include Quoting
    void jMenuMessageReplyQuoting_actionPerformed(ActionEvent e)
    {
        javax.swing.text.DefaultStyledDocument doc = (javax.swing.text.DefaultStyledDocument) jTextPane1.getStyledDocument();
        String sText =" ";
        try
        {
          sText = doc.getText(0,doc.getLength());
        }
        catch(Exception ex){System.out.println("ViewMessageFrame - Reply - Document holen  "+ex);}
        Vector vToAddress = new Vector();
        vToAddress.add(jTextFieldFrom.getText());

        MessageContent content = new MessageContent("bla@bla.de",jTextFieldDate.getText(),vToAddress, new Vector(),jTextFieldSubject.getText(),sText);

        EditorFrame editor = new EditorFrame(fassade,"pfad/zur/PropertieDatei.txt", "id", "bla@bla.de",content);
        //editor.jTextPane1.requestFocus();
        editor.show();
    }

    // Message -> Reply -> Exclude Quoting
    void jMenuMessageReplyNoQuoting_actionPerformed(ActionEvent e)
    {
        Vector vToAddress = new Vector();
        vToAddress.add(jTextFieldFrom.getText());

        MessageContent content = new MessageContent("bla@bla.de",jTextFieldDate.getText(),vToAddress, new Vector(),jTextFieldSubject.getText(),"");

        EditorFrame editor = new EditorFrame(fassade,"pfad/zur/PropertieDatei.txt", "id", "bla@bla.de",content);
        editor.show();
    }


    // Message -> Reply To All -> Include Quoting
    void jMenuMessageReplyToAllQuoting_actionPerformed(ActionEvent e)
    {
        javax.swing.text.DefaultStyledDocument doc = (javax.swing.text.DefaultStyledDocument) jTextPane1.getStyledDocument();
        String sText =" ";
        try
        {
          sText = doc.getText(0,doc.getLength());
        }
        catch(Exception ex){System.out.println("ViewMessageFrame - Reply to All - Document holen  "+ex);}


        Vector vToAddress = new Vector();

        vToAddress.add(jTextFieldFrom.getText());

        for(int iCounter = 0;iCounter < content.getToAddresses().size();iCounter++)
        {
            vToAddress.add(content.getToAddresses().elementAt(iCounter));
        }

        for(int iCounter = 0;iCounter < content.getCcAddresses().size();iCounter++)
        {
            vToAddress.add(content.getCcAddresses().elementAt(iCounter));
        }

        MessageContent content = new MessageContent("bla@bla.de",jTextFieldDate.getText(),vToAddress, new Vector(),jTextFieldSubject.getText(),sText);
        EditorFrame editor = new EditorFrame(fassade,"pfad/zur/PropertieDatei.txt", "id", "bla@bla.de",content);

        editor.show();
    }

    // Message -> Reply To All-> Exclude Quoting
    void jMenuMessageReplyToAllNoQuoting_actionPerformed(ActionEvent e)
    {
        Vector vToAddress = new Vector();

        vToAddress.add(jTextFieldFrom.getText());

        for(int iCounter = 0;iCounter < content.getToAddresses().size();iCounter++)
        {
            vToAddress.add(content.getToAddresses().elementAt(iCounter));
        }

        for(int iCounter = 0;iCounter < content.getCcAddresses().size();iCounter++)
        {
            vToAddress.add(content.getCcAddresses().elementAt(iCounter));
        }

        MessageContent content = new MessageContent("bla@bla.de",jTextFieldDate.getText(),vToAddress, new Vector(),jTextFieldSubject.getText(),"");

        EditorFrame editor = new EditorFrame(fassade,"pfad/zur/PropertieDatei.txt", "id", "bla@bla.de",content);
        editor.show();
    }


    // Message -> Forward
    void jMenuMessageForward_actionPerformed(ActionEvent e)
    {

        javax.swing.text.DefaultStyledDocument doc = (javax.swing.text.DefaultStyledDocument) jTextPane1.getStyledDocument();
        String sText =" ";
        try
        {
          sText = doc.getText(0,doc.getLength());
        }
        catch(Exception ex){System.out.println("ViewMessageFrame - Forward - Document holen  "+ex);}


        //MessageContent(String sSubject, String sHeader, String sText, Vector vAttachments)

        MessageContent forwardContent = new MessageContent(jTextFieldSubject.getText(),content.getHeader(),/*content.getText()*/sText, content.getAttachments());
        EditorFrame editor = new EditorFrame(fassade,"pfad/zur/PropertieDatei.txt", "id", "bla@bla.de",forwardContent,"forward");

        editor.show();
    }


    // Message -> New Message
    void jMenuMessageNew_actionPerformed(ActionEvent e)
    {
        EditorFrame editor = new EditorFrame(fassade,"pfad/zur/PropertieDatei.txt", "id", "bla@bla.de");
        editor.show();
    }


    // Message -> Up
    void jMenuMessageUp_actionPerformed(ActionEvent e)
    {
      //smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
      smail.DummyFassade dm = new smail.DummyFassade(); // anstatt Originalfassade
      smail.DummyFolderContent fc = (smail.DummyFolderContent) dm.getFolderContent(sPath);
      smail.MessageHeader[] mh = null;
      mh = fc.getMessageHeader();

      int laenge = mh.length;

      int iMsgId =  Integer.parseInt(sId);
      System.out.println(sId);
      iMsgId=iMsgId-1;

      if (iMsgId < 0)
      {
        iMsgId = 0;
      }
      if (iMsgId >= laenge)
      {
        iMsgId = laenge-1;
      }

      sId = iMsgId+"";
      smail.gui.MessageContent content = dm.openMail(iMsgId,sPath);

      String sTemp = content.getText().trim().toUpperCase();
      java.net.URL sTempResource = smail.gui.ViewMessageFrame.class.getResource("smilie.txt");

      javax.swing.text.html.HTMLEditorKit eKit = new javax.swing.text.html.HTMLEditorKit();
      jTextPane1.setEditorKit(eKit);

      if ((sTemp.indexOf("<HTML>")==0)||(sTemp.indexOf("<!DOCTYPE HTML")==0))
      {
          String sContent = changeHTMLSmilie(content.getText(), sTempResource); // linux: /user/home/...
          //sContent = replaceHyperlink(sContent);
           sContent = replaceAddress(sContent);
           jTextPane1.setText(sContent);
      }
      else
      {
          jTextPane1.setText("<HTML><PRE>"+content.getText()+"</PRE></HTML>");
          String sContent = changeHTMLSmilie(jTextPane1.getText(),sTempResource);
          sContent = replaceHyperlink(sContent);
          sContent = replaceAddress(sContent);
          jTextPane1.setText(sContent);
      }

      jTextFieldFrom.setText(" "+content.getFrom());
      jTextFieldDate.setText(" "+content.getDate());
      jTextFieldSubject.setText(" "+content.getSubject());

      jListTo.setListData(content.getToAddresses());
      jListCc.setListData(content.getCcAddresses());

      Vector listData = new Vector();	
      try { 	
	      for(int i=0;i<content.getAttachments().size();i++)
      			listData.addElement(((javax.mail.BodyPart)content.getAttachments().elementAt(i)).getFileName());
	}	
	catch(javax.mail.MessagingException me)
	{
		System.out.println("Messaging Exception in ViewMessageFrame, initializing the FilenameStrings "+me);
	}		

      jListAttachments.setListData(listData);
  }


  // Message -> Down
  void jMenuMessageDown_actionPerformed(ActionEvent e)
  {
    //smail.gui.MessageContent mc = face.openMail(iMsgNr,sFolder);
    smail.DummyFassade dm = new smail.DummyFassade(); // anstatt Originalfassade
    smail.DummyFolderContent fc = (smail.DummyFolderContent) dm.getFolderContent(sPath);
    smail.MessageHeader[] mh = null;
    mh = fc.getMessageHeader();

    int laenge = mh.length;

    int iMsgId =  Integer.parseInt(sId);
    System.out.println(sId);
    iMsgId=iMsgId+1;

    if (iMsgId < 0)
    {
      iMsgId = 0;
    }
    if (iMsgId >= laenge)
    {
      iMsgId = laenge-1;
    }

    sId = iMsgId+"";
    smail.gui.MessageContent content = dm.openMail(iMsgId,sPath);


    String sTemp = content.getText().trim().toUpperCase();
    java.net.URL sTempResource = smail.gui.ViewMessageFrame.class.getResource("smilie.txt");

    javax.swing.text.html.HTMLEditorKit eKit = new javax.swing.text.html.HTMLEditorKit();
    jTextPane1.setEditorKit(eKit);

    if ((sTemp.indexOf("<HTML>")==0)||(sTemp.indexOf("<!DOCTYPE HTML")==0))
    {
        String sContent = changeHTMLSmilie(content.getText(), sTempResource); // linux: /user/home/...
        //sContent = replaceHyperlink(sContent);
        sContent = replaceAddress(sContent);
        jTextPane1.setText(sContent);
    }
    else
    {
        jTextPane1.setText("<HTML><PRE>"+content.getText()+"</PRE></HTML>");
        String sContent = changeHTMLSmilie(jTextPane1.getText(),sTempResource);
        sContent = replaceHyperlink(sContent);
        sContent = replaceAddress(sContent);
        jTextPane1.setText(sContent);
      }

      jTextFieldFrom.setText(" "+content.getFrom());
      jTextFieldDate.setText(" "+content.getDate());
      jTextFieldSubject.setText(" "+content.getSubject());

      jListTo.setListData(content.getToAddresses());
      jListCc.setListData(content.getCcAddresses());
	
      Vector listData = new Vector();	
      try { 	
	      for(int i=0;i<content.getAttachments().size();i++)
      			listData.addElement(((javax.mail.BodyPart)content.getAttachments().elementAt(i)).getFileName());
	}	
	catch(javax.mail.MessagingException me)
	{
		System.out.println("Messaging Exception in ViewMessageFrame, initializing the FilenameStrings "+me);
	}		
	
      jListAttachments.setListData(listData);
    }


    // Message -> Close
    public void jMenuMessageClose_actionPerformed(ActionEvent e)
    {
        dispose();
    }


    // Menu Edit
    // Edit -> Copy
    void jMenuEditCopy_actionPerformed(ActionEvent e)
    {
        jTextPane1.copy();
    }

    // Edit -> Select All
    void jMenuEditSelectAll_actionPerformed(ActionEvent e)
    {
        jTextPane1.selectAll();
    }

    // (Hilfsprozedur) Edit -> Find
    void find(String sFind)
    {
        int iIndex = -2;
        String sText = "";

        javax.swing.text.DefaultStyledDocument doc = (javax.swing.text.DefaultStyledDocument) jTextPane1.getStyledDocument();

        try
        {
            sText = doc.getText(0,doc.getLength());
        }
        catch(Exception e){System.out.println("ViewMessageFrame - Find - Document holen  "+e);}

        iIndex = sText.indexOf(sFind,iIndexOld);
        if (iIndex > -1)
        {
            jTextPane1.select(iIndex,iIndex + sFind.length());

            iIndexOld = iIndex + 1;
            sFindOld = sFind;
        }
        else
        {
            iIndexOld = 0;
            iIndex = 0;
        }
    }


    // Edit -> Find
    void jMenuEditFind_actionPerformed(ActionEvent e)
    {
        FindFrame find = new FindFrame(sFindOld);
        find.show();

        if(find.bFindStatus == true)
        {
            String sFind = find.sFind;
            int iIndex = -2;

            // bei neuer Textsuche wird wieder am Anfang des Textes gesucht
            if (sFindOld.equals(sFind)== false)
            {
                iIndex = 0;
                iIndexOld = 0;
            }
            find(sFind);
        }
    }

    // Menu Attachment
    // Attachment -> Save Attachment
    void jMenuAttachmentSave_actionPerformed(ActionEvent e)
    {
	int selAtt=jListAttachments.getSelectedIndex();
    	JFileChooser chooser = new JFileChooser();
	javax.mail.BodyPart bp =((javax.mail.BodyPart)content.getAttachments().elementAt(selAtt));
	chooser.setCurrentDirectory(new java.io.File(System.getProperties().getProperty("user.dir")));
	chooser.setDialogTitle("Save Attachment");
	try {
		chooser.setSelectedFile(new java.io.File(bp.getFileName()));
		int returnVal = chooser.showSaveDialog(this);
		if(returnVal == JFileChooser.APPROVE_OPTION) 
		{
			try {
				byte[] bytes=new byte[bp.getInputStream().available()];
				bp.getInputStream().read(bytes);
				java.io.FileOutputStream fos = new java.io.FileOutputStream(chooser.getSelectedFile());	
				fos.write(bytes);
			}
			catch(Exception ex2)
			{
				System.out.println("ViewMessageFrame :Konnte Datei nicht speichern wegen :");
				ex2.printStackTrace();	
			}
		}
	}
	catch(javax.mail.MessagingException me)
	{
		System.out.println("Messaging Exception in ViewMessageFrame "+me);
	}		
    }


    // Menu Addressbook
    // Addressbook -> Open Addressbook
    void jMenuAddressbookOpen_actionPerformed(ActionEvent e)
    {
        Addressbook book = new Addressbook(fassade);
        book.show();
    }


    // Menu Window
    // Window -> Full Header
    void jMenuWindowFullHeader_actionPerformed(ActionEvent e)
    {
        if (bHeaderStatus == true)
        {
            bHeaderStatus = false;
            jMenuWindowFullHeader.setEnabled(false);
            jMenuWindowNoHeader.setEnabled(true);
            jTextPane1.setText(content.getHeader()+"\n\n"+jTextPane1.getText());
        }
    }

    // Window -> No Header
    void jMenuWindowNoHeader_actionPerformed(ActionEvent e)
    {
        String sTemp = content.getText().trim().toUpperCase();
        java.net.URL sTempResource = smail.gui.ViewMessageFrame.class.getResource("smilie.txt");

        if (bHeaderStatus == false)
        {
            bHeaderStatus = true;
            jMenuWindowFullHeader.setEnabled(true);
            jMenuWindowNoHeader.setEnabled(false);

            if ((sTemp.indexOf("<HTML>")==0)||(sTemp.indexOf("<!DOCTYPE HTML")==0))
            {
              String sContent = changeHTMLSmilie(content.getText(), sTempResource); // linux: /user/home/...
              //sContent = replaceHyperlink(sContent);
              //sContent = replaceAddress(sContent);
              jTextPane1.setText(sContent);
            }
            else
            {
	      jTextPane1.setText("<HTML><PRE>"+content.getText()+"</PRE></HTML>");
              String sContent = changeHTMLSmilie(jTextPane1.getText(),sTempResource);
              sContent = replaceHyperlink(sContent);
              sContent = replaceAddress(sContent);
              jTextPane1.setText(sContent);
            }
        }
    }

    // Menu Help


    // Help -> Help
    public void jMenuHelpHelp_actionPerformed(ActionEvent e)
    {
        String sTempResource = smail.gui.EditorFrame.class.getResource("help.html").toString();//.substring(5);
        Internet browser = new Internet(sTempResource);
        browser.show(sTempResource);
    }



    // Help -> About
    public void jMenuHelpAbout_actionPerformed(ActionEvent e)
    {
        final JFrame f = new AboutFrame();
    }


    // Popup Menu Attachments
    void jListAttachments_mousePressed(MouseEvent e)
    {
      if ((e.getModifiers() != InputEvent.BUTTON1_MASK))
      {
        System.out.println("Nicht die linke maustaste");
        jPopupMenuAttachments.show(e.getComponent(), e.getX(), e.getY());
      }
      else
      {
        System.out.println("linke maustaste");
      }
    }

    // speichern des Mouseevents (fuer hyperlink popup)
    void jTextPane1_mousePressed(MouseEvent e)
    {
      mouseEvent = e;
    }


    // Popup Address -> Editor
    void jPopupMenuAddressEditor_actionPerformed(ActionEvent e)
    {
        EditorFrame editor = new EditorFrame(fassade,"pfad/zur/PropertieDatei.txt", "id", "bla@bla.de",sAufruf);
        editor.show();
    }

    /**Overridden so we can exit when window is closed*/
    protected void processWindowEvent(WindowEvent e)
    {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING)
        {
            jMenuMessageClose_actionPerformed(null);
        }
    }
}



class ViewMessageFrame_jMenuMessageClose_ActionAdapter implements ActionListener {
  ViewMessageFrame adaptee;

  ViewMessageFrame_jMenuMessageClose_ActionAdapter(ViewMessageFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuMessageClose_actionPerformed(e);
  }
}

class ViewMessageFrame_jMenuHelpAbout_ActionAdapter implements ActionListener {
  ViewMessageFrame adaptee;

  ViewMessageFrame_jMenuHelpAbout_ActionAdapter(ViewMessageFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuHelpAbout_actionPerformed(e);
  }
}

class ViewMessageFrame_jMenuMessageReplyQuoting_actionAdapter implements java.awt.event.ActionListener
{
  ViewMessageFrame adaptee;

  ViewMessageFrame_jMenuMessageReplyQuoting_actionAdapter(ViewMessageFrame adaptee)
  {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e)
  {
    adaptee.jMenuMessageReplyQuoting_actionPerformed(e);
  }
}

class ViewMessageFrame_jMenuMessageNew_actionAdapter implements java.awt.event.ActionListener
{
  ViewMessageFrame adaptee;

  ViewMessageFrame_jMenuMessageNew_actionAdapter(ViewMessageFrame adaptee)
  {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e)
  {
    adaptee.jMenuMessageNew_actionPerformed(e);
  }
}

class ViewMessageFrame_jMenuEditCopy_actionAdapter implements java.awt.event.ActionListener
{
  ViewMessageFrame adaptee;

  ViewMessageFrame_jMenuEditCopy_actionAdapter(ViewMessageFrame adaptee)
  {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e)
  {
    adaptee.jMenuEditCopy_actionPerformed(e);
  }
}

class ViewMessageFrame_jMenuEditSelectAll_actionAdapter implements java.awt.event.ActionListener
{
  ViewMessageFrame adaptee;

  ViewMessageFrame_jMenuEditSelectAll_actionAdapter(ViewMessageFrame adaptee)
  {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e)
  {
    adaptee.jMenuEditSelectAll_actionPerformed(e);
  }
}

class ViewMessageFrame_jMenuEditFind_actionAdapter implements java.awt.event.ActionListener
{
  ViewMessageFrame adaptee;

  ViewMessageFrame_jMenuEditFind_actionAdapter(ViewMessageFrame adaptee)
  {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e)
  {
    adaptee.jMenuEditFind_actionPerformed(e);
  }
}

class ViewMessageFrame_jMenuAttachmentSave_actionAdapter implements java.awt.event.ActionListener
{
  ViewMessageFrame adaptee;

  ViewMessageFrame_jMenuAttachmentSave_actionAdapter(ViewMessageFrame adaptee)
  {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e)
  {
    adaptee.jMenuAttachmentSave_actionPerformed(e);
  }
}

class ViewMessageFrame_jMenuWindowFullHeader_actionAdapter implements java.awt.event.ActionListener
{
  ViewMessageFrame adaptee;

  ViewMessageFrame_jMenuWindowFullHeader_actionAdapter(ViewMessageFrame adaptee)
  {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e)
  {
    adaptee.jMenuWindowFullHeader_actionPerformed(e);
  }
}

class ViewMessageFrame_jMenuWindowNoHeader_actionAdapter implements java.awt.event.ActionListener
{
  ViewMessageFrame adaptee;

  ViewMessageFrame_jMenuWindowNoHeader_actionAdapter(ViewMessageFrame adaptee)
  {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e)
  {
    adaptee.jMenuWindowNoHeader_actionPerformed(e);
  }
}

class ViewMessageFrame_jButton1Reply_actionAdapter implements java.awt.event.ActionListener
{
  ViewMessageFrame adaptee;

  ViewMessageFrame_jButton1Reply_actionAdapter(ViewMessageFrame adaptee)
  {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e)
  {
    adaptee.jMenuMessageReplyQuoting_actionPerformed(e);
  }
}

class ViewMessageFrame_jButton3New_actionAdapter implements java.awt.event.ActionListener
{
  ViewMessageFrame adaptee;

  ViewMessageFrame_jButton3New_actionAdapter(ViewMessageFrame adaptee)
  {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e)
  {
    adaptee.jMenuMessageNew_actionPerformed(e);
  }
}

class ViewMessageFrame_jButton4Copy_actionAdapter implements java.awt.event.ActionListener
{
  ViewMessageFrame adaptee;

  ViewMessageFrame_jButton4Copy_actionAdapter(ViewMessageFrame adaptee)
  {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e)
  {
    adaptee.jMenuEditCopy_actionPerformed(e);
  }
}

class ViewMessageFrame_jButton12FullHeader_actionAdapter implements java.awt.event.ActionListener
{
  ViewMessageFrame adaptee;

  ViewMessageFrame_jButton12FullHeader_actionAdapter(ViewMessageFrame adaptee)
  {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e)
  {
    adaptee.jMenuWindowFullHeader_actionPerformed(e);
  }
}

class ViewMessageFrame_jMenuMessageReplyNoQuoting_actionAdapter implements java.awt.event.ActionListener
{
    ViewMessageFrame adaptee;

    ViewMessageFrame_jMenuMessageReplyNoQuoting_actionAdapter(ViewMessageFrame adaptee)
    {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e)
    {
        adaptee.jMenuMessageReplyNoQuoting_actionPerformed(e);
    }
}

class ViewMessageFrame_jMenuMessageForward_actionAdapter implements java.awt.event.ActionListener
{
    ViewMessageFrame adaptee;

    ViewMessageFrame_jMenuMessageForward_actionAdapter(ViewMessageFrame adaptee)
    {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e)
    {
        adaptee.jMenuMessageForward_actionPerformed(e);
    }
}

class ViewMessageFrame_jMenuAddressbookOpen_actionAdapter implements java.awt.event.ActionListener
{
    ViewMessageFrame adaptee;

    ViewMessageFrame_jMenuAddressbookOpen_actionAdapter(ViewMessageFrame adaptee)
    {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e)
    {
        adaptee.jMenuAddressbookOpen_actionPerformed(e);
    }
}

class ViewMessageFrame_jButton11Addressbook_actionAdapter implements java.awt.event.ActionListener
{
    ViewMessageFrame adaptee;

    ViewMessageFrame_jButton11Addressbook_actionAdapter(ViewMessageFrame adaptee)
    {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e)
    {
        adaptee.jMenuAddressbookOpen_actionPerformed(e);
    }
}

class ViewMessageFrame_jButton2Forward_actionAdapter implements java.awt.event.ActionListener
{
    ViewMessageFrame adaptee;

    ViewMessageFrame_jButton2Forward_actionAdapter(ViewMessageFrame adaptee)
    {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e)
    {
        adaptee.jMenuMessageForward_actionPerformed(e);
    }
}


class ViewMessageFrame_jMenuMessageReplyToAllQuoting_actionAdapter implements java.awt.event.ActionListener
{
    ViewMessageFrame adaptee;

    ViewMessageFrame_jMenuMessageReplyToAllQuoting_actionAdapter(ViewMessageFrame adaptee)
    {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e)
    {
        adaptee.jMenuMessageReplyToAllQuoting_actionPerformed(e);
    }
}

class ViewMessageFrame_jMenuMessageReplyToAllNoQuoting_actionAdapter implements java.awt.event.ActionListener
{
    ViewMessageFrame adaptee;

    ViewMessageFrame_jMenuMessageReplyToAllNoQuoting_actionAdapter(ViewMessageFrame adaptee)
    {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e)
    {
        adaptee.jMenuMessageReplyToAllNoQuoting_actionPerformed(e);
    }
}

class ViewMessageFrame_contentPane_hierarchyBoundsAdapter extends java.awt.event.HierarchyBoundsAdapter
{
    ViewMessageFrame adaptee;

    ViewMessageFrame_contentPane_hierarchyBoundsAdapter(ViewMessageFrame adaptee)
    {
        this.adaptee = adaptee;
    }
    public void ancestorResized(HierarchyEvent e)
    {
        adaptee.contentPane_ancestorResized(e);
    }
}

