package smail.gui.filterGui ;

import javax.swing.* ;
import javax.swing.table.* ;
import java.awt.event.* ;
import java.awt.* ;
import smail.filter.* ;

public class AddWizzard extends JDialog {

	// default filter fields , init used on creating new filter
	private smail.filter.Filter newFilter ;
	private String filterName = "" ;
	private Condition[] filterConds = new Condition[0] ;
	private int newFtype  = -1;
	private int action = -1 ;
	private String moveDest = "" ;
	//	private smail.filter.Condition[] conditions ;

	// MAIN COMPONENTS
	private FilterGuy 		parentFrame ;
	private JDialog	thisFellow ;
	private JLabel 			filterNameL 	= new JLabel("Filter Name :") ;
	private JTextField 		filterNameF 	= new JTextField() ;
	private JLabel			filterTypeL		= new JLabel("Filter applying type :") ;
	private JComboBox		filterTypeCB ;
	private JLabel 			condL 			= new JLabel("Condition :") ;
	private JButton 		addCondB		= new JButton("add Condition") ;
	private JButton 		remCondB		= new JButton("remove Condition") ;
	private JTable 			conditionTable ;
	private JScrollPane 	conditionSP ;
	private JPanel 			condPanel ;
	private GridBagConstraints toggleC ;
	private JRadioButton 	moveActRB 		= new JRadioButton("move to :") ;
	private JRadioButton 	delActRB 		= new JRadioButton("delete") ;
	private JTextField 		moveHere		= new JTextField() ;
	private ButtonGroup 	actionGroup ;
	private JButton 		dirChooseB		= new JButton("dir...") ;
	private DestinationLister destLister ;
	private JButton 		doneB 			= new JButton("take this") ;
	private JButton			cancelMainB		= new JButton("cancel") ;
	private Container		cp ;
	private Color active ;
	private Color inactive ;
	private smail.Fassade face ;
	private ConditionDialog cdialog  ;


	AddWizzard(FilterGuy parentFrame, smail.Fassade face) {
		super(parentFrame, true) ;		
		this.face = face ;
		System.out.println( "called AddWizzard with frame" ) ;
		initAddFilterWizzard() ;
		pack() ;
	}

	AddWizzard(FilterGuy parentFrame,smail.Fassade face, Filter filter) {
		super(parentFrame, true) ;
		this.face = face ;
		System.out.println( "called AddWizzard with fram AND Filter" ) ;
		this.newFilter = filter ; // unnoetig ???
		this.filterConds = filter.getCondition() ;
		this.filterName = filter.getName();
		this.newFtype = filter.getType();
		this.action = filter.getAction().getType();
		if ( action == smail.filter.Action.MOVE ) {
			this.moveDest = filter.getAction().getDestination();
		}
		initAddFilterWizzard() ;
		
		pack() ;
	}

	private void initAddFilterWizzard() {
		renewCdialog() ;
		thisFellow = this ;

		this.setTitle("smail - Filter Wizzard") ;
		cp = getContentPane() ;
		((JPanel)cp).setBorder(new javax.swing.border.EmptyBorder(20,20,20,20)) ;
		active = moveHere.getBackground() ;
		inactive = cp.getBackground() ;
		cp.setLayout(new GridBagLayout()) ;
		GridBagConstraints cc = new GridBagConstraints() ;
		cc.insets = new Insets(4,4,4,4) ;

		/* add the filter name label */
		cc.gridx 		= 0 ;
		cc.gridy 		= 0 ;
		cc.gridwidth 	= 1 ;
		cc.gridheight 	= 1 ;
		cp.add(filterNameL , cc) ;

		/* add the textfield to enter name in */
		filterNameF.setText(filterName) ;
		cc.gridx 		= 1 ;
		cc.gridy 		= 0 ;
		cc.gridwidth 	= 3 ;
		cc.gridheight 	= 1 ;
		cc.fill 		= GridBagConstraints.HORIZONTAL ;
		cp.add(filterNameF, cc) ;
		cc.fill			= GridBagConstraints.NONE ;

		/* add the "filterType"-Label */
		cc.gridx		= 0 ;
		cc.gridy		= 1 ;
		cc.gridwidth 	= 1 ;
		cc.gridheight	= 1 ;
		cp.add(filterTypeL, cc) ;

		/* add "filterType" combobox */
		String[] filterTypeList = new String[]
		{	"please select" , "manually" , "automatically after receiving" ,
			 "automatically before receiving" 	} ;	 

		//TODO : actionList for setting the filterType ??

		filterTypeCB = new JComboBox(filterTypeList) ;
		switch (newFtype) {
			case 0:
				filterTypeCB.setSelectedIndex(3) ;
				break;
			case 1:
				filterTypeCB.setSelectedIndex(2);
				break;
			case 2:
				filterTypeCB.setSelectedIndex(1);
				break;
			default:
				filterTypeCB.setSelectedIndex(0);
				break;
		}
		cc.gridx 		= 1 ;
		cc.gridy		= 1 ;
		cc.gridwidth 	= 2 ;
		cc.gridheight	= 1 ;
		cc.fill			= GridBagConstraints.HORIZONTAL ;
		cp.add(filterTypeCB, cc) ;
		cc.fill			= GridBagConstraints.NONE ;


		/* add "condition" label */
		cc.gridx 		= 0 ;
		cc.gridy 		= 3 ;
		cc.gridwidth 	= 1 ;
		cc.gridheight 	= 1 ;
		cp.add(condL, cc) ;

		/* add "add condition" button */
		addCondB.setPreferredSize(new Dimension(120,30)) ;
		addCondB.setActionCommand("addcondition") ;
		addCondB.setMnemonic('a') ;
		addCondB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				renewCdialog() ;
				cdialog.show() ;										
			}
		}) ;
		cc.gridx 		= 1 ;
		cc.gridy 		= 3 ;
		cc.gridwidth 	= 1 ;
		cc.gridheight 	= 1 ;
		cp.add(addCondB, cc) ;


		/* add "remove Condition" button */
		remCondB.setPreferredSize(new Dimension(120,30)) ;
		remCondB.setActionCommand("removecondition") ;
		remCondB.setMnemonic('r') ;
		remCondB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ConditionTableModel tableModel = (ConditionTableModel)conditionTable.getModel() ;
				((ConditionTableModel)tableModel).remove(conditionTable.getSelectedRow()) ;
			}


		}) ;

		cc.gridx 		= 2 ;
		cc.gridy		= 3 ;
		cc.gridwidth 	= 1 ;
		cc.gridheight 	= 1 ;
		cp.add(remCondB, cc) ;

		/* add "condition" table in a scrollablePane */
//		if (newFilter == null) {
//			Condition[] newCond = new Condition[0] ;
//			conditionTable = new JTable(new ConditionTableModel(newCond)) ;
//		} else {
			conditionTable = new JTable( new ConditionTableModel(filterConds) ) ;			
//		}
		conditionTable.setPreferredScrollableViewportSize(new Dimension(300,150)) ;
		ConditionTableModel tableModel = (ConditionTableModel)conditionTable.getModel() ;
		conditionTable.setColumnSelectionAllowed(true) ;
		conditionTable.setShowGrid(false) ;
		conditionTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION) ;
		conditionTable.setCellSelectionEnabled(true) ;
		TableColumn tc = conditionTable.getColumnModel().getColumn(0) ;
		tc.setResizable(false) ;

				conditionSP = new JScrollPane() ;
		conditionSP.getViewport().add(conditionTable) ;
		conditionSP.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		toggleC = new GridBagConstraints() ;
		toggleC.gridx 		= 0 ;
		toggleC.gridy		= 4 ;
		toggleC.gridwidth	= 3 ;
		toggleC.gridheight	= 7 ;
		toggleC.fill 		= GridBagConstraints.HORIZONTAL ;
		cp.add(conditionSP, toggleC) ;

		/* add "action" label */
		cc.gridx 		= 0 ;
		cc.gridy 		= 11 ;
		cc.gridwidth 	= 1 ;
		cc.gridheight 	= 1 ;

		/* make button group */
		actionGroup = new ButtonGroup() ;
		actionGroup.add(moveActRB) ;		
		actionGroup.add(delActRB) ;

		/* add "del" radiobutton */
		delActRB.setActionCommand("deleteaction") ;
		delActRB.setMnemonic('d') ;
		delActRB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
/*DEBUG*/				System.out.println( "				delActRB.<anonymActionllistener>actionPerformed" ) ;
				action = smail.filter.Action.DELETE ;
				moveHere.setEnabled(false) ;
				moveHere.setBackground(inactive) ;
			}
		}) ;
		int temp = cc.anchor ;
		cc.anchor = GridBagConstraints.WEST ;
		cc.gridx 		= 0 ;
		cc.gridy 		= 12 ;
		cc.gridwidth	= 1 ;
		cc.gridheight 	= 1 ;
		cp.add(delActRB, cc) ;
		cc.anchor = temp ;


		/* add "move" radiobutton */
		/* same insets as radiobutton above */
		moveActRB.setActionCommand("moveaction") ;
		moveActRB.setMnemonic('m') ;
		moveActRB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// -"-
				action = smail.filter.Action.MOVE ;
				moveHere.setEnabled(true) ;
				moveHere.setBackground(active) ;
			}
		}) ;
		cc.anchor 		= GridBagConstraints.WEST ;
		cc.gridx 		= 0 ;
		cc.gridy 		= 13 ;
		cc.gridwidth 	= 1 ;
		cc.gridheight	= 1 ;
		cp.add(moveActRB, cc) ;
		cc.anchor = temp ;
		
		/* ckeck which action is set in case a filter is to be changed */
		if ( action == smail.filter.Action.DELETE ) {
//			delActRB.setSelected( true );
			delActRB.doClick(); 
		} else if ( action == smail.filter.Action.MOVE ) {
			moveActRB.setSelected( true );
		} else {
			//
		}
		///

		/* add "dir chooser" button */
		dirChooseB.setActionCommand("choosedir") ;
		dirChooseB.setMnemonic('c') ;
		dirChooseB.setPreferredSize(new Dimension(120,30)) ;
		dirChooseB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.out.println( "AddWizzard <listener DestinationLister-Window closing> EVENT" );
				//						delActRB.setEnabled(false) ;
				moveActRB.doClick() ;
				destLister = new DestinationLister(thisFellow, face) ;
				destLister.addWindowListener(new WindowAdapter() {
					public void windowClosing(WindowEvent e) {
						String dest = destLister.getDestination() ;
						System.out.println( "AddWizzard <anonym listener> :: "+dest ) ;
						if (dest == null) {
							System.out.println( "AddWizzard <anonym listener> :: Destination is NULL") ;
						}
						moveHere.setText(dest) ;
					}
				})  ;

				destLister.show() ;
			}
		}) ;
		cc.gridx 		= 2 ;
		cc.gridy		= 13 ;
		cc.gridwidth 	= 1 ;
		cc.gridheight 	= 1 ;
		cp.add(dirChooseB, cc) ;

		/* add "destintaion" textfield */
		moveHere.addFocusListener(new FocusListener() {
			public void focusGained(FocusEvent e) {
				/* set the "move" radiobutton */
				moveActRB.setSelected(true) ;
			}
			public void focusLost(FocusEvent e) {
			}
		}) ;
		if (action == smail.filter.Action.MOVE) {
			moveHere.setText(moveDest) ;
			moveActRB.doClick();
		}
		cc.gridx		= 0 ;
		cc.gridy 		= 14 ;
		cc.gridwidth 	= 3 ;
		cc.gridheight 	= 1 ;
		cc.fill 		= GridBagConstraints.HORIZONTAL ;
		cp.add(moveHere, cc) ;
		cc.fill = GridBagConstraints.NONE ;

		cancelMainB.setPreferredSize(new Dimension(120,30)) ;

		cancelMainB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose() ;
			}
		}) ;
		cc.gridx 		= 2 ;
		cc.gridy 		= 15 ;
		cc.gridwidth 	= 1 ;
		cc.gridheight 	= 1 ;
		cc.anchor		= GridBagConstraints.WEST ;
		cp.add(cancelMainB, cc) ;

		doneB.setPreferredSize(new Dimension(120,30)) ;
		doneB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				makeNewFilter() ;
			}
		}) ;
		cc.gridx 		= 1 ;
		cc.gridy		= 15 ;
		cc.gridwidth	= 1 ;
		cc.gridheight	= 1 ;
		cc.anchor		= GridBagConstraints.EAST ;
		cp.add(doneB, cc) ;
		setResizable(false) ;
	}	/* INIT */

			private void closeWindow() {
		processWindowEvent(new WindowEvent(this,WindowEvent.WINDOW_CLOSING) ) ;
	}


	private void renewCdialog() {
		cdialog = new ConditionDialog(parentFrame) ;
		cdialog.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				Condition newCondition = ((ConditionDialog)e.getSource()).getCondition() ;
				if (newCondition != null) {
					((ConditionTableModel)conditionTable.getModel()).add(newCondition) ;
				} else {
				}
			}
		}) ;									
	}

	private void makeNewFilter() {		
		String filterName = filterNameF.getText() ;
		String destination = moveHere.getText() ;
		System.out.println( "AddWizzard.makeNewFIlter()<init fields > :: destination is :"+destination ) ;
		int selectedType = filterTypeCB.getSelectedIndex() ;
		int filterType = -1 ;
		switch (selectedType) {
				case 0 :
					smail.Popup p = new smail.Popup("Please select a Filter type !", true) ;
					return ;
				case 1 :
					filterType = smail.filter.Filter.MANUALLY ;
					break;
				case 2 :
					filterType = smail.filter.Filter.POST ;
					break;
				case 3 :
					filterType = smail.filter.Filter.PRE ;
					break;
				default:
					System.out.println( "MAKE NEW FILTER :: unknown filterType :"+filterType ) ;
					return ;
		}
		System.out.println( "on making new filter type is :"+filterType ) ;
		ConditionTableModel tableModel = (ConditionTableModel)conditionTable.getModel() ;
		Condition[] conditions = ((ConditionTableModel)tableModel).getConditions() ;

		if (filterName.equals("")) {
			smail.Popup p = new smail.Popup("Please give a Filtername !",true) ;
			return  ;
		}
		if (action == -1) {
			smail.Popup p = new smail.Popup("Please choose an action type !",true) ;
			return  ;
		}		
		if (conditions == null || conditions.length <= 0) {
			smail.Popup p = new smail.Popup("Please define some conditions !",true) ;
			return  ;
		}

		try {
			System.out.println( "AddFIlterWizzard.makeNewFilter()<compute Action> :: Action type is :"+action ) ;
			System.out.println( "AddFIlterWizzard.makeNewFilter()<compute Action> :: smail.filter.Action.MOVE:"+smail.filter.Action.MOVE);
			System.out.println( "AddFIlterWizzard.makeNewFilter()<compute Action> :: smail.filter.Action.DELETE:"+smail.filter.Action.DELETE ) ;
			if (action == smail.filter.Action.MOVE) {
				if (destination.equals("")) {
					smail.Popup p = new smail.Popup("A move action needs a destination !",true) ;
					return  ;
				}
				this.newFilter = new Filter(filterType, filterName, new smail.filter.Action(action,destination), conditions) ;
				System.out.println( "made new Filter" ) ;
			}
			else if (action == smail.filter.Action.DELETE) {
				this.newFilter = new Filter(filterType, filterName, new smail.filter.Action(action), conditions) ;
				System.out.println( "made new Filter" ) ;
			} else {
				System.out.println( "FGAddWizzard.makeNewFilter() :: unkown action type or action not yet set" ) ;
				return  ;
			}

		}
		catch (NoSuchTypeException nste) {
			System.out.println( "FGAddWizzard.makeNewFilter() :: nosuchtype on making new filter"  ) ;
			System.out.println( "Type is :"+newFtype ) ;
		}
		closeWindow() ;

	} /* MAKE NEW FILTER */

	Filter getNewFilter() {
		return newFilter ;
	}

	class ConditionTableModel extends AbstractTableModel {
		protected Condition[] allCond ;

		protected Class[] colClass = new Class[]
		{	String.class , String.class 	} ;

		protected String[] colNames = new String[]
		{	 "Conditions" } ;


		/**
		 *will remove the condition indexed by <code>selectedRow</code>. There is 
		 *the big question if removing a condition from here will also remove the 
		 *condition from the related Filter ????.
		 *A negative index or an index greater than the "condition amount - 1" will
		 *be ignored silently and the the original Condition-array will be returned.
		 *@param selectedRow is the row selected and the filter that has to be removed.
		 */
		void remove(int selectedRow) {
			if (selectedRow >= allCond.length || selectedRow < 0) {
/*DEBUG*/				System.out.println( "remove : out of range" ) ;
				smail.Popup p = new smail.Popup("There is no Condition selected to remove !",true); 
				return  ;
			}
			Condition[] temp = new Condition[allCond.length-1] ;
			System.arraycopy(allCond,0,temp,0,selectedRow) ;
			System.arraycopy(allCond,selectedRow+1,temp,selectedRow,allCond.length-selectedRow-1) ;
			allCond = temp ;
			fireTableRowsDeleted(selectedRow,selectedRow) ;

		}

		void add(Condition newcond) {
			Condition[] temp = new Condition[allCond.length+1] ;
			System.arraycopy(allCond,0,temp,0,allCond.length) ;
			temp[allCond.length] = newcond ;
			allCond = temp	;
			fireTableRowsInserted(0,allCond.length-1) ;
		}

		Condition[] getConditions() {
			return allCond ;
		}

		ConditionTableModel(Condition[] cond) {
			this.allCond = cond ;
		}

		/**
		 *@see javax.swing.table.AbstractTableModel
		 */
		public int getColumnCount() {
			return 1 ;
		}

		/**
		 *@see javax.swing.table.AbstractTableModel
		 */
		public int getRowCount() {
			return allCond.length ;
		}

		/**
		 *@see javax.swing.table.AbstractTableModel
		 */
		public String getColumnName(int column) {
			return colNames[column] ;
		}

		/**
		 *@see javax.swing.table.AbstractTableModel
		 */
		public Class getColumnClass(int column) {
			return colClass[column] ;
		}


		public Object getValueAt(int row , int column) {
			Condition condition = allCond[row] ;

			switch (column) {
					case 0 :
						return getStringRepresentation(condition) ;
						//				case 1 :
						//					return condition.getConditionType() ;
					default:						
						System.out.println( "wrong column addressed in ConditionTableModel :"+column ) ;
						return null ;
			}
		}

		private String getStringRepresentation(Condition cond) {
			String result = "" ;
			if (cond instanceof DateCondition) {
				DateCondition dateCond = (DateCondition)cond ;

						result += "mails " ;

				if (dateCond.getType() == smail.filter.DateCondition.EQUALS) {
					result += "that date : " ;
				} else if (dateCond.getType() == smail.filter.DateCondition.NEWER) {
					result += "newer than : " ;
				} else if (dateCond.getType() == smail.filter.DateCondition.OLDER) {
					result += "older than : " ;
				} else {
					result = "unkonwn dateCondition type" ;
				}
				return result ;
			} else if (cond instanceof FromCondition) {
				FromCondition fromCond = (FromCondition)cond ;
				result += "mails from : " ;
				result += fromCond.getKeyword() ;
				return result ;
			} else if (cond instanceof SubjectCondition) {
				SubjectCondition subCond = (SubjectCondition)cond ;
				result += "mails with a subjetc including : " ;
				result += subCond.getKeyword() ;
				return result ;
			}
			return "FGAddWizzard.ConditionTableModel :: unknown Condition " ;
		}
	}//END INNER CLASS CONDITIONTABLEMODEL
}

