package smail.gui.filterGui ;

import javax.swing.* ;
import javax.swing.table.* ;
import java.awt.event.* ;
import java.awt.* ;
import smail.filter.* ;


class DestinationLister extends JDialog {
	smail.Fassade face ;

	DestinationLister(JDialog owner, smail.Fassade face) {
		super(owner , "smail says : choose a destination ...", true);
		this.face = face ;
		init() ;
	}

	JButton 		takeThisB	= new JButton("OK") ;
	JButton			cancelB		= new JButton("Cancel");
	JList			list ;
	JScrollPane		listSP ;
	Container 		cp	;

	private void init() {
		cp = getContentPane();
		cp.setLayout( new GridBagLayout() ) ;
		GridBagConstraints c = new GridBagConstraints();
		c.insets = new Insets(4,4,4,4) ;

		/* table and scrollpane */
		String[] pathList = new String[0] ;
		try {
			pathList = getPathList() ;
		} catch (Exception e) {
			e.printStackTrace() ;
			pathList = new String[]  {
			"erster pfad ", "zweiter pfad", "dritter pfad" , "vierter pfad"	};
		}
		list = new JList(pathList) ;
		list.setPreferredSize( new Dimension(500,300) ) ;
		listSP = new JScrollPane() ;
		listSP.getViewport().add(list) ;
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION) ;

				c.gridx 		= 0 ;
		c.gridy			= 0 ;
		c.gridwidth		= 3 ;
		c.gridheight	= 1 ;

		cp.add(listSP, c) ;


		/* takeThisB */
		takeThisB. addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// store the destination
				tellWindowClosing() ;
			}
		}) ;
		c.gridx			= 1 ;
		c.gridy			= 1 ;
		c.gridheight	= 1 ;
		c.gridwidth		= 1 ;
		c.anchor		= GridBagConstraints.EAST ;
		takeThisB.setPreferredSize(new Dimension(120,30)) ;
		takeThisB.setToolTipText("take the selected path") ;
		cp.add(takeThisB, c);

		/* cancelB */
		cancelB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose() ;
			}
		}) ;
		c.gridx			= 2 ;
		c.gridy			= 1 ;
		c.gridheight	= 1 ;
		c.gridwidth		= 1 ;
		c.anchor		= GridBagConstraints.WEST ;
		cancelB.setPreferredSize(new Dimension(120,30)) ;
		cancelB.setToolTipText("abort") ;
		cp.add(cancelB, c) ;
		setResizable(false) ;

		pack() ;
	}

	String getDestination() {
		// TODO : return the chosen destination
		Object obj = list.getSelectedValue() ;
		if (obj != null) {
			return (String)obj ;
		} else {
			System.out.println( "DANGER, Will Robinson, DANGER (in DestinationLister getDestination() !" ) ;
			return null ;
		}
	}

	private String[] getPathList() {
		// TODO : return a String[] of all folder in localStore
		javax.mail.Store store = face.getStore() ;
		javax.mail.Folder[] allFolder = null ;
		try
		{
			javax.mail.Folder rootFolder = store.getDefaultFolder() ;
			allFolder = rootFolder.list("*") ;
			}
		catch (javax.mail.MessagingException e)
		{
			System.out.println( "DestinationLister.getPathlist() :: MessagingException caught" ) ;
			}
		String[] result = new String[allFolder.length] ;
		for (int i = 0 ; i<allFolder.length ; i++ ) {
			result[i] = allFolder[i].getFullName() ;
		}
		return result ;
	}

	private void tellWindowClosing() {
		System.out.println( (String)list.getSelectedValue()  ) ;
		if (list.getSelectedValue() == null) {
			smail.Popup p = new smail.Popup("Please choose a destination", true) ;
		} else {
			processWindowEvent(new WindowEvent(this,WindowEvent.WINDOW_CLOSING) ) ;
			dispose() ;
		}
	}

}
		
		
		