package smail.gui.filterGui ;

import javax.swing.* ;
import javax.swing.table.* ;
import java.awt.event.* ;
import java.awt.* ;
import smail.filter.* ;
import javax.swing.event.* ;
/**
 *This class is the entry point for all filter related actions and managements.
 *This frame is responsible for the logic behind of making/removing/changing 
 *filters. The frame stays the same while handling filters. Only the panels
 *showen up on the frame changes.
 */

public class FilterGuy extends JFrame /* implements ActionListener */
{
	FilterManager 			fiMan ;
	FilterGuy 				myself 			= this ;
	AddWizzard 				wiz ;
	smail.Fassade face ;
	boolean overwrite = false ;
	/////////////////////
	GridBagConstraints 		cc 				= new GridBagConstraints() ;
	JLabel 					label			= new JLabel("These are your Filters and their Activation Status") ;
	JTable filterTable ;
	JScrollPane 			tablePane ;
	JButton 				addFilterB 		= new JButton("add Filter") ;
	JButton 				changeFilterB 	= new JButton("change Filter") ;
	JButton 				remFilterB 		= new JButton("remove Filter") ;
	JButton 				toggleActB		= new JButton("toggle Activities") ;
	JButton					filterNow		= new JButton("filter now");
	JButton 				closeB 			= new JButton("Done") ;
	/////////////////////

	/**
	 *this initializes a new FilterGuy-Frame based on the informations from 
	 *FilterManager.
	 *@param fiMan the FilterManager-object that manages the filters.
	 */
	public FilterGuy(smail.Fassade fassade) {
		super("smail - FilterGuy") ;
		this.fiMan = fassade.getFilterManager(  ) ;
		this.face = fassade ;
		initFilterGuy(fassade) ;
	}

	private void renewAddWizzard(Filter changeFilter) {
		if (changeFilter == null) {
			wiz = new AddWizzard(this, face) ;
		} else {
			overwrite = true ;
			wiz = new AddWizzard(this, face , changeFilter);
		}
		wiz.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent we) {
				Filter newFilter = wiz.getNewFilter() ;
				FilterTableModel filterTableModel = (FilterTableModel)filterTable.getModel() ;						
				filterTableModel.addFilterToModel(newFilter,overwrite) ;
				overwrite = false ;				
			}
		}) ;
	}

	private void initFilterGuy(smail.Fassade face) {
		setResizable(false) ;
		Image image = new ImageIcon(getClass().getResource("icon16.png")).getImage();
		this.setIconImage(image);
	
		
		Container cp = this.getContentPane() ;
		((JPanel)cp).setBorder(new javax.swing.border.EmptyBorder(20,15,10,15)) ;

		cp.setLayout(new java.awt.GridBagLayout()) ;

		/* add the table for all filters-names and activation status */
		this.filterTable = new JTable(new FilterTableModel(fiMan)) ;
		filterTable.setShowGrid(false) ;
		filterTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION) ;
		filterTable.sizeColumnsToFit(1) ;
		filterTable.setPreferredScrollableViewportSize(new Dimension(500,200)) ;

		TableColumn tc = filterTable.getColumnModel().getColumn(0) ;
		tc.setMinWidth(40) ;
		tc.setMaxWidth(40) ;
		tc.setResizable(false) ;
		tc = filterTable.getColumnModel().getColumn(1) ;
		tc.setMinWidth(80) ;
		tc.setMaxWidth(80) ;
		tc.setResizable(false) ;
		tablePane = new JScrollPane () ;
		tablePane.getViewport().add(filterTable) ;
		tablePane.validate() ;
		tablePane.setToolTipText("these are the currently defined filter") ;

		

		/* add the "add filter" button to the panel */
		addFilterB.setPreferredSize(new Dimension(120,30)) ;
		addFilterB.setToolTipText("add a new filter") ;
		addFilterB.setActionCommand("addnewfilter") ;
		addFilterB.setMnemonic('a') ;
		addFilterB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				renewAddWizzard(null) ;
				wiz.show() ;
			}
		}) ;

		/* add the "change Filter" button to the panel */
		changeFilterB.setPreferredSize(new Dimension(120,30)) ;
		changeFilterB.setToolTipText("this is currently not implemented");
		changeFilterB.setMnemonic('c') ;
		changeFilterB.setActionCommand("changefilter") ;
		changeFilterB. addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				int sel = filterTable.getSelectedRow() ;
				if (sel < 0) {
					smail.Popup p = new smail.Popup("You need to select a Filter to change it", true);	
				} else {
					Filter filter2Change = null; 
					try  {
					filter2Change = ((FilterTableModel)filterTable.getModel()).getFilter(sel);
					} catch (WrongFilterIDException ex) {
						System.out.println( "FIlterGuy.<anonymListener><getFilter(filteerID/tableSelection) :: caught wrongfilterID" ) ;
					}
					renewAddWizzard( filter2Change ) ;
					wiz.show() ;
				}
			}
		}) ;

		/* add the "remove filter" button to the panel */
		remFilterB.setPreferredSize(new Dimension(120,30)) ;
		remFilterB.setActionCommand("removefilter") ;
		remFilterB.setToolTipText("remove the currently selected filter") ;
		remFilterB.setMnemonic('r') ;
		remFilterB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				TableModel tableModel = filterTable.getModel() ;
				Object button ;
				int selectedRow = filterTable.getSelectedRow() ;
				if (selectedRow == -1) {
					smail.Popup p = new smail.Popup("Please choose/define a Filter first !", true) ;
				} else {
					((FilterTableModel)tableModel).removeFilterFromModel(selectedRow) ;
				}
			}
		}) ;

		/* "toggle Action state" Button */
		toggleActB.setPreferredSize( new Dimension(120,30) ) ;
		toggleActB.setToolTipText("toggle activity for all selected Filter (rows)") ;
		toggleActB.setMnemonic('t') ;
		toggleActB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ListSelectionModel listModel = filterTable.getSelectionModel() ;
				for (int i = 0 ; i<filterTable.getRowCount() ; i++) {
/* ??? */			if (listModel.isSelectedIndex(i)) {
						FilterTableModel filterModel = (FilterTableModel)filterTable.getModel() ;
						filterModel.toggleActivity( i ) ;
					}
				}
			}
		}) ;

		/* add "filter now" button */
		filterNow.setPreferredSize(new Dimension(120,30)) ;
		filterNow.setToolTipText("apply all active manual filter now on all folder") ;
		filterNow.setMnemonic('n');
		filterNow. addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						// TODO : apply filter on all folder
						actionPerformed_callApplyManualFilter() ;
					}
				}) ;
		
		/* add the "OK" button to the panel */
		closeB.setPreferredSize(new Dimension(120,30)) ;
		closeB.setToolTipText("This button closes the Filter-Manager") ;
		closeB.setMnemonic('d') ;
		closeB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				fiMan.exiting() ;
				dispose() ;
			}
		}) ;

/////////////////////////////////////////////////
		cc.insets = new Insets(4,4,4,4) ;
		
		cc.gridx 		= 0 ;
		cc.gridy 		= 0 ;
		cc.gridwidth	= 1 ;
		cc.gridheight 	= 6 ;
//		cc.gridheight 	= GridBagConstraints.REMAINDER ;
		cp.add( tablePane, cc ) ;

		cc.gridx 		= 1 ;
		cc.gridy 		= 0 ;
		cc.gridwidth 	= 1 ;
		cc.gridheight 	= 1 ;
		cp.add( addFilterB, cc ) ;

		cc.gridx 		= 1 ;
		cc.gridy 		= 1 ;
		cc.gridwidth 	= 1 ;
		cc.gridheight 	= 1 ;
		cp.add( changeFilterB, cc ) ;

		cc.gridx 		= 1 ;
		cc.gridy 		= 2 ;
		cc.gridwidth 	= 1 ;
		cc.gridheight 	= 1 ;
		cp.add( remFilterB, cc) ;

		cc.gridx 		= 1 ;
		cc.gridy		= 3 ;
		cc.gridwidth	= 1 ;
		cc.gridheight	= 1;
//		cc.weighty		= 0.0 ;
//		cc.anchor 		= GridBagConstraints.SOUTH ; 
		cp.add(filterNow, cc);
//		cc.anchor 		= GridBagConstraints.CENTER ;

		cc.gridx 		= 1 ;
		cc.gridy 		= 5 ;
		cc.gridwidth	= 1 ;
		cc.gridheight 	= 1;
//		cc.weighty		= 0.0 ;
//		cc.gridwidth 	= GridBagConstraints.REMAINDER ;
		cc.anchor		= GridBagConstraints.SOUTH ;
		cp.add(closeB, cc) ;


		validate() ;
		pack() ;

		////////////////////////////

		/* mit Dank geklaut */
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = getSize();
		if (frameSize.height > screenSize.height) {
			frameSize.height = screenSize.height;
		}
		if (frameSize.width > screenSize.width) {
			frameSize.width = screenSize.width;
		}
		setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

		show() ;
	}	

	private void actionPerformed_callApplyManualFilter() {
		face.applyManualFilter();
	}
	
	
	
	/* TESTING ONLY */
	public static void main(String[] arg) {
		//		try
		//		{
		//			javax.mail.Session session = javax.mail.Session.getDefaultInstance(System.getProperties(), null) ;
		//			String m = smail.utils.PropertiesManager.get("smail.home") ;
		//			javax.mail.URLName name = new javax.mail.URLName("localstore:"+m) ;
		//			javax.mail.Store store  = session.getStore(name) ;
		//			final FilterManager fm = new FilterManager(store) ;
		//			FilterGuy fg = new FilterGuy(fm) ;
		//			fg.addWindowListener(new WindowAdapter()
		//					{
		//						public void windowClosed(WindowEvent e)
		//						{
		//							smail.utils.PropertiesManager pm =smail.utils.PropertiesManager.getInstance() ;
		//							fm.exiting() ;
		//							pm.exiting();
		//							System.exit(0) ;
		//						}
		//					});
		//			fg.show() ;
		//		}
		//		catch (javax.mail.MessagingException e)
		//		{
		//			System.out.println( "exception in TestMain :: FilterGuy" ) ;
		//			System.out.println( e.getMessage() ) ;
		//			System.exit(-1) ;
		//		}

	}
}
