package smail.server;

import java.lang.*;
import java.util.*;

/**
 *This class has one big lack.All fields are public and so they can be changed
 *from anywhere. There is no fun on coping with Side-effects so anyone using 
 *accounts in any kind of use should be aware that any the fields of an account
 *object should only be changed with methods found in @see smail.Control or
 *@see smail.Fassade of with methods found in @see smail.server.AccountData.
 */
public class Account
{
	/** this is the name that has to be passed in authorization on a pop3 server. */
	public String username;

	/** this is the password that has to be passed in authorization on a pop3 server. */
	public String password;

	/** the address of the smtpHost to send mail to. */
	public String smtpHost;

	/** the address of the pop3 server to receive mails from .*/
	public String pop3Host;

	/** the protocol when receiving messages . this is set to "pop3" in default. */
	public String rcptprot;

	/** the protocol when sending messages. this is set to "smtp" in default*/
	public String transferprot;

	/** the name that the user gave this account */
	public String accountName ;

	/** the e-mail address this account-informations are related to */
	public String address ;

	public String toString()
	{
		return accountName +" <"+address+">";	
		
	}

	/**
	 *Creates a new Account-object initialing the fields with the passes parameters.
	 *Take care to pass the paramters in the correct order. Flipping the fields 
	 *will cause unknown desaster.
	 *@param accountName the idetifier of the account that has to be changed
	 *@param address the email address of the account
	 *@param username is the name needed for authorization on the mail server
	 *@param smtpHost is the host address where to send mails to
	 *@param pop3Host is the host address where to receive mails from
	 */
	public Account(String accountName, String address, String username,
					 String smtp, String pop3 )
	{
		this.accountName = accountName==null ? " ":accountName ;
		this.username = username==null ? " ": username ;
		this.address = address==null ? " ": address;
		this.smtpHost = smtp==null ? " ": smtp;
		this.pop3Host = pop3==null ? " ": pop3;
		this.rcptprot = "pop3" ;
		this.transferprot = "smtp" ;
	}

	/**
	 * XXX
	 */
	public void changeUsername(String name)
	{
		this.username=name;
	}
	/**
	 * XXX
	 */
	public void changeAddress(String address)
	{
		this.address = address ;
	}
	/**
	 * XXX
	 */
	public void changeAccountName(String accountName)
	{
		this.accountName = accountName ;
	}
	/**
	 * XXX
	 */
	public void changePsswrd(String psswrd)
	{
		this.password=psswrd;
	}
	/**
	 * XXX
	 */
	public void changeRcptprot(String prot)
	{
		this.rcptprot=prot;
	}
	/**
	 * XXX
	 */
	public void changeTransprot(String transprot)
	{
		this.transferprot=transprot;
	}
	/**
	 * XXX
	 */
	public void changeSmtpHost(String host)
	{
		this.smtpHost=host;
	}
	/**
	 * XXX
	 */
	public void changePop3Host(String host)
	{
		this.pop3Host=host;
	}
}                