package smail.utils ;
/**
 *This interface is part of the mechanism to assure a consistent configuration
 *of our program. Classes which can be customized and even classes which need
 *userdefined data/properties like account information must implement this 
 *interface.<br> This mechanism is based upon the idea of events and eventlisteners.
 *When a property changes an "event" is fired and each listener has to decide
 *to ignore or to react on this property.
 *More information about property handling is written in the PropertiesManager-class
 */

public interface Configurable
{
	/**
	 *This is called when a property has changed.
	 */
	public void propertyChanged(PropertyChangedEvent event) ;
}