package smail.utils;

/*
import smail.gui.*;
import smail.server.*;
import java.lang.*;
import javax.mail.*;
import javax.mail.internet.*;
import java.util.*;
import java.io.*;
import javax.activation.*;
*/

public class Converter
{
	/**
	 *This method converts a message constructed by the Gui in a MimeMessage and 
	 *returns the result of the conversion
	 */
	public static smail.localStore.LocalMessage convert(smail.server.Account acc, smail.gui.MessageContent pMsg) throws javax.mail.MessagingException
	{
                java.util.Properties props = System.getProperties ();
            
                props.setProperty("mail.user",acc.username);
//		props.setProperty("Password",acc.password);
		props.setProperty("mail.store.protocol",acc.rcptprot);
		props.setProperty("mail.transport.protocol",acc.transferprot);
		props.setProperty("mail.smtp.host",acc.smtpHost);
		props.setProperty("mail.pop3.host",acc.pop3Host);

                // creates a new session-object
                javax.mail.Session session = javax.mail.Session.getDefaultInstance(props) ;
                
                // craetes a new MimieMessage with the session-object above created 
                javax.mail.internet.MimeMessage mimeMsg = new javax.mail.internet.MimeMessage(session) ;
		try
		{
			mimeMsg.setFrom(new javax.mail.internet.InternetAddress(pMsg.getFrom())) ;
		}
		catch(javax.mail.MessagingException e)
		{
			System.out.println("Address Exception in COnverter.convert() !!!") ;
		}

                // set the Subject of the MIME-Message
                mimeMsg.setSubject (pMsg.getSubject());
                
		// set the To-Adresses
                Object[] objArray = pMsg.getToAddresses().toArray();
		javax.mail.Address[] addArray = new javax.mail.internet.InternetAddress[objArray.length];
		for (int i = 0; i < objArray.length; i++)
		{
			try
			{
				addArray[i] = new javax.mail.internet.InternetAddress ((String) objArray[i]);
			}
			catch(javax.mail.MessagingException e)
			{
				System.out.println("InternetAddress Exception in COnverter.convert() !!!") ;
			}
		}
		try
		{
			mimeMsg.setRecipients(javax.mail.Message.RecipientType.TO , addArray); 
		}
		catch(javax.mail.MessagingException e)
		{
			System.out.println("Address Exception in COnverter.convert() !!!") ;
		}
                
                // set the CC-Adresses
                objArray = pMsg.getCcAddresses().toArray();
		addArray = new javax.mail.internet.InternetAddress[objArray.length];
		for (int i = 0; objArray != null && i < objArray.length; i++)
		{
			try
			{
				addArray[i] = new javax.mail.internet.InternetAddress ((String) objArray[i]);
			}
			catch(javax.mail.MessagingException e)
			{
				System.out.println("InternetAddress Exception in COnverter.convert() !!!") ;
			}
		}
		try
		{
			mimeMsg.setRecipients(javax.mail.Message.RecipientType.CC , addArray); 
		}
		catch(javax.mail.MessagingException e)
		{
			System.out.println("Address Exception in COnverter.convert() !!!") ;
		}
                
                // set the BCC-Adresses
                objArray = pMsg.getBccAddresses().toArray();
		addArray = new javax.mail.internet.InternetAddress[objArray.length];
		for (int i = 0; objArray != null && i < objArray.length; i++)
		{
			try
			{
				addArray[i] = new javax.mail.internet.InternetAddress ((String) objArray[i]);
			}
			catch(javax.mail.MessagingException e)
			{
				System.out.println("InternetAddress Exception in COnverter.convert() !!!") ;
			}
		}
		try
		{
			mimeMsg.setRecipients(javax.mail.Message.RecipientType.BCC , addArray); 
		}
		catch(javax.mail.MessagingException e)
		{
			System.out.println("Address Exception in COnverter.convert() !!!") ;
		}

		// creates a maultipart
		javax.mail.internet.MimeMultipart mp = new javax.mail.internet.MimeMultipart();
       		
                // creates a BodyBart
                javax.mail.internet.MimeBodyPart bp = new javax.mail.internet.MimeBodyPart();
            
                bp.setText(pMsg.getText());
                
                //bp.setDisposition(Part.INLINE);
                mp.addBodyPart(bp);
            
                try
                {
                    if (pMsg.getAttachmentsBoolean())
                    {
                        smail.server.Attachement [] atts = new smail.server.Attachement [pMsg.getAttachments().size()];
                            for(int i = 0; i < pMsg.getAttachments().size();i++)
                        {
                                if (pMsg.getAttachments().get(i) instanceof String)
                                {
                                        atts[i] = smail.server.Attachement.makeAttachement((String) pMsg.getAttachments().get(i));
                                        mp.addBodyPart(atts[i]);
                                }
                        }         
                    }
                }
                catch(java.io.FileNotFoundException e ) { System.out.println ("FileNotFoundException in Converter"); }
                
                //set the content of the message
                mimeMsg.setContent(mp);
                
                
               /*
                now setting the Body Content or text 
		javax.mail.internet.MimeBodyPart mimeBpart = new javax.mail.internet.MimeBodyPart() ;
		try
		{
			mimeBpart.setText(pMsg.getText()) ;//setting the text as bodypart
		}
		catch(javax.mail.MessagingException e)
		{
			System.out.println("Address Exception in COnverter.convert() !!!") ;
		}
		
		javax.mail.internet.MimeMultipart mimeMpart = new javax.mail.internet.MimeMultipart() ;
		
		try
		{
			mimeMpart.addBodyPart(mimeBpart) ;//setting bodypart as a part of multipart
		}
		catch (javax.mail.MessagingException e) 
		{
			System.out.println("Exc in COnverter.convert::MimeMultiPartsetBodyPart() !!!") ;
		}
		try
		{
			mimeMsg.setContent(mimeMpart) ;//add this chained garbage to the MimeMessage and then fin !
		}
		catch(javax.mail.MessagingException e)
		{
			System.out.println("MessagingException in COnverter.convert() !!!") ;
		}

		try
		{
			return new smail.localStore.LocalMessage(mimeMsg) ;
		}
		catch(javax.mail.MessagingException e)
		{
			throw new javax.mail.MessagingException("MessagingException in COnverter.convert() !!!" , e) ;
		} */ 
              return new smail.localStore.LocalMessage(mimeMsg);
        }
		
/*	public static MimeMessage convert(Account acc,smail.gui.MessageContent mc) 
	{
		//Exception ex;
		MimeMessage msg = null;
		Account myacc = acc;   
		javax.mail.Address [] toadds = null;
		javax.mail.Address [] ccadds = null; 
		javax.mail.Address [] bccadds = null;
		
		try
		{
			toadds = new javax.mail.Address [mc.getToAddresses().size()]; 
			for(int i = 0;i < mc.getToAddresses().size();i++)
			{
				if (mc.getToAddresses().get(i) instanceof String)
				{
					toadds[i] = new InternetAddress((String) mc.getToAddresses().get(i));
				}
			}  
			if (!mc.getCcAddresses().isEmpty())
			{
				ccadds = new InternetAddress [mc.getCcAddresses().size()];
            	for(int i = 0;i < mc.getCcAddresses().size();i++)
				{
					if (mc.getCcAddresses().get(i) instanceof String)
					{
						ccadds[i] = new InternetAddress((String) mc.getCcAddresses().get(i));
					}
				}  
				
            }	
			if (!mc.getBccAddresses().isEmpty())
	        {
	           	bccadds = new javax.mail.Address [mc.getBccAddresses().size()];
		    	for(int i = 0;i < mc.getBccAddresses().size();i++)
				{
					if (mc.getBccAddresses().get(i) instanceof String)
					{
						bccadds[i] = new InternetAddress((String) mc.getBccAddresses().get(i));
					}
				}  
			
		    }
           	
                Multipart content = new MimeMultipart();
       		BodyPart bp = new MimeBodyPart();
            bp.setText(mc.getText());
            //bp.setDisposition(Part.INLINE);
            content.addBodyPart(bp,0);
            
            if (!mc.getAttachments().isEmpty())
            {
            	Attachement [] atts = new Attachement [mc.getAttachments().size()];
            	for(int i = 0; i < mc.getAttachments().size();i++)
            	{
            		if (mc.getAttachments().get(i) instanceof String)
            		{
            			atts[i] = Attachement.makeAttachement((String) mc.getAttachments().get(i));
            			content.addBodyPart(atts[i]);
            		}
            	}         
	        }		
	        			
			//Authenticator sets user,password
			AuthentiMail authenti = new AuthentiMail(myacc.username,myacc.password);
		
			//Get systemproperties (such as CLASSPATH for instance)
			Properties props = System.getProperties();
		
			//Add accounts properties to systemproperties and save in props 
			myacc.addProperties(props);
			System.out.println(props.getProperty("mail.smtp.host"));
			System.out.println(props.getProperty("mail.user"));
			System.out.println(props.getProperty("Password"));
			System.out.println(props.getProperty("mail.store.protocol"));
			System.out.println(props.getProperty("mail.transport.protocol"));
		
        	//Creating new Session-object
			Session session = Session.getInstance(props,authenti);
		
			//Creating new Message-object
			msg = new MimeMessage(session);
		
			//Set author (or at least submitter)
			javax.mail.Address from = new InternetAddress(myacc.username); 
			msg.setFrom(from);
		
			//Set recipients 
			
			for (int i=0;i<toadds.length;i++)
			{
				System.out.println("5");
				msg.addRecipient(Message.RecipientType.TO,toadds[i]);
				System.out.println("6");
				System.out.println(msg.getRecipients(Message.RecipientType.TO).toString());
			}
			if (!mc.getCcAddresses().isEmpty())
			{
				for (int i=0;i<ccadds.length;i++)
				{
					msg.addRecipient(Message.RecipientType.CC,ccadds[i]);
				}
			}
			if (!mc.getBccAddresses().isEmpty())
			{
				for (int i=0;i<bccadds.length;i++)
				{
					msg.addRecipient(Message.RecipientType.BCC,bccadds[i]);
				}
			}
		        System.out.println("7");
			
                        //Set subject
			msg.setSubject(mc.getSubject());
	        	System.out.println("8");

			//Set message-content
			msg.setContent(content);
 
        		

	        System.out.println(toadds.toString());

		        //System.out.println(session.getTransport("mail.inf.fu-berlin.de").toString());	
			System.out.println("juhu"+ myacc.smtpHost);
			msg.saveChanges(); // implicit with send()
			System.out.println("11");
            System.out.println("13");
            //System.out.println("10");	
        }
		//Exceptionhandling for mailer-deamons
		//catch(NullPointerException nulp)
		//{
		//	System.out.println("Some field has not been initialized");
		//}
		catch(MessagingException mex)
		{
			System.out.println("MessagingException in SendMail");
            System.out.println(mex.getMessage());
        }
		catch(FileNotFoundException fex)
		{
			System.out.println("Path without File");
		}
		try {
			return new smail.localStore.LocalMessage(msg);
		}
		catch(Exception e)
		{
			return null;
		}
	}
 */
        /**
	 *This is the counterpart of the convert() method and takes a a Message-object and converts 
	 *to a MessageContent-object and returns the result
	 NOTE: is in work (it was get lost by a disk-crash)
	 */
	public static smail.gui.MessageContent reConvert(javax.mail.internet.MimeMessage msg) throws javax.mail.MessagingException
	{
                
                //initialises variables needed to create a new MessageContent-Object
                String sFrom            = "";
                String sDate            = "";
                java.util.Vector vTOAddresses     = new java.util.Vector();     
                java.util.Vector vCCAddresses     = new java.util.Vector();     
                java.util.Vector vBCCAddresses    = new java.util.Vector();     
                String sSubject         = "";
                String sHeader          = "";
                String sText            = "";
                java.util.Vector vAttachments     = new java.util.Vector();     
                boolean  bCCAddresses   = false;
                boolean  bBCCAddresses  = false;
                boolean  bAttachments   = false;
                
                //TODO : reconvert a message-objekt to a Message Content-object
                
                try
                {   
                    // sets From, Subject and received date
                    sFrom           = msg.getFrom()[0].toString();
                    sSubject        = msg.getSubject();
//                    sDate           = msg.getReceivedDate().toString();
                    
                    // tempporary Array of Addresses
                    javax.mail.Address[] tempArray;
                    
                    // sets ToAddresses
                    tempArray = msg.getRecipients(javax.mail.Message.RecipientType.TO);
                    if (tempArray != null && tempArray.length != 0)
                        for (int i=0; i<tempArray.length; i++)
                            vTOAddresses.add(tempArray[i].toString());
                    
                    // sets vCCAddresses
                    tempArray = msg.getRecipients(javax.mail.Message.RecipientType.CC);
                    if (tempArray != null && tempArray.length != 0)
                    {
                        bCCAddresses = true;
                        for (int i=0; i<tempArray.length; i++)
                            vCCAddresses.add(tempArray[i].toString());
                    }
                    
                    // sets vBccAddresses
                    tempArray = msg.getRecipients(javax.mail.Message.RecipientType.BCC);
                    if (tempArray != null &&  tempArray.length != 0)
                    {
                        bBCCAddresses = true;
                        for (int i=0; i<tempArray.length; i++)
                            vBCCAddresses.add(tempArray[i].toString());
                    }
                
                    java.util.Enumeration enum = msg.getAllHeaderLines();
					while (enum.hasMoreElements())
					{
						sHeader.concat(enum.nextElement().toString());
						sHeader.concat(" ");
					}
                    
                    // gets the Text and optional Attachments
                    Object obj = msg.getContent();
                    System.out.println("Standard Daten der E-Mail erhalten");
                     
                     /** Das mu in mehrere Methoden aufgeteilt werden z.B.
                     editText(MessageContent,Bodypart)
                     editAttachement(MessageContent,Bodypart)
                     editMultipart(MessageContent,Bodypart)
                     Dabei wir ein MessageContent am anfang erzeugt und bei jedem aufruf an die Methoden mitgegeben.
                     Diese tragen dann text in das Objekt ein, oder fgen eine Attachement hinzu.
                     Das ist besonders fr Multipart verschachtelungen wichtig
                     */
		     
		    smail.gui.MessageContent messageContent = new smail.gui.MessageContent (sFrom, sDate, vTOAddresses, vCCAddresses, vBCCAddresses,
                                                    sSubject, sHeader, "", new java.util.Vector(), bCCAddresses, bBCCAddresses, false);	
                    if (msg.isMimeType("text/*"))
                    {
                    	editText((String)msg.getContent(),messageContent);
                    }
		    else if(msg.isMimeType("multipart/alternative"))
		    {
			editAlternative((javax.mail.internet.MimeMultipart)msg.getContent(),messageContent);
		    }
		    
                    else if (msg.isMimeType("multipart/*"))// instanceof javax.mail.internet.MimeMultipart)
                    {
                    	editMultipart((javax.mail.internet.MimeMultipart)msg.getContent(),messageContent);
                    }
	            else
                    {
                    	throw new javax.mail.MessagingException("Message without MessageText");
                    }	
	            return messageContent;
                }
                catch (javax.mail.MessagingException e)
                {
                    System.out.println("MessagingException in ReConverter");
                }
                catch (java.io.IOException e)
                {
                    System.out.println("IOException in ReConverter");
                }
             
                return new smail.gui.MessageContent ("", "", new java.util.Vector(), new java.util.Vector(), new java.util.Vector(),
                                                    "Internal Error occured in Converter", "", "", new java.util.Vector(), false, false, false);
	}
        

       public static void editText(String mPart, smail.gui.MessageContent mContent)
       {
       		mContent.setText(mContent.getText()+"\n"+mPart);
       }

       public static void editMultipart(javax.mail.internet.MimeMultipart mPart, smail.gui.MessageContent mContent)
       {
      		try {
	               while (mPart.getCount() != 0)
        	       {
                	       javax.mail.BodyPart bp = mPart.getBodyPart(0);
                	       String disp =bp.getDisposition();
			       if(disp == null)
			       		disp="";
                	       
			       if(bp.isMimeType("multipart/alternative"))
			       {
					editAlternative((javax.mail.internet.MimeMultipart)bp.getContent(),mContent);
			       }
			       else if(bp.isMimeType("text/*") && !disp.equalsIgnoreCase(javax.mail.Part.ATTACHMENT))
                	       {
					 editText((String)bp.getContent(),mContent);
                	       }
                	       else
                	       {	
			       		editAttachment(bp,mContent);	
                	       }
		               mPart.removeBodyPart(0);
			}
		}
		catch(ClassCastException cce)
		{
			System.out.println("CONVERTER ERROR :Contenttype of Text does not result in String Object ("+cce.getMessage()+")");
		}	       
		catch(javax.mail.MessagingException me)
		{
			System.out.println("CONVERTER ERROR :Messaging Exception in edit Multipart ("+me.getMessage()+")");
		}
		catch(Exception e)
		{
			System.out.println("CONVERTER ERROR :Exception("+e.getMessage()+")\n\n");
			e.printStackTrace();
		}
	}


	public static void editAlternative(javax.mail.internet.MimeMultipart mMp,smail.gui.MessageContent mContent)
	{
		try {
               		System.out.println("Wir haben ein Alternative Multipart");
			if(mMp.getCount()!=2)
			{
				System.out.println("CONVERTER ERROR :Illegal Alternative Multipart there are "+mMp.getCount()+" Parts not 2");
			}
			else
			{
				 javax.mail.BodyPart bp0 = mMp.getBodyPart(0);
				 javax.mail.BodyPart bp1 = mMp.getBodyPart(1);
				 if(bp0.isMimeType("text/html"))
				 {
					 editText((String)bp0.getContent(),mContent);
					 System.out.println("Add Text (HTML)");
				 }	
				 else if(bp1.isMimeType("text/html"))
				 {
					 editText((String)bp1.getContent(),mContent);
					 System.out.println("Add Text (HTML)");
				 }	
				 else if(bp0.isMimeType("text/plain"))
				 {
					 editText((String)bp0.getContent(),mContent);
					 System.out.println("Add Text (PLAIN)");
				 }	
				 else if(bp1.isMimeType("text/plain"))
				 {
					 editText((String)bp1.getContent(),mContent);
					 System.out.println("Add Text (PLAIN)");
				 }	
				 else System.out.println("CONVERTER ERROR :Illegal Alternative Multipart no HTML or Plain Text Fields found");
			}		       
		}
		catch(Exception e)	
		{
			System.out.println("CONVERTER ERROR :Exception in editAlternative ("+e.getMessage()+")");
		}	
	}
	
       public static void editAttachment(javax.mail.BodyPart bPart, smail.gui.MessageContent mContent)
       {
       		try {
		      	mContent.addAttachment(bPart);
			mContent.setAttachmentsBoolean(true);
        		System.out.println("Attachment hinzugefgt: "+bPart.getContentType()+" Java Type: "+bPart.getContent().getClass());
		}
		catch(javax.mail.MessagingException me)
		{
			System.out.println("CONVERTER ERROR :Messaging Exception in editAttachment ("+me.getMessage()+")");
		}
		catch(java.io.IOException ioe)
		{
			System.out.println("CONVERTER ERROR :IO Exception in editAttachment ("+ioe.getMessage()+")");
		}
       }	
}
