package smail.utils ;

/**
 *This class is intended for use as a Logging mechanism.
 *When first instantiated it get passed an OutputStream
 *to write log-messages to. If there is no OutputStream passed
 *System.out is used as the standard target to log to.
 *
 *Suggestion :
 *<ul>
 *<li>short description of the problem</li>
 *<li>::</li>
 *<li>Classname</li>
 *<li>Methodname</li>
 *</ul>
 *for example : "random runtime-error in environment :: Windows.rundll32.exe"
 *This is just a suggestion for better understanding what and where an 
 *error occured
 */
public class Logger
{
	
	private java.io.PrintStream pOut;

	/**
	 *This Construcotr assumes System.out as the wanted PrintStream-target
	 * and log-messages will be written there.
	 */
	public Logger()
	{
		pOut = System.out ;
	}
	
	/**
	 *This constructor gets passed an OutputStream where the loggs should go to
	 *and encapsulates this stream in a PrintStream (automated flushing enabled)
	 */
	public Logger(java.io.OutputStream out)
	{
		this.pOut = new java.io.PrintStream(out,true) ;
	}
	
	/**
	 *This Constructor can be used if a PrintStream already exists. Because
	 *if there is already a Printstream there is no reason to pass an 
	 *OutputStream.
	 */
	public Logger(java.io.PrintStream pOut)
	{
		this.pOut = pOut ;
	}
	
	/**
	 *This one is the main used method. It prints the passsed String to the 
	 *OutputStream (encapsulated by a PrintStream) defined on initialization.
	 */
	public void log(String str)
	{
		pOut.print(str) ;
	}
}
	
